/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || !nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!nonimmediate_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !nonimmediate_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern15 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4SImode:
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[1], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern21 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return pattern20 (x1); /* [-1, 1] */
}

int
pattern27 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern32 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !const_0_to_255_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern35 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V16HImode:
          if (!register_operand (operands[0], E_V16HImode)
              || GET_MODE (x3) != E_V16HImode
              || !nonimmediate_operand (operands[1], E_V16QImode))
            return -1;
          return 0;

        case E_V32HImode:
          if (!register_operand (operands[0], E_V32HImode)
              || GET_MODE (x3) != E_V32HImode
              || !nonimmediate_operand (operands[1], E_V32QImode))
            return -1;
          return 1;

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !memory_operand (operands[1], E_V8QImode))
            return -1;
          return 2;

        case E_V16SImode:
          if (!register_operand (operands[0], E_V16SImode)
              || GET_MODE (x3) != E_V16SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V16QImode:
              if (!nonimmediate_operand (operands[1], E_V16QImode))
                return -1;
              return 3;

            case E_V16HImode:
              if (!nonimmediate_operand (operands[1], E_V16HImode))
                return -1;
              return 4;

            default:
              return -1;
            }

        case E_V8SImode:
          if (!register_operand (operands[0], E_V8SImode)
              || GET_MODE (x3) != E_V8SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8QImode:
              if (!memory_operand (operands[1], E_V8QImode))
                return -1;
              return 5;

            case E_V8HImode:
              if (!nonimmediate_operand (operands[1], E_V8HImode))
                return -1;
              return 6;

            default:
              return -1;
            }

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4QImode:
              if (!memory_operand (operands[1], E_V4QImode))
                return -1;
              return 7;

            case E_V4HImode:
              if (!memory_operand (operands[1], E_V4HImode))
                return -1;
              return 8;

            default:
              return -1;
            }

        case E_V8DImode:
          if (!register_operand (operands[0], E_V8DImode)
              || GET_MODE (x3) != E_V8DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8QImode:
              if (!memory_operand (operands[1], E_V8QImode))
                return -1;
              return 9;

            case E_V8HImode:
              if (!nonimmediate_operand (operands[1], E_V8HImode))
                return -1;
              return 10;

            case E_V8SImode:
              if (!nonimmediate_operand (operands[1], E_V8SImode))
                return -1;
              return 11;

            default:
              return -1;
            }

        case E_V4DImode:
          if (!register_operand (operands[0], E_V4DImode)
              || GET_MODE (x3) != E_V4DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4QImode:
              if (!memory_operand (operands[1], E_V4QImode))
                return -1;
              return 12;

            case E_V4HImode:
              if (!memory_operand (operands[1], E_V4HImode))
                return -1;
              return 13;

            case E_V4SImode:
              if (!nonimmediate_operand (operands[1], E_V4SImode))
                return -1;
              return 14;

            default:
              return -1;
            }

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V2QImode:
              if (!memory_operand (operands[1], E_V2QImode))
                return -1;
              return 15;

            case E_V2HImode:
              if (!memory_operand (operands[1], E_V2HImode))
                return -1;
              return 16;

            case E_V2SImode:
              if (!memory_operand (operands[1], E_V2SImode))
                return -1;
              return 17;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL)
        return -1;
      return 18;

    default:
      return -1;
    }
}

int
pattern80 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern85 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  x7 = XEXP (x2, 1);
  operands[1] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return 0;

    case E_HImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern94 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], E_V2DImode))
    return -1;
  return 0;
}

int
pattern99 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != ASHIFT
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != ZERO_EXTEND
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_CODE (x5) != ZERO_EXTEND
      || GET_MODE (x5) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  return pattern98 (x1); /* [-1, 1] */
}

int
pattern106 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern105 (x1, 
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern105 (x1, 
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern116 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!nonimmediate_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    case E_V2DFmode:
      if (!nonimmediate_operand (operands[1], E_V2DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern127 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  x3 = XEXP (x1, 2);
  operands[3] = x3;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          return 0;

        case E_V16HImode:
          return 1;

        case E_V32HImode:
          return 2;

        case E_V8SImode:
          return 3;

        case E_V16SImode:
          return 4;

        case E_V8DImode:
          return 5;

        case E_V4SImode:
          return 6;

        case E_V4DImode:
          return 7;

        case E_V2DImode:
          return 8;

        default:
          return -1;
        }

    case VEC_SELECT:
      x6 = XEXP (x5, 1);
      if (GET_CODE (x6) != PARALLEL)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!register_operand (operands[3], E_QImode))
        return -1;
      switch (XVECLEN (x6, 0))
        {
        case 4:
          x8 = XVECEXP (x6, 0, 0);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x9 = XVECEXP (x6, 0, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x10 = XVECEXP (x6, 0, 2);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x11 = XVECEXP (x6, 0, 3);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
              || GET_MODE (x5) != E_V4HFmode
              || !register_operand (operands[1], E_V8HFmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SImode:
              if (pattern126 (x1, 
E_V4SImode) != 0)
                return -1;
              return 9;

            case E_V4DImode:
              if (pattern126 (x1, 
E_V4DImode) != 0)
                return -1;
              return 10;

            default:
              return -1;
            }

        case 2:
          x8 = XVECEXP (x6, 0, 0);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x9 = XVECEXP (x6, 0, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !register_operand (operands[0], E_V2DImode)
              || GET_MODE (x1) != E_V2DImode
              || GET_MODE (x4) != E_V2DImode
              || !nonimm_or_0_operand (operands[2], E_V2DImode))
            return -1;
          switch (GET_MODE (x5))
            {
            case E_V2HFmode:
              if (!nonimmediate_operand (operands[1], E_V8HFmode))
                return -1;
              return 11;

            case E_V2SFmode:
              if (!nonimmediate_operand (operands[1], E_V4SFmode))
                return -1;
              return 12;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern157 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SFmode:
      return pattern156 (x3, 
E_V16SFmode); /* [-1, 0] */

    case E_V8SFmode:
      if (pattern156 (x3, 
E_V8SFmode) != 0)
        return -1;
      return 1;

    case E_V4SFmode:
      if (pattern156 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern168 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x1) != E_V8HFmode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_V4HFmode:
          if (!const0_operand (operands[2], E_V4HFmode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SImode:
              if (!vector_operand (operands[1], E_V4SImode))
                return -1;
              return 0;

            case E_V4DImode:
              if (!vector_operand (operands[1], E_V4DImode))
                return -1;
              return 1;

            default:
              return -1;
            }

        case E_V2HFmode:
          if (!vector_operand (operands[1], E_V2DImode)
              || !const0_operand (operands[2], E_V6HFmode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_V4SFmode:
      if (pattern167 (x1, 
E_V2SFmode, 
E_V2DImode, 
E_V4SFmode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern182 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL)
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != VEC_SELECT)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != PARALLEL)
    return -1;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  x9 = XEXP (x6, 0);
  operands[2] = x9;
  switch (XVECLEN (x4, 0))
    {
    case 8:
      x10 = XVECEXP (x4, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x11 = XVECEXP (x4, 0, 1);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x12 = XVECEXP (x4, 0, 2);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x13 = XVECEXP (x4, 0, 3);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x14 = XVECEXP (x4, 0, 4);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x15 = XVECEXP (x4, 0, 5);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
        return -1;
      x16 = XVECEXP (x4, 0, 6);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x17 = XVECEXP (x4, 0, 7);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 14]
          || XVECLEN (x7, 0) != 8)
        return -1;
      x18 = XVECEXP (x7, 0, 0);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x19 = XVECEXP (x7, 0, 1);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x20 = XVECEXP (x7, 0, 2);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x21 = XVECEXP (x7, 0, 3);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x22 = XVECEXP (x7, 0, 4);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x23 = XVECEXP (x7, 0, 5);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
        return -1;
      x24 = XVECEXP (x7, 0, 6);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x25 = XVECEXP (x7, 0, 7);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 14]
          || pattern181 (x1, 
E_V16SImode, 
E_V8SImode, 
E_V8DImode) != 0)
        return -1;
      return 0;

    case 4:
      x10 = XVECEXP (x4, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x11 = XVECEXP (x4, 0, 1);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x12 = XVECEXP (x4, 0, 2);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x13 = XVECEXP (x4, 0, 3);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 6]
          || XVECLEN (x7, 0) != 4)
        return -1;
      x18 = XVECEXP (x7, 0, 0);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x19 = XVECEXP (x7, 0, 1);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x20 = XVECEXP (x7, 0, 2);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x21 = XVECEXP (x7, 0, 3);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 6]
          || pattern181 (x1, 
E_V8SImode, 
E_V4SImode, 
E_V4DImode) != 0)
        return -1;
      return 1;

    case 2:
      x10 = XVECEXP (x4, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x11 = XVECEXP (x4, 0, 1);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 2]
          || XVECLEN (x7, 0) != 2)
        return -1;
      x18 = XVECEXP (x7, 0, 0);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x19 = XVECEXP (x7, 0, 1);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 2]
          || !register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || GET_MODE (x2) != E_V2DImode
          || GET_MODE (x3) != E_V2SImode
          || !vector_operand (operands[1], E_V4SImode)
          || GET_MODE (x5) != E_V2DImode
          || GET_MODE (x6) != E_V2SImode
          || !vector_operand (operands[2], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern211 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  return pattern210 (x1); /* [-1, 0] */
}

int
pattern220 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], i1))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], i1))
    return -1;
  x8 = XEXP (x3, 1);
  operands[2] = x8;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern234 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern241 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      return pattern2 (x3); /* [-1, 1] */

    case STRICT_LOW_PART:
      res = pattern237 (x1, pnum_clobbers);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern249 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[3] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern248 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern248 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern258 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !register_operand (operands[0], E_SImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!nonimmediate_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern264 (rtx x1, int i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != VEC_SELECT
      || GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 2)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern273 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_all_ones_operand (operands[1], i1)
      || !const0_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !nonimmediate_operand (operands[3], i1)
      || !nonimmediate_operand (operands[4], i1)
      || !const_0_to_7_operand (operands[5], E_SImode))
    return -1;
  return 0;
}

int
pattern281 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !nonimmediate_operand (operands[1], E_V16HFmode))
        return -1;
      return 0;

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x1) != E_V32QImode
          || !nonimmediate_operand (operands[1], E_V32HFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern285 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != VEC_SELECT)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 1)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x3, 1);
  if (GET_CODE (x7) != VEC_SELECT)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != PARALLEL
      || XVECLEN (x8, 0) != 1)
    return -1;
  x9 = XVECEXP (x8, 0, 0);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x10 = XEXP (x2, 1);
  if (GET_CODE (x10) != i1)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != VEC_SELECT)
    return -1;
  x12 = XEXP (x11, 1);
  if (GET_CODE (x12) != PARALLEL
      || XVECLEN (x12, 0) != 1)
    return -1;
  x13 = XVECEXP (x12, 0, 0);
  if (GET_CODE (x13) != CONST_INT)
    return -1;
  x14 = XEXP (x10, 1);
  if (GET_CODE (x14) != VEC_SELECT)
    return -1;
  x15 = XEXP (x14, 1);
  if (GET_CODE (x15) != PARALLEL
      || XVECLEN (x15, 0) != 1)
    return -1;
  x16 = XVECEXP (x15, 0, 0);
  if (GET_CODE (x16) != CONST_INT)
    return -1;
  x17 = XEXP (x1, 1);
  if (GET_CODE (x17) != VEC_CONCAT)
    return -1;
  x18 = XEXP (x17, 0);
  if (GET_CODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_CODE (x19) != VEC_SELECT)
    return -1;
  x20 = XEXP (x19, 1);
  if (GET_CODE (x20) != PARALLEL
      || XVECLEN (x20, 0) != 1)
    return -1;
  x21 = XVECEXP (x20, 0, 0);
  if (GET_CODE (x21) != CONST_INT)
    return -1;
  x22 = XEXP (x18, 1);
  if (GET_CODE (x22) != VEC_SELECT)
    return -1;
  x23 = XEXP (x22, 1);
  if (GET_CODE (x23) != PARALLEL
      || XVECLEN (x23, 0) != 1)
    return -1;
  x24 = XVECEXP (x23, 0, 0);
  if (GET_CODE (x24) != CONST_INT)
    return -1;
  x25 = XEXP (x17, 1);
  if (GET_CODE (x25) != i1)
    return -1;
  x26 = XEXP (x25, 0);
  if (GET_CODE (x26) != VEC_SELECT)
    return -1;
  x27 = XEXP (x26, 1);
  if (GET_CODE (x27) != PARALLEL
      || XVECLEN (x27, 0) != 1)
    return -1;
  x28 = XVECEXP (x27, 0, 0);
  if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x29 = XEXP (x25, 1);
  if (GET_CODE (x29) != VEC_SELECT)
    return -1;
  x30 = XEXP (x29, 1);
  if (GET_CODE (x30) != PARALLEL
      || XVECLEN (x30, 0) != 1)
    return -1;
  x31 = XVECEXP (x30, 0, 0);
  if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x32 = XEXP (x4, 0);
  operands[1] = x32;
  x33 = XEXP (x7, 0);
  if (!rtx_equal_p (x33, operands[1]))
    return -1;
  switch (XWINT (x13, 0))
    {
    case 0LL:
      if (XWINT (x16, 0) != 1LL
          || XWINT (x21, 0) != 2LL
          || XWINT (x24, 0) != 3LL
          || !register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x1) != E_V4DFmode
          || GET_MODE (x2) != E_V2DFmode
          || GET_MODE (x3) != E_DFmode
          || GET_MODE (x4) != E_DFmode
          || !register_operand (operands[1], E_V4DFmode)
          || GET_MODE (x7) != E_DFmode
          || GET_MODE (x10) != E_DFmode
          || GET_MODE (x11) != E_DFmode)
        return -1;
      x34 = XEXP (x11, 0);
      operands[2] = x34;
      if (!nonimmediate_operand (operands[2], E_V4DFmode)
          || GET_MODE (x14) != E_DFmode
          || GET_MODE (x17) != E_V2DFmode
          || GET_MODE (x18) != E_DFmode
          || GET_MODE (x19) != E_DFmode
          || GET_MODE (x22) != E_DFmode
          || GET_MODE (x25) != E_DFmode
          || GET_MODE (x26) != E_DFmode
          || GET_MODE (x29) != E_DFmode)
        return -1;
      x35 = XEXP (x14, 0);
      if (!rtx_equal_p (x35, operands[2]))
        return -1;
      x36 = XEXP (x19, 0);
      if (!rtx_equal_p (x36, operands[1]))
        return -1;
      x37 = XEXP (x22, 0);
      if (!rtx_equal_p (x37, operands[1]))
        return -1;
      x38 = XEXP (x26, 0);
      if (!rtx_equal_p (x38, operands[2]))
        return -1;
      x39 = XEXP (x29, 0);
      if (!rtx_equal_p (x39, operands[2]))
        return -1;
      return 0;

    case 2LL:
      if (XWINT (x16, 0) != 3LL
          || XWINT (x21, 0) != 0LL
          || XWINT (x24, 0) != 1LL
          || !register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || GET_MODE (x2) != E_V2SFmode
          || GET_MODE (x3) != E_SFmode
          || GET_MODE (x4) != E_SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || GET_MODE (x7) != E_SFmode
          || GET_MODE (x10) != E_SFmode
          || GET_MODE (x11) != E_SFmode
          || GET_MODE (x14) != E_SFmode
          || GET_MODE (x17) != E_V2SFmode
          || GET_MODE (x18) != E_SFmode
          || GET_MODE (x19) != E_SFmode)
        return -1;
      x36 = XEXP (x19, 0);
      operands[2] = x36;
      if (!vector_operand (operands[2], E_V4SFmode)
          || GET_MODE (x22) != E_SFmode
          || GET_MODE (x25) != E_SFmode
          || GET_MODE (x26) != E_SFmode
          || GET_MODE (x29) != E_SFmode)
        return -1;
      x34 = XEXP (x11, 0);
      if (!rtx_equal_p (x34, operands[1]))
        return -1;
      x35 = XEXP (x14, 0);
      if (!rtx_equal_p (x35, operands[1]))
        return -1;
      x37 = XEXP (x22, 0);
      if (!rtx_equal_p (x37, operands[2]))
        return -1;
      x38 = XEXP (x26, 0);
      if (!rtx_equal_p (x38, operands[2]))
        return -1;
      x39 = XEXP (x29, 0);
      if (!rtx_equal_p (x39, operands[2]))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern333 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != ZERO_EXTEND
      || GET_MODE (x3) != E_DImode
      || pattern38 (x1) != 0)
    return -1;
  return 0;
}

int
pattern338 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      return 0;

    case SIGN_EXTEND:
      res = pattern337 (x1);
      if (res >= 0)
        return res + 1; /* [1, 3] */
      return -1;

    case ZERO_EXTEND:
      res = pattern337 (x1);
      if (res >= 0)
        return res + 4; /* [4, 6] */
      return -1;

    default:
      return -1;
    }
}

int
pattern348 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PARALLEL
      || XVECLEN (x2, 0) != 1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern352 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  operands[4] = x1;
  if (!general_gr_operand (operands[4], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x2) != PARALLEL
      || XVECLEN (x2, 0) != 3)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 1
      || XINT (x4, 1) != 92)
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 17
      || GET_MODE (x8) != E_CCmode)
    return -1;
  x9 = XEXP (x3, 0);
  operands[0] = x9;
  x10 = XVECEXP (x4, 0, 0);
  operands[1] = x10;
  x11 = XEXP (x5, 0);
  operands[2] = x11;
  if (!general_reg_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!memory_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode
          || !memory_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!memory_operand (operands[0], E_DImode)
          || GET_MODE (x4) != E_DImode
          || !memory_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern377 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[2] = x6;
  if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern376 (x2, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern376 (x2, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern392 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (maybe_ne (SUBREG_BYTE (x2), 0)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case AND:
      return pattern389 (x1); /* [-1, 1] */

    case PLUS:
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
        return -1;
      res = pattern388 (x1);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case MINUS:
      x4 = XEXP (x3, 0);
      operands[3] = x4;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
        return -1;
      res = pattern19 (x1);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern407 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern411 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[3] = x5;
  x6 = XEXP (x1, 1);
  switch (GET_CODE (x6))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[4] = x6;
      x7 = XEXP (x1, 2);
      if (GET_CODE (x7) != UNSPEC
          || XVECLEN (x7, 0) != 1
          || XINT (x7, 1) != 223)
        return -1;
      x8 = XVECEXP (x7, 0, 0);
      operands[5] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          if (!register_operand (operands[0], E_V32HFmode)
              || GET_MODE (x1) != E_V32HFmode
              || GET_MODE (x2) != E_V32HFmode
              || !vector_operand (operands[1], E_V32HFmode)
              || !vector_operand (operands[2], E_V32HFmode)
              || !vector_operand (operands[3], E_V32HFmode)
              || !const0_operand (operands[4], E_V32HFmode)
              || GET_MODE (x7) != E_SImode
              || !register_operand (operands[5], E_HImode))
            return -1;
          return 0;

        case E_V16HFmode:
          if (pattern409 (x1, 
E_HImode, 
E_V16HFmode) != 0)
            return -1;
          return 1;

        case E_V8HFmode:
          if (pattern409 (x1, 
E_QImode, 
E_V8HFmode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      x7 = XEXP (x1, 2);
      switch (GET_CODE (x7))
        {
        case UNSPEC:
          if (XVECLEN (x7, 0) != 1
              || XINT (x7, 1) != 223)
            return -1;
          x8 = XVECEXP (x7, 0, 0);
          operands[4] = x8;
          if (!rtx_equal_p (x6, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              if (!register_operand (operands[0], E_V32HFmode)
                  || GET_MODE (x1) != E_V32HFmode
                  || GET_MODE (x2) != E_V32HFmode
                  || !vector_operand (operands[1], E_V32HFmode)
                  || !vector_operand (operands[2], E_V32HFmode)
                  || !vector_operand (operands[3], E_V32HFmode)
                  || GET_MODE (x7) != E_SImode
                  || !register_operand (operands[4], E_HImode))
                return -1;
              return 3;

            case E_V16HFmode:
              if (pattern410 (x1, 
E_HImode, 
E_V16HFmode) != 0)
                return -1;
              return 4;

            case E_V8HFmode:
              if (pattern410 (x1, 
E_QImode, 
E_V8HFmode) != 0)
                return -1;
              return 5;

            default:
              return -1;
            }

        case CONST_INT:
          if (XWINT (x7, 0) != 3LL
              || !register_operand (operands[0], E_V8HFmode)
              || GET_MODE (x1) != E_V8HFmode
              || GET_MODE (x2) != E_V8HFmode
              || !vector_operand (operands[1], E_V8HFmode)
              || !vector_operand (operands[2], E_V8HFmode)
              || !vector_operand (operands[3], E_V8HFmode)
              || !rtx_equal_p (x6, operands[2]))
            return -1;
          return 6;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern445 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2
      || !nonimm_or_0_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4SImode:
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[1], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern454 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !bcst_vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern457 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8SImode:
      if (!nonimmediate_operand (operands[1], E_V8SImode))
        return -1;
      return 0;

    case E_V8DImode:
      if (!nonimmediate_operand (operands[1], E_V8DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern462 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2DImode)
      || GET_MODE (x1) != E_V2DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2HFmode:
      if (!memory_operand (operands[1], E_V2HFmode))
        return -1;
      return 0;

    case E_V2DFmode:
      if (!vector_operand (operands[1], E_V2DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern467 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !permvar_truncate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern473 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !regmem_or_bitnot_regmem_operand (operands[1], i1)
      || !regmem_or_bitnot_regmem_operand (operands[2], i1)
      || !regmem_or_bitnot_regmem_operand (operands[3], i1)
      || !regmem_or_bitnot_regmem_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern478 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode)
        return -1;
      return 0;

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode)
        return -1;
      return 1;

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern480 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 8:
      x4 = XVECEXP (x3, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x7 = XVECEXP (x3, 0, 3);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x8 = XVECEXP (x3, 0, 4);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x9 = XVECEXP (x3, 0, 5);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x10 = XVECEXP (x3, 0, 6);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x11 = XVECEXP (x3, 0, 7);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
          || GET_MODE (x2) != E_V8QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return pattern478 (x1); /* [-1, 2] */

    case 4:
      x4 = XVECEXP (x3, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x7 = XVECEXP (x3, 0, 3);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          res = pattern479 (x1, 
E_V4SImode);
          if (res >= 0)
            return res + 3; /* [3, 4] */
          return -1;

        case E_V4DImode:
          res = pattern479 (x1, 
E_V4DImode);
          if (res >= 0)
            return res + 5; /* [5, 6] */
          return -1;

        default:
          return -1;
        }

    case 2:
      x4 = XVECEXP (x3, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_V2QImode:
          if (!register_operand (operands[1], E_V16QImode))
            return -1;
          return 7;

        case E_V2HImode:
          if (!register_operand (operands[1], E_V8HImode))
            return -1;
          return 8;

        case E_V2SImode:
          if (!register_operand (operands[1], E_V4SImode))
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern507 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern510 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern514 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern517 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern522 (machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[3], i2)
      || !nonimmediate_operand (operands[4], i1)
      || !scratch_operand (operands[1], i1)
      || !scratch_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern524 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode)
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode)
        return -1;
      return 1;

    case E_XFmode:
      if (!register_operand (operands[0], E_XFmode)
          || GET_MODE (x1) != E_XFmode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern528 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern534 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  return pattern391 (x2); /* [-1, 0] */
}

int
pattern539 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!int248_register_operand (operands[0], E_VOIDmode))
    return -1;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_HImode:
      if (!extract_operator (operands[3], E_HImode)
          || GET_MODE (x2) != E_HImode
          || GET_MODE (x4) != E_HImode)
        return -1;
      return 0;

    case E_SImode:
      if (!extract_operator (operands[3], E_SImode)
          || GET_MODE (x2) != E_SImode
          || GET_MODE (x4) != E_SImode)
        return -1;
      return 1;

    case E_DImode:
      if (!extract_operator (operands[3], E_DImode)
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x4) != E_DImode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern547 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !nonimmediate_operand (operands[1], i2)
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern553 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SUBREG
      || maybe_ne (SUBREG_BYTE (x1), 0)
      || GET_MODE (x1) != E_QImode)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      return 0;

    default:
      return -1;
    }
}

int
pattern558 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern560 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern566 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], i2))
    return -1;
  return 0;
}

int
pattern574 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 2);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      return pattern572 (x1, 
E_V16SImode, 
E_HImode, 
E_V16SFmode); /* [-1, 0] */

    case E_V8SImode:
      if (pattern572 (x1, 
E_V8SImode, 
E_QImode, 
E_V8SFmode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern572 (x1, 
E_V4SImode, 
E_QImode, 
E_V4SFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern580 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V8SImode)
      || GET_MODE (x1) != E_V8SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!vector_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V8SFmode:
      if (!vector_operand (operands[1], E_V8SFmode))
        return -1;
      return 1;

    case E_V8DFmode:
      if (!vector_operand (operands[1], E_V8DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern584 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2DImode)
      || GET_MODE (x1) != E_V2DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!nonimmediate_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V2DFmode:
      if (!vector_operand (operands[1], E_V2DFmode))
        return -1;
      return 1;

    case E_V4SFmode:
      if (!nonimmediate_operand (operands[1], E_V4SFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern592 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V8DFmode:
      if (!register_operand (operands[1], E_V8DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern598 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern603 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !vector_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !vector_all_ones_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern608 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V2SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != CONST_VECTOR
      || XVECLEN (x3, 0) != 2
      || GET_MODE (x3) != E_V2SImode)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || !register_operand (operands[0], E_V4SImode)
      || GET_MODE (x1) != E_V4SImode
      || !nonimmediate_operand (operands[1], E_V2DFmode))
    return -1;
  return 0;
}

int
pattern619 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_V2DImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  if (!memory_operand (operands[1], E_DImode))
    return -1;
  x7 = XEXP (x2, 1);
  switch (XVECLEN (x7, 0))
    {
    case 8:
      x8 = XVECEXP (x7, 0, 0);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XVECEXP (x7, 0, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x10 = XVECEXP (x7, 0, 2);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x11 = XVECEXP (x7, 0, 3);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x12 = XVECEXP (x7, 0, 4);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x13 = XVECEXP (x7, 0, 5);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x14 = XVECEXP (x7, 0, 6);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x15 = XVECEXP (x7, 0, 7);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
          || GET_MODE (x2) != E_V8QImode
          || GET_MODE (x3) != E_V16QImode)
        return -1;
      return pattern478 (x1); /* [-1, 2] */

    case 4:
      res = pattern617 (x1, 
E_V8HImode, 
E_V4HImode);
      if (res >= 0)
        return res + 3; /* [3, 4] */
      return -1;

    case 2:
      if (pattern618 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern642 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      return 0;

    case STRICT_LOW_PART:
      return 1;

    default:
      return -1;
    }
}

int
pattern648 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case UNSPEC:
      if (XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 37)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 0;

    case SET:
      x3 = XEXP (x1, 1);
      if (GET_CODE (x3) != PLUS
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 7
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x1, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 7
          || GET_MODE (x5) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern660 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != SIGN_EXTEND)
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != SIGN_EXTEND)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i1)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 17
      || GET_MODE (x8) != E_CCOmode)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x9) != SET)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != i1
      || GET_MODE (x3) != E_CCOmode)
    return -1;
  x11 = XEXP (x5, 0);
  operands[1] = x11;
  x12 = XEXP (x9, 0);
  operands[0] = x12;
  x13 = XEXP (x7, 0);
  if (!rtx_equal_p (x13, operands[1]))
    return -1;
  x14 = XEXP (x10, 0);
  if (!rtx_equal_p (x14, operands[1]))
    return -1;
  x15 = XEXP (x4, 1);
  switch (GET_CODE (x15))
    {
    case SIGN_EXTEND:
      x16 = XEXP (x15, 0);
      operands[2] = x16;
      x17 = XEXP (x7, 1);
      if (!rtx_equal_p (x17, operands[2]))
        return -1;
      x18 = XEXP (x10, 1);
      if (!rtx_equal_p (x18, operands[2]))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_TImode:
          return pattern658 (x1, 
E_DImode, 
E_TImode); /* [-1, 0] */

        case E_POImode:
          if (pattern658 (x1, 
E_TImode, 
E_POImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
      operands[3] = x15;
      x17 = XEXP (x7, 1);
      operands[2] = x17;
      x18 = XEXP (x10, 1);
      if (!rtx_equal_p (x18, operands[2]))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_TImode:
          if (pattern659 (x1, 
E_DImode, 
E_TImode) != 0)
            return -1;
          return 2;

        case E_POImode:
          if (pattern659 (x1, 
E_TImode, 
E_POImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern691 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !ix86_comparison_uns_operator (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern698 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 17)
    return -1;
  x3 = XEXP (x1, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return 0;

    case E_DImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern705 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vector_all_ones_operand (operands[3], i1)
      || !const0_operand (operands[4], i1)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !const0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern712 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != VEC_SELECT)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 1)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  x8 = XVECEXP (x3, 0, 1);
  operands[2] = x8;
  x9 = XEXP (x1, 1);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern711 (x1, 
E_HFmode, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern711 (x1, 
E_SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    case E_V2DFmode:
      if (pattern711 (x1, 
E_DFmode, 
E_V2DFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern725 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !nonimmediate_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern732 (rtx x1, int i1, int i2, int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern751 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !vector_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern760 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case CLOBBER:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != REG
          || REGNO (x2) != 17
          || GET_MODE (x2) != E_CCmode)
        return -1;
      return 0;

    case UNSPEC:
      if (XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 174)
        return -1;
      x3 = XVECEXP (x1, 0, 0);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          return 1;

        case E_HImode:
          return 2;

        case E_SImode:
          return 3;

        case E_DImode:
          return 4;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern765 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern769 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V2BFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      return pattern638 (x5, 
E_V2BFmode); /* [-1, 0] */

    case E_V2HFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern638 (x5, 
E_V2HFmode) != 0)
        return -1;
      return 1;

    case E_V32BFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern637 (x5, 
E_V32BFmode) != 0)
        return -1;
      return 2;

    case E_V16BFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern637 (x5, 
E_V16BFmode) != 0)
        return -1;
      return 3;

    case E_V8BFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern637 (x5, 
E_V8BFmode) != 0)
        return -1;
      return 4;

    case E_V32HFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern637 (x5, 
E_V32HFmode) != 0)
        return -1;
      return 5;

    case E_V16HFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern637 (x5, 
E_V16HFmode) != 0)
        return -1;
      return 6;

    case E_V8HFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern637 (x5, 
E_V8HFmode) != 0)
        return -1;
      return 7;

    case E_V16SFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern637 (x5, 
E_V16SFmode) != 0)
        return -1;
      return 8;

    case E_V8SFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern637 (x5, 
E_V8SFmode) != 0)
        return -1;
      return 9;

    case E_V4SFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern637 (x5, 
E_V4SFmode) != 0)
        return -1;
      return 10;

    case E_V8DFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern637 (x5, 
E_V8DFmode) != 0)
        return -1;
      return 11;

    case E_V4DFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern637 (x5, 
E_V4DFmode) != 0)
        return -1;
      return 12;

    case E_V2DFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern637 (x5, 
E_V2DFmode) != 0)
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern797 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !bcst_vector_operand (operands[1], i1)
      || !bcst_vector_operand (operands[2], i1)
      || !bcst_vector_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern807 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern814 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V8HFmode)
      || GET_MODE (x1) != E_V8HFmode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V8HFmode
      || !nonimm_or_0_operand (operands[2], E_V8HFmode)
      || !register_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      if (!vector_operand (operands[1], E_V8HImode))
        return -1;
      return 0;

    case E_V8SImode:
      if (!vector_operand (operands[1], E_V8SImode))
        return -1;
      return 1;

    case E_V8DImode:
      if (!vector_operand (operands[1], E_V8DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern823 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!const_0_to_3_operand (operands[2], E_VOIDmode))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  operands[3] = x2;
  if (!const_0_to_3_operand (operands[3], E_VOIDmode))
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  operands[4] = x3;
  if (!const_0_to_3_operand (operands[4], E_VOIDmode))
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  operands[5] = x4;
  if (!const_0_to_3_operand (operands[5], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern833 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern838 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !nonimm_or_0_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern843 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V2SImode)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != CONST_VECTOR
      || XVECLEN (x4, 0) != 2
      || GET_MODE (x4) != E_V2SImode)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || !register_operand (operands[0], E_V4SImode)
      || GET_MODE (x1) != E_V4SImode
      || GET_MODE (x2) != E_V2SImode
      || !nonimmediate_operand (operands[1], E_V2DFmode))
    return -1;
  return pattern442 (x2); /* [-1, 1] */
}

int
pattern849 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern854 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x8) != CONST_INT)
    return -1;
  x9 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x10) != CONST_INT)
    return -1;
  x11 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x11) != CONST_INT)
    return -1;
  x12 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x12) != CONST_INT)
    return -1;
  x13 = XVECEXP (x1, 0, 13);
  if (GET_CODE (x13) != CONST_INT)
    return -1;
  x14 = XVECEXP (x1, 0, 14);
  if (GET_CODE (x14) != CONST_INT)
    return -1;
  x15 = XVECEXP (x1, 0, 15);
  if (GET_CODE (x15) != CONST_INT)
    return -1;
  return 0;
}

int
pattern875 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != i1)
        return -1;
      return pattern874 (x1); /* [-1, 3] */

    case CLOBBER:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XVECEXP (x1, 0, 0);
      x6 = XEXP (x5, 1);
      x7 = XEXP (x6, 0);
      switch (GET_MODE (x7))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode)
              || !general_operand (operands[2], E_QImode)
              || !scratch_operand (operands[0], E_QImode))
            return -1;
          return 4;

        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode)
              || !general_operand (operands[2], E_HImode)
              || !scratch_operand (operands[0], E_HImode))
            return -1;
          return 5;

        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !x86_64_general_operand (operands[2], E_SImode)
              || !scratch_operand (operands[0], E_SImode))
            return -1;
          return 6;

        case E_DImode:
          if (!nonimmediate_operand (operands[1], E_DImode)
              || !x86_64_general_operand (operands[2], E_DImode)
              || !scratch_operand (operands[0], E_DImode))
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern891 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern896 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], E_SFmode)
      || GET_MODE (x1) != E_SFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2SFmode:
      if (!nonimmediate_operand (operands[1], E_V2SFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!nonimmediate_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern899 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2SImode)
      || GET_MODE (x1) != E_V2SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V4SImode
      || !register_operand (operands[1], E_V2SImode)
      || !register_mmxmem_operand (operands[2], E_V2SImode))
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  switch (XWINT (x4, 0))
    {
    case 1LL:
      x5 = XVECEXP (x3, 0, 1);
      if (XWINT (x5, 0) != 3LL)
        return -1;
      return 0;

    case 0LL:
      x5 = XVECEXP (x3, 0, 1);
      if (XWINT (x5, 0) != 2LL)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern903 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[3] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_DImode
          || !nonimm_or_0_operand (operands[1], E_V64QImode)
          || !nonimm_or_0_operand (operands[2], E_V64QImode)
          || !register_operand (operands[3], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V32QImode:
          if (!nonimm_or_0_operand (operands[1], E_V32QImode)
              || !nonimm_or_0_operand (operands[2], E_V32QImode))
            return -1;
          return 1;

        case E_V32HImode:
          if (!nonimm_or_0_operand (operands[1], E_V32HImode)
              || !nonimm_or_0_operand (operands[2], E_V32HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern916 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (!register_operand (x3, i1))
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (!register_operand (x4, i1))
    return -1;
  return 0;
}

int
pattern926 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !bcst_vector_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern934 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern941 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !vector_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern947 (rtx x1, machine_mode i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != i2
      || GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern956 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[3] = x4;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x6 = XEXP (x4, 2);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x7 = XEXP (x2, 1);
      if (GET_CODE (x7) != SUBREG
          || maybe_ne (SUBREG_BYTE (x7), 0)
          || GET_MODE (x7) != E_QImode)
        return -1;
      x8 = XEXP (x7, 0);
      switch (GET_CODE (x8))
        {
        case SIGN_EXTRACT:
        case ZERO_EXTRACT:
          operands[4] = x8;
          x9 = XEXP (x8, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x10 = XEXP (x8, 2);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
              || GET_MODE (x2) != E_QImode)
            return -1;
          return pattern955 (x1); /* [-1, 4] */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern970 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern977 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V4QImode:
      if (!register_operand (operands[1], E_V4QImode)
          || !const_0_to_3_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode)
          || !const_0_to_15_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern983 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern992 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  return pattern991 (x2); /* [-1, 11] */
}

int
pattern999 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_V8SFmode:
      if (GET_MODE (x2) != E_V8SImode
          || !register_operand (operands[1], E_V8SImode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (GET_MODE (x2) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 1;

    case E_V4DFmode:
      if (GET_MODE (x2) != E_V4DImode
          || !register_operand (operands[1], E_V4DImode))
        return -1;
      return 2;

    case E_V2DFmode:
      if (GET_MODE (x2) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1008 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern1015 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !nonimmediate_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1023 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i4
      || !register_operand (operands[1], i3))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i4
      || !vector_operand (operands[2], i3)
      || !nonimm_or_0_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1029 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_V8HFmode)
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 223
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x2, 2);
  if (XWINT (x6, 0) != 3LL
      || !register_operand (operands[0], E_V8HFmode)
      || GET_MODE (x1) != E_V8HFmode
      || GET_MODE (x2) != E_V8HFmode
      || GET_MODE (x3) != E_V8HFmode)
    return -1;
  x7 = XVECEXP (x4, 0, 0);
  operands[1] = x7;
  if (!nonimmediate_operand (operands[1], E_V8HFmode))
    return -1;
  x8 = XVECEXP (x4, 0, 1);
  operands[2] = x8;
  if (!register_operand (operands[2], E_V8HFmode))
    return -1;
  x9 = XEXP (x3, 1);
  operands[3] = x9;
  if (!nonimm_or_0_operand (operands[3], E_V8HFmode))
    return -1;
  x10 = XVECEXP (x5, 0, 0);
  operands[4] = x10;
  if (!register_operand (operands[4], E_QImode))
    return -1;
  x11 = XVECEXP (x1, 0, 1);
  operands[5] = x11;
  if (!const_4_or_8_to_11_operand (operands[5], E_SImode))
    return -1;
  x12 = XEXP (x2, 1);
  if (!rtx_equal_p (x12, operands[1]))
    return -1;
  return 0;
}

int
pattern1046 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (XWINT (x2, 0))
    {
    case 0LL:
      x3 = XVECEXP (x1, 0, 1);
      switch (XWINT (x3, 0))
        {
        case 1LL:
          return 0;

        case 2LL:
          return 1;

        default:
          return -1;
        }

    case 1LL:
      x3 = XVECEXP (x1, 0, 1);
      if (XWINT (x3, 0) != 3LL)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (XWINT (x4, 0) != 5LL)
        return -1;
      x5 = XVECEXP (x1, 0, 3);
      if (XWINT (x5, 0) != 7LL)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1056 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != 19
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern1063 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  operands[3] = x5;
  if (!int_nonimmediate_operand (operands[3], E_VOIDmode))
    return -1;
  x6 = XEXP (x2, 1);
  operands[1] = x6;
  x7 = XEXP (x1, 1);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern1061 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern1061 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern1062 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern1062 (x1, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1078 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return pattern1077 (); /* [-1, 2] */
}

int
pattern1084 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1091 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_gr_operand (operands[1], i1)
      || GET_CODE (x1) != UNSPEC
      || XVECLEN (x1, 0) != 2
      || XINT (x1, 1) != 40
      || GET_MODE (x1) != E_CCCmode)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern1095 (rtx x1, machine_mode i1, rtx_code i2, machine_mode i3, rtx_code i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i4
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern1100 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      if (!ix86_carry_flag_unset_operator (operands[2], E_QImode)
          || !nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!ix86_carry_flag_unset_operator (operands[2], E_HImode)
          || !nonimmediate_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1112 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
      x4 = XEXP (x2, 2);
      operands[4] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          return 0;

        case E_V4SFmode:
          return 1;

        case E_V2DFmode:
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[4] = x3;
      x4 = XEXP (x2, 2);
      operands[5] = x4;
      x5 = XEXP (x1, 1);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          return 3;

        case E_V4SFmode:
          return 4;

        case E_V2DFmode:
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1125 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode)
          || !vector_operand (operands[2], E_V16QImode)
          || GET_MODE (x2) != E_V16QImode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_V4SImode:
          if (!register_operand (operands[3], E_V4SImode)
              || !const0_operand (operands[4], E_V4SImode))
            return -1;
          return 0;

        case E_V2DImode:
          if (!register_operand (operands[3], E_V2DImode)
              || !const0_operand (operands[4], E_V2DImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x1) != E_V32QImode
          || !register_operand (operands[1], E_V32QImode)
          || !vector_operand (operands[2], E_V32QImode)
          || GET_MODE (x2) != E_V32QImode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_V8SImode:
          if (!register_operand (operands[3], E_V8SImode)
              || !const0_operand (operands[4], E_V8SImode))
            return -1;
          return 2;

        case E_V4DImode:
          if (!register_operand (operands[3], E_V4DImode)
              || !const0_operand (operands[4], E_V4DImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1141 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !bcst_vector_operand (operands[1], i1)
      || !vector_all_ones_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1145 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SUBREG
      || maybe_ne (SUBREG_BYTE (x4), 0)
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[3] = x5;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x7 = XEXP (x5, 2);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x8 = XEXP (x1, 0);
      if (GET_CODE (x8) != ZERO_EXTRACT)
        return -1;
      x9 = XEXP (x8, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x10 = XEXP (x8, 2);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x11 = XEXP (x8, 0);
      operands[0] = x11;
      if (!int248_register_operand (operands[0], E_VOIDmode))
        return -1;
      x12 = XEXP (x5, 0);
      operands[1] = x12;
      if (!int248_register_operand (operands[1], E_VOIDmode))
        return -1;
      x13 = XEXP (x3, 1);
      operands[2] = x13;
      if (!nonmemory_operand (operands[2], E_QImode))
        return -1;
      return pattern1144 (x1); /* [-1, 2] */

    default:
      return -1;
    }
}

int
pattern1166 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!int248_register_operand (operands[2], E_VOIDmode))
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], E_QImode))
    return -1;
  x4 = XEXP (x1, 0);
  switch (GET_CODE (x4))
    {
    case STRICT_LOW_PART:
      x5 = XEXP (x4, 0);
      operands[0] = x5;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_HImode:
          if (!extract_operator (operands[3], E_HImode))
            return -1;
          return 0;

        case E_SImode:
          if (!extract_operator (operands[3], E_SImode))
            return -1;
          return 1;

        case E_DImode:
          if (!extract_operator (operands[3], E_DImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x4;
      if (!nonimmediate_operand (operands[0], E_QImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_HImode:
          if (!extract_operator (operands[3], E_HImode))
            return -1;
          return 3;

        case E_SImode:
          if (!extract_operator (operands[3], E_SImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1186 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !nonimmediate_operand (operands[1], i2)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1197 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x2, 2);
  return pattern1196 (x3, 
i1, 
i2); /* [-1, 0] */
}

int
pattern1205 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i3)
      || !nonimm_or_0_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1213 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1221 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1225 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], E_QImode)
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern1232 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || pattern510 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1239 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  if (!general_reg_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 0);
  if (!rtx_equal_p (x3, operands[1]))
    return -1;
  x4 = PATTERN (peep2_next_insn (2));
  x5 = XEXP (x4, 1);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  x6 = XEXP (x4, 0);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  return 0;
}

int
pattern1246 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_HImode:
      if (!extract_operator (operands[2], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!extract_operator (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1256 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x8 = XEXP (x5, 1);
  operands[4] = x8;
  if (!const_0_to_63_operand (operands[4], E_QImode))
    return -1;
  return 0;
}

int
pattern1270 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !bcst_vector_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 2);
  return pattern1269 (x3, 
i2, 
i1); /* [-1, 0] */
}

int
pattern1280 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_MODE (x4) != i1
      || !const0_operand (operands[4], i1)
      || !register_operand (operands[5], E_QImode))
    return -1;
  return 0;
}

int
pattern1291 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      x5 = XEXP (x3, 2);
      operands[4] = x5;
      x6 = XVECEXP (x1, 0, 1);
      operands[5] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          return pattern1290 (x1, 
E_V8HFmode); /* [-1, 0] */

        case E_V4SFmode:
          if (pattern1290 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 1;

        case E_V2DFmode:
          if (pattern1290 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[4] = x4;
      x7 = XEXP (x3, 0);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      x10 = XEXP (x7, 1);
      operands[1] = x10;
      x5 = XEXP (x3, 2);
      operands[5] = x5;
      x6 = XVECEXP (x1, 0, 1);
      operands[6] = x6;
      x11 = XEXP (x2, 1);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          return 3;

        case E_V4SFmode:
          return 4;

        case E_V2DFmode:
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1316 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1324 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !addsub_vm_operator (operands[6], i1))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !vector_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1335 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1345 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  x3 = XVECEXP (x2, 0, 0);
  if (maybe_ne (SUBREG_BYTE (x3), 0))
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != NOT)
    return -1;
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!const_0_to_7_operand (operands[5], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern1343 (x1, 
E_V4SImode, 
E_V16QImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern1343 (x1, 
E_V2DImode, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V8SImode:
      if (pattern1343 (x1, 
E_V8SImode, 
E_V32QImode) != 0)
        return -1;
      return 2;

    case E_V4DImode:
      if (pattern1343 (x1, 
E_V4DImode, 
E_V32QImode) != 0)
        return -1;
      return 3;

    case E_V32QImode:
      if (pattern1344 (x1, 
E_V32QImode, 
E_SImode) != 0)
        return -1;
      return 4;

    case E_V16QImode:
      if (pattern1344 (x1, 
E_V16QImode, 
E_HImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern1361 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern1369 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !x86_64_general_operand (operands[2], i1)
      || !nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern1376 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (maybe_ne (SUBREG_BYTE (x1), 0)
      || GET_MODE (x1) != E_QImode
      || !nonimmediate_operand (operands[0], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  return pattern1147 (x2); /* [-1, 2] */
}

int
pattern1384 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  return pattern1383 (x3, 
i1); /* [-1, 0] */
}

int
pattern1391 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_0_to_3_operand (operands[3], E_VOIDmode)
      || !const_0_to_3_operand (operands[4], E_VOIDmode)
      || !const_4_to_7_operand (operands[5], E_VOIDmode)
      || !const_4_to_7_operand (operands[6], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1398 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !nonimmediate_operand (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1408 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[2], i2))
    return -1;
  x7 = XEXP (x3, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern1418 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  operands[2] = x2;
  if (!const_4_to_7_operand (operands[2], E_VOIDmode))
    return -1;
  x3 = XVECEXP (x1, 0, 5);
  operands[3] = x3;
  if (!const_4_to_7_operand (operands[3], E_VOIDmode))
    return -1;
  x4 = XVECEXP (x1, 0, 6);
  operands[4] = x4;
  if (!const_4_to_7_operand (operands[4], E_VOIDmode))
    return -1;
  x5 = XVECEXP (x1, 0, 7);
  operands[5] = x5;
  if (!const_4_to_7_operand (operands[5], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1427 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (XWINT (x2, 0) != 2LL)
    return -1;
  x3 = XVECEXP (x1, 0, 3);
  if (XWINT (x3, 0) != 3LL)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  if (XWINT (x4, 0) != 4LL)
    return -1;
  x5 = XVECEXP (x1, 0, 5);
  if (XWINT (x5, 0) != 5LL)
    return -1;
  x6 = XVECEXP (x1, 0, 6);
  if (XWINT (x6, 0) != 6LL)
    return -1;
  x7 = XVECEXP (x1, 0, 7);
  if (XWINT (x7, 0) != 7LL)
    return -1;
  return 0;
}

int
pattern1438 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !x86_64_general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1447 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 1);
  operands[1] = x6;
  if (!x86_64_general_operand (operands[1], E_DImode))
    return -1;
  x7 = XEXP (x3, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = XEXP (x2, 0);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  return 0;
}

int
pattern1454 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1462 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x3, 2);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern1470 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!vsib_mem_operator (operands[5], i1)
      || !register_operand (operands[6], E_QImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      return pattern1469 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1469 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1482 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V4SImode:
      if (!register_operand (operands[2], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[2], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1490 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[3]))
    {
    case E_HImode:
      if (!extract_operator (operands[3], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!extract_operator (operands[3], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      if (!extract_operator (operands[3], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1498 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !ix86_carry_flag_operator (operands[4], i1)
      || !x86_64_general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1507 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1516 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[4], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V8SImode:
      if (!register_operand (operands[3], E_V8SImode))
        return -1;
      return 0;

    case E_V8DImode:
      if (!register_operand (operands[3], E_V8DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1525 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !ix86_carry_flag_operator (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !x86_64_general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1531 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  if (!rtx_equal_p (x6, operands[3]))
    return -1;
  x7 = XVECEXP (x1, 0, 4);
  x8 = XEXP (x7, 0);
  if (!rtx_equal_p (x8, operands[4]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      return 0;

    case E_DImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern1543 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != MINUS)
    return -1;
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case LTU:
    case UNLT:
      operands[5] = x3;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 0;

    default:
      return -1;
    }
}

int
pattern1553 (rtx x1, int i1, int i2, int i3, int i4, int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 12);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x3 = XVECEXP (x1, 0, 13);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x4 = XVECEXP (x1, 0, 14);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x5 = XVECEXP (x1, 0, 15);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x6 = XVECEXP (x1, 0, 16);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + i5])
    return -1;
  return 0;
}

int
pattern1561 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i1)
      || !register_operand (operands[5], i3))
    return -1;
  return 0;
}

int
pattern1570 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 4);
  if (XWINT (x3, 0) != 6LL)
    return -1;
  x4 = XVECEXP (x2, 0, 5);
  if (XWINT (x4, 0) != 14LL)
    return -1;
  x5 = XVECEXP (x2, 0, 6);
  if (XWINT (x5, 0) != 7LL)
    return -1;
  x6 = XVECEXP (x2, 0, 7);
  if (XWINT (x6, 0) != 15LL)
    return -1;
  x7 = XEXP (x1, 0);
  x8 = XEXP (x7, 1);
  operands[2] = x8;
  return 0;
}

int
pattern1580 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[6], i1)
      || !register_operand (operands[2], i2)
      || !scratch_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!vsib_address_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!vsib_address_operand (operands[3], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1590 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_V16QImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[3] = x5;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[4] = x6;
  if (!nonimmediate_operand (operands[4], E_V16QImode))
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  operands[5] = x7;
  if (!register_operand (operands[5], E_SImode))
    return -1;
  x8 = XVECEXP (x3, 0, 4);
  operands[6] = x8;
  if (!const_0_to_255_operand (operands[6], E_SImode))
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 0);
  operands[1] = x10;
  if (!register_operand (operands[1], E_V16QImode))
    return -1;
  x11 = XEXP (x9, 1);
  x12 = XVECEXP (x11, 0, 0);
  if (!rtx_equal_p (x12, operands[2]))
    return -1;
  x13 = XVECEXP (x11, 0, 1);
  if (!rtx_equal_p (x13, operands[3]))
    return -1;
  x14 = XVECEXP (x11, 0, 2);
  if (!rtx_equal_p (x14, operands[4]))
    return -1;
  x15 = XVECEXP (x11, 0, 3);
  if (!rtx_equal_p (x15, operands[5]))
    return -1;
  x16 = XVECEXP (x11, 0, 4);
  if (!rtx_equal_p (x16, operands[6]))
    return -1;
  x17 = XVECEXP (x1, 0, 2);
  x18 = XEXP (x17, 1);
  x19 = XVECEXP (x18, 0, 0);
  if (!rtx_equal_p (x19, operands[2]))
    return -1;
  x20 = XVECEXP (x18, 0, 1);
  if (!rtx_equal_p (x20, operands[3]))
    return -1;
  x21 = XVECEXP (x18, 0, 2);
  if (!rtx_equal_p (x21, operands[4]))
    return -1;
  x22 = XVECEXP (x18, 0, 3);
  if (!rtx_equal_p (x22, operands[5]))
    return -1;
  x23 = XVECEXP (x18, 0, 4);
  if (!rtx_equal_p (x23, operands[6]))
    return -1;
  return 0;
}

int
pattern1618 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_HImode:
      if (!memory_operand (operands[0], E_HImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 0);
      if (GET_MODE (x6) != E_HImode
          || !nonmemory_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!memory_operand (operands[0], E_SImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 0);
      if (GET_MODE (x6) != E_SImode
          || !nonmemory_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1630 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[0], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V16SImode:
      return pattern1628 (
E_HImode, 
E_V16SFmode, 
E_V16SImode); /* [-1, 0] */

    case E_V8DImode:
      if (pattern1628 (
E_QImode, 
E_V8SFmode, 
E_V8DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1637 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1
      || !const_int_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1648 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !vsib_mem_operator (operands[7], i2)
      || !register_operand (operands[5], i1)
      || !scratch_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1647 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1647 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1659 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != COMPARE)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17)
    return -1;
  x5 = XEXP (x2, 0);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  return 0;
}

int
pattern1667 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[3], i1))
    return -1;
  x6 = XEXP (x2, 1);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XEXP (x1, 1);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  return 0;
}

int
pattern1675 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1683 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (!register_operand (x6, E_SImode))
    return -1;
  return 0;
}

int
pattern1689 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i4
      || !register_operand (operands[1], i3))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i4
      || !vector_operand (operands[2], i3)
      || !nonimm_or_0_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1696 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  if (XWINT (x2, 0) != 6LL)
    return -1;
  x3 = XVECEXP (x1, 0, 5);
  if (XWINT (x3, 0) != 22LL)
    return -1;
  x4 = XVECEXP (x1, 0, 6);
  if (XWINT (x4, 0) != 7LL)
    return -1;
  x5 = XVECEXP (x1, 0, 7);
  if (XWINT (x5, 0) != 23LL)
    return -1;
  return 0;
}

int
pattern1700 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i2
      || !ix86_carry_flag_operator (operands[4], i2))
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1
      || !ix86_carry_flag_operator (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1711 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !vsib_mem_operator (operands[7], i3)
      || !register_operand (operands[5], i2)
      || !scratch_operand (operands[1], i1))
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      if (!vsib_address_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!vsib_address_operand (operands[3], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1720 (rtx x1, int i1, int i2, int i3, int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 28);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x3 = XVECEXP (x1, 0, 29);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x4 = XVECEXP (x1, 0, 30);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x5 = XVECEXP (x1, 0, 31);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern1725 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[4], E_SImode)
      || GET_MODE (x1) != E_SImode
      || !nonmemory_operand (operands[2], E_SImode))
    return -1;
  x2 = PATTERN (peep2_next_insn (3));
  x3 = XEXP (x2, 1);
  operands[5] = x3;
  if (!register_operand (operands[5], i1))
    return -1;
  x4 = PATTERN (peep2_next_insn (4));
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  operands[6] = x6;
  x7 = XEXP (x5, 1);
  operands[7] = x7;
  return 0;
}

int
pattern1732 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!x86_64_immediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern1735 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !nonimmediate_operand (operands[1], i1)
      || !ix86_carry_flag_operator (operands[4], i2))
    return -1;
  x7 = XEXP (x4, 1);
  if (GET_MODE (x7) != i2
      || !sext_operand (operands[2], i1)
      || pattern1734 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1743 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 8);
  if (XWINT (x2, 0) != 12LL)
    return -1;
  x3 = XVECEXP (x1, 0, 9);
  if (XWINT (x3, 0) != 44LL)
    return -1;
  x4 = XVECEXP (x1, 0, 10);
  if (XWINT (x4, 0) != 13LL)
    return -1;
  x5 = XVECEXP (x1, 0, 11);
  if (XWINT (x5, 0) != 45LL)
    return -1;
  x6 = XVECEXP (x1, 0, 12);
  if (XWINT (x6, 0) != 14LL)
    return -1;
  x7 = XVECEXP (x1, 0, 13);
  if (XWINT (x7, 0) != 46LL)
    return -1;
  x8 = XVECEXP (x1, 0, 14);
  if (XWINT (x8, 0) != 15LL)
    return -1;
  x9 = XVECEXP (x1, 0, 15);
  if (XWINT (x9, 0) != 47LL)
    return -1;
  return 0;
}

 int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 17)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x4;
      res = recog_3 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x4) != SUBREG
          || pattern235 (x4) != 0)
        return -1;
      x5 = XEXP (x4, 0);
      x6 = XEXP (x5, 0);
      operands[0] = x6;
      if (!int248_register_operand (operands[0], E_VOIDmode))
        return -1;
      x7 = XEXP (x3, 1);
      operands[1] = x7;
      switch (GET_MODE (operands[2]))
        {
        case E_HImode:
          if (extract_operator (operands[2], E_HImode))
            {
              if (const0_operand (operands[1], E_QImode)
                  && 
#line 1629 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)))
                return 23; /* *cmpqi_exthi_2 */
              if (general_operand (operands[1], E_QImode)
                  && 
#line 1654 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCmode)))
                return 26; /* *cmpqi_exthi_3 */
            }
          break;

        case E_SImode:
          if (extract_operator (operands[2], E_SImode))
            {
              if (const0_operand (operands[1], E_QImode)
                  && 
#line 1629 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)))
                return 24; /* *cmpqi_extsi_2 */
              if (general_operand (operands[1], E_QImode)
                  && 
#line 1654 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCmode)))
                return 27; /* *cmpqi_extsi_3 */
            }
          break;

        case E_DImode:
          if (extract_operator (operands[2], E_DImode))
            {
              if (const0_operand (operands[1], E_QImode)
                  && (
#line 1629 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 25; /* *cmpqi_extdi_2 */
              if (general_operand (operands[1], E_QImode)
                  && (
#line 1654 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCmode)) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 28; /* *cmpqi_extdi_3 */
            }
          break;

        default:
          break;
        }
      if (GET_CODE (x7) != SUBREG
          || maybe_ne (SUBREG_BYTE (x7), 0)
          || GET_MODE (x7) != E_QImode)
        return -1;
      x8 = XEXP (x7, 0);
      switch (GET_CODE (x8))
        {
        case SIGN_EXTRACT:
        case ZERO_EXTRACT:
          operands[3] = x8;
          x9 = XEXP (x8, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x10 = XEXP (x8, 2);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x11 = XEXP (x8, 0);
          operands[1] = x11;
          if (!int248_register_operand (operands[1], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_HImode:
              if (!extract_operator (operands[2], E_HImode)
                  || !extract_operator (operands[3], E_HImode)
                  || !
#line 1673 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCmode)))
                return -1;
              return 29; /* *cmpqi_exthi_4 */

            case E_SImode:
              if (!extract_operator (operands[2], E_SImode)
                  || !extract_operator (operands[3], E_SImode)
                  || !
#line 1673 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCmode)))
                return -1;
              return 30; /* *cmpqi_extsi_4 */

            case E_DImode:
              if (!extract_operator (operands[2], E_DImode)
                  || !extract_operator (operands[3], E_DImode)
                  || !(
#line 1673 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCmode)) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 31; /* *cmpqi_extdi_4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      x7 = XEXP (x3, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x4, 0);
      operands[0] = x5;
      x12 = XEXP (x4, 1);
      operands[1] = x12;
      switch (GET_MODE (x4))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[0], E_QImode)
              || !general_operand (operands[1], E_QImode)
              || !
#line 1600 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCGOCmode)))
            return -1;
          return 16; /* *cmpqi_minus_1 */

        case E_HImode:
          if (!nonimmediate_operand (operands[0], E_HImode)
              || !general_operand (operands[1], E_HImode)
              || !
#line 1600 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCGOCmode)))
            return -1;
          return 17; /* *cmphi_minus_1 */

        case E_SImode:
          if (!nonimmediate_operand (operands[0], E_SImode)
              || !x86_64_general_operand (operands[1], E_SImode)
              || !
#line 1600 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCGOCmode)))
            return -1;
          return 18; /* *cmpsi_minus_1 */

        case E_DImode:
          if (!nonimmediate_operand (operands[0], E_DImode)
              || !x86_64_general_operand (operands[1], E_DImode)
              || !(
#line 1600 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCGOCmode)) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 19; /* *cmpdi_minus_1 */

        default:
          return -1;
        }

    case NEG:
      if (GET_MODE (x4) != E_QImode
          || GET_MODE (x2) != E_CCCmode
          || GET_MODE (x3) != E_CCCmode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_QImode)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_MODE (x7) != E_QImode)
        return -1;
      switch (GET_CODE (x5))
        {
        case LTU:
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 17
              || GET_MODE (x6) != E_CCCmode)
            return -1;
          x13 = XEXP (x5, 1);
          if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || GET_CODE (x7) != GEU
              || pattern1325 (x7) != 0)
            return -1;
          return 63; /* *x86_cmc */

        case GEU:
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 17)
            return -1;
          x13 = XEXP (x5, 1);
          if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || GET_CODE (x7) != LTU)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 17)
            return -1;
          x14 = XEXP (x7, 1);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          switch (GET_MODE (x6))
            {
            case E_CCmode:
              if (GET_MODE (x8) != E_CCmode
                  || !
#line 9873 "../../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()))
                return -1;
              return 440; /* *setcc_qi_addqi3_cconly_overflow_1_cc */

            case E_CCCmode:
              if (GET_MODE (x8) != E_CCCmode
                  || !
#line 9873 "../../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()))
                return -1;
              return 441; /* *setcc_qi_addqi3_cconly_overflow_1_ccc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_DImode)
        return -1;
      x7 = XEXP (x3, 1);
      if (pattern554 (x7, 
E_CCmode, 
E_DImode, 
PLUS) != 0
          || GET_MODE (x2) != E_CCCmode
          || GET_MODE (x3) != E_CCCmode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x14 = XEXP (x7, 1);
      switch (GET_CODE (x14))
        {
        case ZERO_EXTEND:
          if (GET_MODE (x14) != E_DImode)
            return -1;
          x15 = XEXP (x14, 0);
          operands[2] = x15;
          if (!x86_64_sext_operand (operands[2], E_SImode))
            return -1;
          *pnum_clobbers = 1;
          return 433; /* subsi3_carry_ccc */

        case CONST_INT:
        case CONST_WIDE_INT:
          operands[2] = x14;
          if (!x86_64_dwzext_immediate_operand (operands[2], E_DImode))
            return -1;
          *pnum_clobbers = 1;
          return 434; /* *subsi3_carry_ccc_1 */

        default:
          return -1;
        }

    case PLUS:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_CCCmode
          || GET_MODE (x3) != E_CCCmode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x12 = XEXP (x4, 1);
      operands[2] = x12;
      x7 = XEXP (x3, 1);
      if (!rtx_equal_p (x7, operands[1]))
        return -1;
      switch (pattern973 (x4))
        {
        case 0:
          if (!
#line 9931 "../../../gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          *pnum_clobbers = 1;
          return 447; /* *addqi3_cconly_overflow_1 */

        case 1:
          if (!
#line 9931 "../../../gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          *pnum_clobbers = 1;
          return 448; /* *addhi3_cconly_overflow_1 */

        case 2:
          if (!
#line 9931 "../../../gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          *pnum_clobbers = 1;
          return 449; /* *addsi3_cconly_overflow_1 */

        default:
          return -1;
        }

    case AND:
      x7 = XEXP (x3, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || GET_MODE (x2) != E_CCZmode
          || GET_MODE (x3) != E_CCZmode)
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case NOT:
          switch (pattern780 (x4))
            {
            case 0:
              if (!
#line 12320 "../../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()
   && (!TARGET_BMI || !REG_P (operands[1]))))
                return -1;
              return 563; /* *testqi_not */

            case 1:
              if (!
#line 12320 "../../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()
   && (!TARGET_BMI || !REG_P (operands[1]))))
                return -1;
              return 564; /* *testhi_not */

            case 2:
              if (!
#line 12320 "../../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()
   && (!TARGET_BMI || !REG_P (operands[1]))))
                return -1;
              return 565; /* *testsi_not */

            case 3:
              if (register_operand (operands[0], E_DImode)
                  && x86_64_szext_nonmemory_operand (operands[1], E_DImode)
                  && (
#line 12320 "../../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()
   && (!TARGET_BMI || !REG_P (operands[1]))) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 566; /* *testdi_not */
              if (!nonimmediate_operand (operands[0], E_DImode)
                  || !nonimmediate_operand (operands[1], E_DImode)
                  || !(
#line 12338 "../../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 1195 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 567; /* *testdi_not_doubleword */

            case 4:
              if (!(
#line 12338 "../../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 1196 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 568; /* *testti_not_doubleword */

            default:
              return -1;
            }

        case PLUS:
          if (pnum_clobbers == NULL
              || GET_MODE (x5) != E_SImode)
            return -1;
          x13 = XEXP (x5, 1);
          if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + -1]
              || GET_MODE (x4) != E_SImode)
            return -1;
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (!nonimmediate_operand (operands[1], E_SImode))
            return -1;
          x12 = XEXP (x4, 1);
          if (!rtx_equal_p (x12, operands[1])
              || !
#line 21878 "../../../gcc/config/i386/i386.md"
(TARGET_BMI))
            return -1;
          *pnum_clobbers = 1;
          return 1285; /* *bmi_blsr_si_ccz */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x12 = XEXP (x4, 1);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x16 = XEXP (x4, 2);
      if (pattern533 (x16) != 0)
        return -1;
      x7 = XEXP (x3, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || GET_MODE (x2) != E_CCCmode
          || GET_MODE (x3) != E_CCCmode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[0] = x5;
      if (!nonimmediate_operand (operands[0], E_DImode))
        return -1;
      x17 = XEXP (x16, 0);
      switch (pattern1381 (x17))
        {
        case 0:
          if (!(
#line 19186 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1166; /* *btdi_mask */

        case 1:
          if (!(
#line 19186 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1168; /* *btdi_mask */

        case 2:
          if (!(
#line 19186 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1170; /* *btdi_mask */

        default:
          return -1;
        }

    case UNSPEC:
      if (GET_MODE (x2) != E_CCZmode
          || GET_MODE (x3) != E_CCZmode
          || GET_MODE (x4) != E_SImode)
        return -1;
      switch (XVECLEN (x4, 0))
        {
        case 2:
          if (pnum_clobbers == NULL
              || XINT (x4, 1) != 98)
            return -1;
          x7 = XEXP (x3, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x18 = XVECEXP (x4, 0, 0);
          operands[1] = x18;
          if (!nonimmediate_operand (operands[1], E_SImode))
            return -1;
          x19 = XVECEXP (x4, 0, 1);
          operands[2] = x19;
          if (!register_operand (operands[2], E_SImode)
              || !
#line 21771 "../../../gcc/config/i386/i386.md"
(TARGET_BMI))
            return -1;
          *pnum_clobbers = 1;
          return 1276; /* *bmi_bextr_si_ccz */

        case 1:
          if (XINT (x4, 1) != 49)
            return -1;
          x18 = XVECEXP (x4, 0, 0);
          if (GET_CODE (x18) != VEC_MERGE)
            return -1;
          x7 = XEXP (x3, 1);
          operands[2] = x7;
          if (!const_int_operand (operands[2], E_VOIDmode))
            return -1;
          switch (pattern1164 (x18))
            {
            case 0:
              if (!(
#line 22416 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && UINTVAL (operands[2]) <= 0xffffffff) && 
#line 630 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
                return -1;
              return 7941; /* *pmovsk_mask_cmp_v32qi_avx512 */

            case 1:
              if (!
#line 22416 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && UINTVAL (operands[2]) <= 0xffff))
                return -1;
              return 7942; /* *pmovsk_mask_cmp_v16qi_avx512 */

            case 2:
              if (!(
#line 22439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && (INTVAL (operands[2]) == (int) (0xffffffff))) && 
#line 630 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
                return -1;
              return 7943; /* *pmovsk_ptest_v32qi_avx512 */

            case 3:
              if (!
#line 22439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && (INTVAL (operands[2]) == (int) (0xffff))))
                return -1;
              return 7944; /* *pmovsk_ptest_v16qi_avx512 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IF_THEN_ELSE:
      if (pattern110 (x4, pnum_clobbers, 
0, 
E_QImode, 
NE) != 0)
        return -1;
      x12 = XEXP (x4, 1);
      if (GET_CODE (x12) != ZERO_EXTRACT
          || GET_MODE (x12) != E_SImode)
        return -1;
      x20 = XEXP (x12, 1);
      if (GET_CODE (x20) != UMIN
          || GET_MODE (x20) != E_QImode)
        return -1;
      x21 = XEXP (x12, 2);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x16 = XEXP (x4, 2);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x3, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || GET_MODE (x2) != E_CCZmode
          || GET_MODE (x3) != E_CCZmode)
        return -1;
      x5 = XEXP (x4, 0);
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      x22 = XEXP (x12, 0);
      operands[1] = x22;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      x23 = XEXP (x20, 1);
      operands[3] = x23;
      if (!const_int_operand (operands[3], E_QImode))
        return -1;
      x24 = XEXP (x20, 0);
      if (!rtx_equal_p (x24, operands[2])
          || !
#line 21934 "../../../gcc/config/i386/i386.md"
(TARGET_BMI2 && INTVAL (operands[3]) == 4 * BITS_PER_UNIT))
        return -1;
      *pnum_clobbers = 1;
      return 1287; /* *bmi2_bzhi_si3_1_ccz */

    case VEC_SELECT:
      x12 = XEXP (x4, 1);
      if (GET_CODE (x12) != PARALLEL
          || XVECLEN (x12, 0) != 1)
        return -1;
      x25 = XVECEXP (x12, 0, 0);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x3, 1);
      if (pattern223 (x7) != 0
          || GET_MODE (x2) != E_CCFPmode
          || GET_MODE (x3) != E_CCFPmode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[0] = x5;
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      switch (GET_MODE (x4))
        {
        case E_HFmode:
          if (!register_operand (operands[0], E_V8HFmode)
              || GET_MODE (x7) != E_HFmode
              || !nonimmediate_operand (operands[1], E_V8HFmode)
              || !(
#line 4869 "../../../gcc/config/i386/sse.md"
(SSE_FLOAT_MODE_P (HFmode) || HFmode == E_HFmode) && 
#line 1355 "../../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16)))
            return -1;
          return 3157; /* avx512fp16_comi */

        case E_SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x7) != E_SFmode
              || !nonimmediate_operand (operands[1], E_V4SFmode)
              || !
#line 4869 "../../../gcc/config/i386/sse.md"
(SSE_FLOAT_MODE_P (SFmode) || SFmode == E_HFmode))
            return -1;
          return 3161; /* sse_comi */

        case E_DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x7) != E_DFmode
              || !nonimmediate_operand (operands[1], E_V2DFmode)
              || !
#line 4869 "../../../gcc/config/i386/sse.md"
(SSE_FLOAT_MODE_P (DFmode) || DFmode == E_HFmode))
            return -1;
          return 3165; /* sse2_comi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_25 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!nonimmediate_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !x86_64_zext_operand (operands[1], E_SImode))
            return -1;
          return 146; /* *zero_extendsidi2 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!nonimmediate_operand (operands[1], E_QImode))
                return -1;
              if (pnum_clobbers != NULL
                  && 
#line 4839 "../../../gcc/config/i386/i386.md"
(TARGET_ZERO_EXTEND_WITH_AND && optimize_function_for_speed_p (cfun)))
                {
                  *pnum_clobbers = 1;
                  return 147; /* zero_extendqisi2_and */
                }
              if (!
#line 4867 "../../../gcc/config/i386/i386.md"
(!(TARGET_ZERO_EXTEND_WITH_AND && optimize_function_for_speed_p (cfun))))
                return -1;
              return 149; /* *zero_extendqisi2 */

            case E_HImode:
              if (!nonimmediate_operand (operands[1], E_HImode))
                return -1;
              if (pnum_clobbers != NULL
                  && 
#line 4839 "../../../gcc/config/i386/i386.md"
(TARGET_ZERO_EXTEND_WITH_AND && optimize_function_for_speed_p (cfun)))
                {
                  *pnum_clobbers = 1;
                  return 148; /* zero_extendhisi2_and */
                }
              if (!
#line 4867 "../../../gcc/config/i386/i386.md"
(!(TARGET_ZERO_EXTEND_WITH_AND && optimize_function_for_speed_p (cfun))))
                return -1;
              return 150; /* *zero_extendhisi2 */

            default:
              return -1;
            }

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !nonimmediate_operand (operands[1], E_QImode))
            return -1;
          if (pnum_clobbers != NULL
              && 
#line 4893 "../../../gcc/config/i386/i386.md"
(TARGET_ZERO_EXTEND_WITH_AND && optimize_function_for_speed_p (cfun)))
            {
              *pnum_clobbers = 1;
              return 151; /* zero_extendqihi2_and */
            }
          if (!
#line 4921 "../../../gcc/config/i386/i386.md"
(!(TARGET_ZERO_EXTEND_WITH_AND && optimize_function_for_speed_p (cfun))))
            return -1;
          return 152; /* *zero_extendqihi2 */

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x4) != E_QImode
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x5;
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          if (!general_operand (operands[2], E_QImode))
            return -1;
          if (
#line 6677 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return 226; /* *addqi_1_zexthi_nf */
          if (pnum_clobbers == NULL
              || !
#line 6677 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          *pnum_clobbers = 1;
          return 227; /* *addqi_1_zexthi */

        case PLUS:
          if (pnum_clobbers == NULL
              || GET_MODE (x5) != E_QImode)
            return -1;
          x7 = XEXP (x5, 0);
          if (!ix86_carry_flag_operator (x7, E_QImode))
            return -1;
          operands[3] = x7;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 17)
            return -1;
          x9 = XEXP (x7, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x10 = XEXP (x5, 1);
          operands[1] = x10;
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          if (!x86_64_general_operand (operands[2], E_QImode)
              || !
#line 8895 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          *pnum_clobbers = 1;
          return 387; /* *addqi3_carry_zexthi */

        case LTU:
        case UNLT:
          if (pnum_clobbers == NULL)
            return -1;
          operands[2] = x5;
          if (!ix86_carry_flag_operator (operands[2], E_QImode)
              || pattern976 (x4) != 0
              || !
#line 8952 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
            return -1;
          *pnum_clobbers = 1;
          return 392; /* *addqi3_carry_zexthi_0 */

        case GE:
        case GEU:
          if (pnum_clobbers == NULL)
            return -1;
          operands[2] = x5;
          if (!ix86_carry_flag_unset_operator (operands[2], E_QImode)
              || pattern976 (x4) != 0
              || !
#line 8997 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
            return -1;
          *pnum_clobbers = 1;
          return 397; /* *addqi3_carry_zexthi_0r */

        default:
          return -1;
        }

    case MINUS:
      if (GET_MODE (x4) != E_QImode
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x5;
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          switch (GET_CODE (operands[2]))
            {
            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_POLY_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
            case REG:
            case SUBREG:
            case MEM:
            case LABEL_REF:
            case SYMBOL_REF:
            case HIGH:
              if (!x86_64_general_operand (operands[2], E_QImode))
                return -1;
              if (
#line 8144 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return 321; /* *subqi_1_zexthi_nf */
              if (pnum_clobbers == NULL
                  || !
#line 8144 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              *pnum_clobbers = 1;
              return 322; /* *subqi_1_zexthi */

            case LTU:
            case UNLT:
              if (pnum_clobbers == NULL
                  || !ix86_carry_flag_operator (operands[2], E_QImode))
                return -1;
              x11 = XEXP (x6, 0);
              if (GET_CODE (x11) != REG
                  || REGNO (x11) != 17)
                return -1;
              x12 = XEXP (x6, 1);
              if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || !
#line 9440 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              *pnum_clobbers = 1;
              return 423; /* *subqi3_carry_zexthi_0 */

            case GE:
            case GEU:
              if (pnum_clobbers == NULL
                  || !ix86_carry_flag_unset_operator (operands[2], E_QImode))
                return -1;
              x11 = XEXP (x6, 0);
              if (GET_CODE (x11) != REG
                  || REGNO (x11) != 17)
                return -1;
              x12 = XEXP (x6, 1);
              if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || !
#line 9488 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              *pnum_clobbers = 1;
              return 428; /* *subqi3_carry_zexthi_0r */

            default:
              return -1;
            }

        case MINUS:
          if (pnum_clobbers == NULL
              || GET_MODE (x5) != E_QImode)
            return -1;
          x10 = XEXP (x5, 1);
          if (!ix86_carry_flag_operator (x10, E_QImode))
            return -1;
          operands[3] = x10;
          x13 = XEXP (x10, 0);
          if (GET_CODE (x13) != REG
              || REGNO (x13) != 17)
            return -1;
          x14 = XEXP (x10, 1);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (!nonimmediate_operand (operands[1], E_QImode)
              || !x86_64_general_operand (operands[2], E_QImode)
              || !
#line 9380 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          *pnum_clobbers = 1;
          return 418; /* *subqi3_carry_zexthi */

        default:
          return -1;
        }

    case AND:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x5;
          if (!nonimmediate_operand (operands[1], E_QImode)
              || GET_MODE (x4) != E_QImode)
            return -1;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          if (!x86_64_general_operand (operands[2], E_QImode))
            return -1;
          if (
#line 12626 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return 571; /* *andqi_1_zexthi_nf */
          if (pnum_clobbers == NULL
              || !
#line 12626 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          *pnum_clobbers = 1;
          return 572; /* *andqi_1_zexthi */

        case UNSPEC:
          if (XVECLEN (x5, 0) != 2)
            return -1;
          x15 = XVECEXP (x5, 0, 0);
          operands[1] = x15;
          x16 = XVECEXP (x5, 0, 1);
          operands[2] = x16;
          x6 = XEXP (x4, 1);
          operands[3] = x6;
          switch (XINT (x5, 1))
            {
            case 158:
              switch (pattern987 (x4))
                {
                case 0:
                  if (!(
#line 19091 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (DImode))) && 
#line 505 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return -1;
                  return 7610; /* *avx512bw_testmv64qi3_zext_mask */

                case 1:
                  if (!(
#line 19091 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (SImode))) && 
#line 506 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return -1;
                  return 7613; /* *avx512vl_testmv32qi3_zext_mask */

                case 2:
                  if (!(
#line 19091 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (SImode))) && 
#line 508 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return -1;
                  return 7619; /* *avx512bw_testmv32hi3_zext_mask */

                case 3:
                  if (!(
#line 19091 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (HImode))) && 
#line 507 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return -1;
                  return 7616; /* *avx512vl_testmv16qi3_zext_mask */

                case 4:
                  if (!(
#line 19091 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (HImode))) && 
#line 509 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return -1;
                  return 7622; /* *avx512vl_testmv16hi3_zext_mask */

                case 5:
                  if (!(
#line 19091 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (HImode))) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 7628; /* *avx512f_testmv16si3_zext_mask */

                case 6:
                  if (!(
#line 19091 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return -1;
                  return 7625; /* *avx512vl_testmv8hi3_zext_mask */

                case 7:
                  if (!(
#line 19091 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 7631; /* *avx512vl_testmv8si3_zext_mask */

                case 8:
                  if (!(
#line 19091 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 7634; /* *avx512vl_testmv4si3_zext_mask */

                case 9:
                  if (!(
#line 19091 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 512 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 7637; /* *avx512f_testmv8di3_zext_mask */

                case 10:
                  if (!(
#line 19091 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 512 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 7640; /* *avx512vl_testmv4di3_zext_mask */

                case 11:
                  if (!(
#line 19091 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 512 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 7643; /* *avx512vl_testmv2di3_zext_mask */

                default:
                  return -1;
                }

            case 159:
              switch (pattern987 (x4))
                {
                case 0:
                  if (!(
#line 19121 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (DImode))) && 
#line 505 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return -1;
                  return 7682; /* *avx512bw_testnmv64qi3_zext_mask */

                case 1:
                  if (!(
#line 19121 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (SImode))) && 
#line 506 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return -1;
                  return 7685; /* *avx512vl_testnmv32qi3_zext_mask */

                case 2:
                  if (!(
#line 19121 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (SImode))) && 
#line 508 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return -1;
                  return 7691; /* *avx512bw_testnmv32hi3_zext_mask */

                case 3:
                  if (!(
#line 19121 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (HImode))) && 
#line 507 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return -1;
                  return 7688; /* *avx512vl_testnmv16qi3_zext_mask */

                case 4:
                  if (!(
#line 19121 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (HImode))) && 
#line 509 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return -1;
                  return 7694; /* *avx512vl_testnmv16hi3_zext_mask */

                case 5:
                  if (!(
#line 19121 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (HImode))) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 7700; /* *avx512f_testnmv16si3_zext_mask */

                case 6:
                  if (!(
#line 19121 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 510 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return -1;
                  return 7697; /* *avx512vl_testnmv8hi3_zext_mask */

                case 7:
                  if (!(
#line 19121 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 7703; /* *avx512vl_testnmv8si3_zext_mask */

                case 8:
                  if (!(
#line 19121 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 7706; /* *avx512vl_testnmv4si3_zext_mask */

                case 9:
                  if (!(
#line 19121 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 512 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 7709; /* *avx512f_testnmv8di3_zext_mask */

                case 10:
                  if (!(
#line 19121 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 512 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 7712; /* *avx512vl_testnmv4di3_zext_mask */

                case 11:
                  if (!(
#line 19121 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 512 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 7715; /* *avx512vl_testnmv2di3_zext_mask */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IOR:
      if (pattern79 (x3) != 0)
        return -1;
      if (
#line 13715 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 684; /* *iorqi_1_zexthi_nf */
      if (pnum_clobbers == NULL
          || !
#line 13715 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      *pnum_clobbers = 1;
      return 685; /* *iorqi_1_zexthi */

    case XOR:
      if (pattern79 (x3) != 0)
        return -1;
      if (
#line 13715 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 686; /* *xorqi_1_zexthi_nf */
      if (pnum_clobbers == NULL
          || !
#line 13715 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      *pnum_clobbers = 1;
      return 687; /* *xorqi_1_zexthi */

    case NEG:
      if (pattern80 (x3, 
E_QImode, 
E_HImode) != 0)
        return -1;
      if (
#line 14360 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
        return 777; /* *negqi_1_zexthi_nf */
      if (pnum_clobbers == NULL
          || !
#line 14360 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
        return -1;
      *pnum_clobbers = 1;
      return 778; /* *negqi_1_zexthi */

    case NOT:
      if (pattern80 (x3, 
E_QImode, 
E_HImode) != 0
          || !
#line 15002 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
        return -1;
      return 845; /* *one_cmplqi2_1_zexthi */

    case ASHIFT:
      if (pattern81 (x3) != 0)
        return -1;
      if (
#line 16018 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
        return 887; /* *ashlqi3_1_zexthi_nf */
      if (pnum_clobbers == NULL
          || !
#line 16018 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
        return -1;
      *pnum_clobbers = 1;
      return 888; /* *ashlqi3_1_zexthi */

    case LSHIFTRT:
      if (pattern81 (x3) != 0)
        return -1;
      if (
#line 17475 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
        return 957; /* *lshrqi3_1_zexthi_nf */
      if (pnum_clobbers == NULL
          || !
#line 17475 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
        return -1;
      *pnum_clobbers = 1;
      return 958; /* *lshrqi3_1_zexthi */

    case ASHIFTRT:
      if (pattern81 (x3) != 0)
        return -1;
      if (
#line 17475 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
        return 959; /* *ashrqi3_1_zexthi_nf */
      if (pnum_clobbers == NULL
          || !
#line 17475 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
        return -1;
      *pnum_clobbers = 1;
      return 960; /* *ashrqi3_1_zexthi */

    case ROTATE:
      if (pattern81 (x3) != 0)
        return -1;
      if (
#line 18590 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
        return 1110; /* *rotlqi3_1_zexthi_nf */
      if (pnum_clobbers == NULL
          || !
#line 18590 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
        return -1;
      *pnum_clobbers = 1;
      return 1111; /* *rotlqi3_1_zexthi */

    case ROTATERT:
      if (pattern81 (x3) != 0)
        return -1;
      if (
#line 18590 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
        return 1112; /* *rotrqi3_1_zexthi_nf */
      if (pnum_clobbers == NULL
          || !
#line 18590 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
        return -1;
      *pnum_clobbers = 1;
      return 1113; /* *rotrqi3_1_zexthi */

    case VEC_SELECT:
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != PARALLEL)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (XVECLEN (x6, 0))
        {
        case 2:
          x17 = XVECEXP (x6, 0, 0);
          if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x18 = XVECEXP (x6, 0, 1);
          if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || pattern785 (x3, 
E_V4QImode, 
E_V2QImode, 
E_V2HImode) != 0
              || !
#line 5101 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1))
            return -1;
          return 1822; /* sse4_1_zero_extendv2qiv2hi2 */

        case 1:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || GET_MODE (x4) != E_QImode)
            return -1;
          x17 = XVECEXP (x6, 0, 0);
          operands[2] = x17;
          switch (pattern977 ())
            {
            case 0:
              if (!
#line 6130 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1))
                return -1;
              return 1854; /* *pextrb_zext */

            case 1:
              if (!
#line 21134 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return -1;
              return 7877; /* *vec_extractv16qi_zext */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      return recog_24 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_57 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case PLUS:
      if (pattern91 (x3, 
E_V2SFmode, 
E_SFmode) != 0)
        return -1;
      x5 = XEXP (x3, 1);
      x6 = XEXP (x5, 0);
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      if (!nonimmediate_operand (operands[2], E_V2SFmode)
          || pattern1709 (x3) != 0
          || !
#line 995 "../../../gcc/config/i386/mmx.md"
(TARGET_3DNOW
   && INTVAL (operands[3]) != INTVAL (operands[4])
   && INTVAL (operands[5]) != INTVAL (operands[6])))
        return -1;
      return 1634; /* *mmx_haddv2sf3 */

    case MINUS:
      if (pattern92 (x4, 
E_SFmode) != 0
          || !register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode)
        return -1;
      x8 = XEXP (x4, 0);
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) != E_SFmode)
        return -1;
      x10 = XEXP (x4, 1);
      x11 = XEXP (x10, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      switch (GET_CODE (x5))
        {
        case MINUS:
          if (pattern1425 (x5, 
E_SFmode) != 0)
            return -1;
          x6 = XEXP (x5, 0);
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          if (!nonimmediate_operand (operands[2], E_V2SFmode))
            return -1;
          x12 = XEXP (x5, 1);
          x13 = XEXP (x12, 0);
          if (!rtx_equal_p (x13, operands[2])
              || !
#line 1043 "../../../gcc/config/i386/mmx.md"
(TARGET_3DNOW_A))
            return -1;
          return 1635; /* mmx_hsubv2sf3 */

        case PLUS:
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != VEC_SELECT
              || GET_MODE (x6) != E_SFmode)
            return -1;
          x14 = XEXP (x6, 1);
          if (GET_CODE (x14) != PARALLEL
              || XVECLEN (x14, 0) != 1)
            return -1;
          x12 = XEXP (x5, 1);
          if (GET_CODE (x12) != VEC_SELECT
              || GET_MODE (x12) != E_SFmode)
            return -1;
          x15 = XEXP (x12, 1);
          if (GET_CODE (x15) != PARALLEL
              || XVECLEN (x15, 0) != 1)
            return -1;
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          if (!nonimmediate_operand (operands[2], E_V2SFmode))
            return -1;
          x16 = XVECEXP (x14, 0, 0);
          operands[3] = x16;
          if (!const_0_to_1_operand (operands[3], E_SImode))
            return -1;
          x17 = XVECEXP (x15, 0, 0);
          operands[4] = x17;
          if (!const_0_to_1_operand (operands[4], E_SImode))
            return -1;
          x13 = XEXP (x12, 0);
          if (!rtx_equal_p (x13, operands[2])
              || !
#line 1105 "../../../gcc/config/i386/mmx.md"
(TARGET_3DNOW_A
   && INTVAL (operands[3]) != INTVAL (operands[4])))
            return -1;
          return 1636; /* *mmx_haddsubv2sf3 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V2SFmode:
          if (!register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !nonimmediate_operand (operands[1], E_SFmode))
            return -1;
          if (nonimm_or_0_operand (operands[2], E_SFmode))
            {
              if (
#line 1755 "../../../gcc/config/i386/mmx.md"
(TARGET_MMX && !TARGET_SSE))
                return 1646; /* *mmx_concatv2sf */
              if (
#line 11753 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return 4707; /* *vec_concatv2sf_sse4_1 */
            }
          if (!reg_or_0_operand (operands[2], E_SFmode)
              || !
#line 11817 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 4708; /* *vec_concatv2sf_sse */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !nonimmediate_operand (operands[1], E_SImode))
            return -1;
          if (nonimm_or_0_operand (operands[2], E_SImode))
            {
              if (
#line 5701 "../../../gcc/config/i386/mmx.md"
(TARGET_MMX && !TARGET_SSE))
                return 1841; /* *mmx_concatv2si */
              if (
#line 21505 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return 7887; /* *vec_concatv2si_sse4_1 */
            }
          if (!reg_or_0_operand (operands[2], E_SImode)
              || !
#line 21554 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && !TARGET_SSE4_1))
            return -1;
          return 7888; /* *vec_concatv2si */

        default:
          return -1;
        }

    case SS_TRUNCATE:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != SS_TRUNCATE)
        return -1;
      switch (pattern243 (x3))
        {
        case 0:
          if (!
#line 4771 "../../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return -1;
          return 1810; /* mmx_packsswb */

        case 1:
          if (!
#line 4812 "../../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return -1;
          return 1812; /* mmx_packssdw */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_64 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (pattern379 (x3))
        {
        case 0:
          if (pnum_clobbers != NULL
              && x86_64_hilo_general_operand (operands[2], E_DImode)
              && (
#line 6465 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 212; /* *adddi3_doubleword */
            }
          if (x86_64_general_operand (operands[2], E_DImode))
            {
              if ((
#line 6615 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)
  && TARGET_APX_NF) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 224; /* *adddi_1_nf */
              if (pnum_clobbers != NULL
                  && (
#line 6615 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)
  && true) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 225; /* *adddi_1 */
                }
            }
          break;

        case 1:
          if (
#line 6615 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)
  && TARGET_APX_NF))
            return 222; /* *addsi_1_nf */
          if (pnum_clobbers != NULL
              && 
#line 6615 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)
  && true))
            {
              *pnum_clobbers = 1;
              return 223; /* *addsi_1 */
            }
          break;

        default:
          break;
        }
      if (!register_operand (operands[1], E_SImode)
          || pattern380 (x3, 
22) != 0)
        return -1;
      x6 = XEXP (x5, 0);
      x7 = XVECEXP (x6, 0, 0);
      operands[2] = x7;
      if (!tls_symbolic_operand (operands[2], E_VOIDmode)
          || !
#line 23151 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_GNU2_TLS))
        return -1;
      return 1326; /* *tls_dynamic_gnu2_lea_32 */

    case ZERO_EXTEND:
      if (GET_MODE (x4) != E_DImode
          || !nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x8 = XEXP (x4, 0);
      if (!nonimmediate_operand (x8, E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
        case MEM:
          if (pnum_clobbers == NULL)
            return -1;
          operands[1] = x5;
          if (!nonimmediate_operand (operands[1], E_DImode))
            return -1;
          operands[2] = x8;
          if (!(
#line 6511 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (UNKNOWN, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 214; /* *adddi3_doubleword_zext */

        case ASHIFT:
          if (GET_MODE (x5) != E_DImode)
            return -1;
          operands[1] = x8;
          switch (pattern108 (x5))
            {
            case 0:
              if (!(
#line 14077 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 728; /* *concatsidi3_2 */

            case 1:
              if (!(
#line 14121 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 737; /* *concatsidi3_4 */

            case 2:
              if (!(
#line 14121 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 740; /* *concatsidi3_4 */

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
          operands[2] = x5;
          if (!const_scalar_int_operand (operands[2], E_DImode))
            return -1;
          operands[1] = x8;
          if (!(
#line 14198 "../../../gcc/config/i386/i386.md"
(DImode == DImode
   ? CONST_INT_P (operands[2])
     && (UINTVAL (operands[2]) & GET_MODE_MASK (SImode)) == 0
     && !ix86_endbr_immediate_operand (operands[2], VOIDmode)
   : CONST_WIDE_INT_P (operands[2])
     && CONST_WIDE_INT_NUNITS (operands[2]) == 2
     && CONST_WIDE_INT_ELT (operands[2], 0) == 0
     && !ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[2],
								    1)),
				       VOIDmode)) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 761; /* *concatsidi3_7 */

        default:
          return -1;
        }

    case PLUS:
      if (pnum_clobbers == NULL)
        return -1;
      x8 = XEXP (x4, 0);
      switch (GET_CODE (x8))
        {
        case ASHIFT:
          if (GET_MODE (x8) != E_DImode)
            return -1;
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != ZERO_EXTEND
              || GET_MODE (x9) != E_DImode)
            return -1;
          x10 = XEXP (x4, 1);
          if (GET_CODE (x10) != ZERO_EXTEND
              || GET_MODE (x10) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return -1;
          switch (pattern98 (x3))
            {
            case 0:
              if (!(
#line 6542 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 216; /* *adddi3_doubleword_concat */

            case 1:
              if (!(
#line 6573 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 219; /* *adddi3_doubleword_concat_zext */

            default:
              return -1;
            }

        case LTU:
        case UNLT:
          operands[4] = x8;
          x11 = XEXP (x8, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x9 = XEXP (x8, 0);
          operands[3] = x9;
          if (!flags_reg_operand (operands[3], E_VOIDmode))
            return -1;
          x10 = XEXP (x4, 1);
          operands[1] = x10;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern1173 (x3, 
E_SImode) != 0
                  || !
#line 8793 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)))
                return -1;
              *pnum_clobbers = 1;
              return 377; /* addsi3_carry */

            case E_DImode:
              if (pattern1173 (x3, 
E_DImode) != 0
                  || !(
#line 8793 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 378; /* adddi3_carry */

            default:
              return -1;
            }

        case EQ:
          x11 = XEXP (x8, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x9 = XEXP (x8, 0);
          operands[3] = x9;
          if (!int_nonimmediate_operand (operands[3], E_VOIDmode))
            return -1;
          x10 = XEXP (x4, 1);
          operands[1] = x10;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern1097 (x3, 
E_SImode) != 0
                  || !
#line 10136 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 465; /* *addsi3_eq */

            case E_DImode:
              if (pattern1097 (x3, 
E_DImode) != 0
                  || !(
#line 10136 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 466; /* *adddi3_eq */

            default:
              return -1;
            }

        case NE:
          x11 = XEXP (x8, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x9 = XEXP (x8, 0);
          operands[3] = x9;
          if (!int_nonimmediate_operand (operands[3], E_VOIDmode))
            return -1;
          x10 = XEXP (x4, 1);
          operands[1] = x10;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern1098 (x3, 
E_SImode) != 0
                  || !
#line 10157 "../../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (SImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 469; /* *addsi3_ne */

            case E_DImode:
              if (pattern1098 (x3, 
E_DImode) != 0
                  || !(
#line 10157 "../../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (DImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 470; /* *adddi3_ne */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IOR:
      switch (pattern99 (x3, pnum_clobbers))
        {
        case 0:
          if (!(
#line 6542 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 217; /* *adddi3_doubleword_concat */

        case 1:
          if (!(
#line 6573 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 220; /* *adddi3_doubleword_concat_zext */

        default:
          return -1;
        }

    case XOR:
      switch (pattern99 (x3, pnum_clobbers))
        {
        case 0:
          if (!(
#line 6542 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 218; /* *adddi3_doubleword_concat */

        case 1:
          if (!(
#line 6573 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 221; /* *adddi3_doubleword_concat_zext */

        default:
          return -1;
        }

    case LTU:
    case UNLT:
      switch (pattern100 (x3, pnum_clobbers))
        {
        case 0:
          if (pattern985 (x3, 
E_SImode) != 0
              || !
#line 8865 "../../../gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          *pnum_clobbers = 1;
          return 381; /* *addsi3_carry_0 */

        case 1:
          if (pattern985 (x3, 
E_DImode) != 0
              || !(
#line 8865 "../../../gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 382; /* *adddi3_carry_0 */

        default:
          return -1;
        }

    case GE:
    case GEU:
      switch (pattern100 (x3, pnum_clobbers))
        {
        case 0:
          if (pattern986 (x3, 
E_SImode) != 0
              || !
#line 8879 "../../../gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          *pnum_clobbers = 1;
          return 385; /* *addsi3_carry_0r */

        case 1:
          if (pattern986 (x3, 
E_DImode) != 0
              || !(
#line 8879 "../../../gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 386; /* *adddi3_carry_0r */

        default:
          return -1;
        }

    case EQ:
      switch (pattern102 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 10183 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, SImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 473; /* *addsi3_eq_0 */

        case 1:
          if (!(
#line 10183 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, DImode, operands)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 474; /* *adddi3_eq_0 */

        default:
          return -1;
        }

    case NE:
      switch (pattern102 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 10204 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, SImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 477; /* *addsi3_ne_0 */

        case 1:
          if (!(
#line 10204 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, DImode, operands)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 478; /* *adddi3_ne_0 */

        default:
          return -1;
        }

    case MINUS:
      if (pnum_clobbers == NULL)
        return -1;
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      x10 = XEXP (x4, 1);
      switch (GET_CODE (x10))
        {
        case NE:
          switch (pattern696 (x3))
            {
            case 0:
              if (!
#line 10252 "../../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (SImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 485; /* *subsi3_ne */

            case 1:
              if (!(
#line 10252 "../../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (DImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 486; /* *subdi3_ne */

            default:
              return -1;
            }

        case EQ:
          switch (pattern696 (x3))
            {
            case 0:
              if (!
#line 10281 "../../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (SImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 489; /* *subsi3_eq_1 */

            case 1:
              if (!(
#line 10281 "../../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (DImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 490; /* *subdi3_eq_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      if (GET_MODE (x4) != E_DImode
          || !nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x10 = XEXP (x4, 1);
      operands[2] = x10;
      if (!const_int_operand (operands[2], E_QImode))
        return -1;
      x8 = XEXP (x4, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[1] = x8;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x5 = XEXP (x3, 1);
          switch (pattern246 (x5))
            {
            case 0:
              if (!(
#line 14060 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 725; /* *concatsidi3_1 */

            case 1:
              if (!(
#line 14137 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT / 2
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1195 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 743; /* *concatsidi3_5 */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern901 (x3))
            {
            case 0:
              if (!(
#line 14096 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 731; /* *concatsidi3_3 */

            case 1:
              if (!(
#line 14169 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 749; /* *concatsidi3_6 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern901 (x3))
            {
            case 0:
              if (!(
#line 14096 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 734; /* *concatsidi3_3 */

            case 1:
              if (!(
#line 14169 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 752; /* *concatsidi3_6 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LSHIFTRT:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_SImode)
        return -1;
      x10 = XEXP (x4, 1);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XEXP (x3, 1);
      if (pattern554 (x5, 
E_CCCmode, 
E_SImode, 
ASHIFT) != 0)
        return -1;
      x12 = XEXP (x5, 1);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 31]
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      *pnum_clobbers = 1;
      return 1142; /* rcrsi2 */

    case UNSPEC:
      if (pnum_clobbers == NULL)
        return -1;
      switch (XVECLEN (x4, 0))
        {
        case 3:
          if (XINT (x4, 1) != 21
              || GET_MODE (x4) != E_SImode)
            return -1;
          x13 = XVECEXP (x4, 0, 2);
          if (GET_CODE (x13) != REG
              || REGNO (x13) != 7
              || GET_MODE (x13) != E_SImode
              || pattern380 (x3, 
6) != 0)
            return -1;
          x14 = XVECEXP (x4, 0, 0);
          operands[1] = x14;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x15 = XVECEXP (x4, 0, 1);
          operands[2] = x15;
          if (!constant_call_address_operand (operands[2], E_VOIDmode))
            return -1;
          x5 = XEXP (x3, 1);
          x6 = XEXP (x5, 0);
          x7 = XVECEXP (x6, 0, 0);
          operands[3] = x7;
          if (!tls_symbolic_operand (operands[3], E_VOIDmode))
            return -1;
          *pnum_clobbers = 3;
          return 1319; /* *tls_local_dynamic_32_once */

        case 1:
          if (XINT (x4, 1) != 19)
            return -1;
          x14 = XVECEXP (x4, 0, 0);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern902 (x3, 
E_SImode) != 0
                  || !
#line 1408 "../../../gcc/config/i386/i386.md"
(ptr_mode == SImode))
                return -1;
              *pnum_clobbers = 1;
              return 1323; /* *add_tp_si */

            case E_DImode:
              if (pattern902 (x3, 
E_DImode) != 0
                  || !
#line 1408 "../../../gcc/config/i386/i386.md"
(ptr_mode == DImode))
                return -1;
              *pnum_clobbers = 1;
              return 1324; /* *add_tp_di */

            default:
              return -1;
            }

        case 4:
          if (XINT (x4, 1) != 22
              || GET_MODE (x4) != E_SImode)
            return -1;
          x16 = XVECEXP (x4, 0, 3);
          if (GET_CODE (x16) != REG
              || REGNO (x16) != 7
              || GET_MODE (x16) != E_SImode
              || pattern380 (x3, 
6) != 0)
            return -1;
          x14 = XVECEXP (x4, 0, 0);
          operands[3] = x14;
          if (!tls_modbase_operand (operands[3], E_VOIDmode))
            return -1;
          x15 = XVECEXP (x4, 0, 1);
          operands[4] = x15;
          x13 = XVECEXP (x4, 0, 2);
          operands[2] = x13;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x5 = XEXP (x3, 1);
          x6 = XEXP (x5, 0);
          x7 = XVECEXP (x6, 0, 0);
          operands[1] = x7;
          if (!tls_symbolic_operand (operands[1], E_VOIDmode)
              || !
#line 23185 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_GNU2_TLS))
            return -1;
          *pnum_clobbers = 1;
          return 1328; /* *tls_dynamic_gnu2_combine_32 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_83 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !general_operand (operands[1], E_DImode))
        return -1;
      if ((
#line 14600 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        {
          *pnum_clobbers = 1;
          return 805; /* *absdi2_doubleword */
        }
      if (!(
#line 14687 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (DImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 812; /* *absdi2_1 */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !general_operand (operands[1], E_SImode)
          || !
#line 14687 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (SImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 811; /* *abssi2_1 */

    default:
      return -1;
    }
}

 int
recog_85 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
    case MEM:
      switch (pattern47 (x3, pnum_clobbers))
        {
        case 0:
          if (pnum_clobbers != NULL
              && pattern387 (x3) == 0
              && (
#line 15203 "../../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (4 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 4 * BITS_PER_UNIT - 1))
	 == (2 * 4 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 859; /* *ashldi3_doubleword_mask */
            }
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          res = recog_84 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern390 (x3))
            {
            case 0:
              if (!
#line 17860 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1))
      == 4 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 1009; /* *ashlsi3_mask */

            case 1:
              if (!(
#line 17860 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1))
      == 8 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1012; /* *ashldi3_mask */

            case 2:
              if (!
#line 17908 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 1021; /* *ashlsi3_add */

            case 3:
              if (!(
#line 17908 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1024; /* *ashldi3_add */

            case 4:
              if (!
#line 17954 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 1033; /* *ashlsi3_sub */

            case 5:
              if (!(
#line 17954 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1036; /* *ashldi3_sub */

            default:
              return -1;
            }

        case 1:
          if (register_operand (operands[0], E_DImode)
              && register_operand (operands[1], E_DImode)
              && (
#line 15264 "../../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (4 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 4 * BITS_PER_UNIT - 1))
	 == (2 * 4 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 861; /* *ashldi3_doubleword_mask_1 */
            }
          if (!nonimmediate_operand (operands[0], E_DImode)
              || !nonimmediate_operand (operands[1], E_DImode)
              || !(
#line 17885 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1))
      == 8 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1018; /* *ashldi3_mask_1 */

        case 2:
          if (!
#line 17885 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1))
      == 4 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1015; /* *ashlsi3_mask_1 */

        case 3:
          if (!
#line 17932 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1027; /* *ashlsi3_add_1 */

        case 4:
          if (!(
#line 17932 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1030; /* *ashldi3_add_1 */

        case 5:
          if (!
#line 17984 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1039; /* *ashlsi3_sub_1 */

        case 6:
          if (!(
#line 17984 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1042; /* *ashldi3_sub_1 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pattern114 (x3, pnum_clobbers) != 0
          || !(
#line 15365 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) >= 4 * BITS_PER_UNIT
   && INTVAL (operands[2]) < 4 * BITS_PER_UNIT * 2) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 864; /* *ashldi3_doubleword_highpart */

    case ZERO_EXTEND:
      if (pattern114 (x3, pnum_clobbers) != 0
          || !(
#line 15365 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) >= 4 * BITS_PER_UNIT
   && INTVAL (operands[2]) < 4 * BITS_PER_UNIT * 2) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 865; /* *ashldi3_doubleword_highpart */

    default:
      return -1;
    }
}

 int
recog_92 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (pattern22 (x1, pnum_clobbers))
    {
    case 0:
      if (!
#line 18202 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1061; /* *rotrsi3_mask_1 */

    case 1:
      if (!(
#line 18202 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1063; /* *rotrdi3_mask_1 */

    case 2:
      if (!
#line 18273 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1077; /* *rotrsi3_add_1 */

    case 3:
      if (!(
#line 18273 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1079; /* *rotrdi3_add_1 */

    case 4:
      if (!
#line 18342 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1093; /* *rotrsi3_sub_1 */

    case 5:
      if (!(
#line 18342 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1095; /* *rotrdi3_sub_1 */

    case 6:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case SUBREG:
          switch (pattern392 (x2, pnum_clobbers))
            {
            case 0:
              if (
#line 18162 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
                {
                  *pnum_clobbers = 1;
                  return 1053; /* *rotrsi3_mask */
                }
              break;

            case 1:
              if ((
#line 18162 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 1055; /* *rotrdi3_mask */
                }
              break;

            case 2:
              if (
#line 18237 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                {
                  *pnum_clobbers = 1;
                  return 1069; /* *rotrsi3_add */
                }
              break;

            case 3:
              if ((
#line 18237 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 1071; /* *rotrdi3_add */
                }
              break;

            case 4:
              if (
#line 18306 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                {
                  *pnum_clobbers = 1;
                  return 1085; /* *rotrsi3_sub */
                }
              break;

            case 5:
              if ((
#line 18306 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 1087; /* *rotrdi3_sub */
                }
              break;

            default:
              break;
            }
          break;

        case CONST_INT:
          operands[2] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern561 (x2, pnum_clobbers, 
E_DImode) == 0
                  && const_1_to_31_operand (operands[2], E_QImode))
                {
                  *pnum_clobbers = 2;
                  return 1097; /* ix86_rotrdi3_doubleword */
                }
              break;

            case E_SImode:
              if (register_operand (operands[0], E_SImode)
                  && GET_MODE (x2) == E_SImode
                  && nonimmediate_operand (operands[1], E_SImode)
                  && const_0_to_31_operand (operands[2], E_QImode)
                  && 
#line 18488 "../../../gcc/config/i386/i386.md"
(TARGET_BMI2 && !optimize_function_for_size_p (cfun)))
                return 1100; /* *bmi2_rorxsi3_1 */
              break;

            default:
              break;
            }
          if (register_operand (operands[0], E_DImode)
              && GET_MODE (x2) == E_DImode)
            {
              if (XWINT (x3, 0) == 32LL
                  && register_operand (operands[1], E_DImode))
                return 1099; /* rotr32di2_doubleword */
              if (nonimmediate_operand (operands[1], E_DImode))
                {
                  operands[2] = x3;
                  if (const_0_to_63_operand (operands[2], E_QImode)
                      && (
#line 18488 "../../../gcc/config/i386/i386.md"
(TARGET_BMI2 && !optimize_function_for_size_p (cfun)) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return 1101; /* *bmi2_rorxdi3_1 */
                }
            }
          break;

        default:
          break;
        }
      operands[2] = x3;
      if (!nonmemory_operand (operands[2], E_QImode))
        return -1;
      switch (pattern19 (x2))
        {
        case 0:
          if (
#line 18498 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
            return 1104; /* *rotrsi3_1_nf */
          if (pnum_clobbers == NULL
              || !
#line 18498 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands, TARGET_APX_NDD)
   && true))
            return -1;
          *pnum_clobbers = 1;
          return 1105; /* *rotrsi3_1 */

        case 1:
          if ((
#line 18498 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 1108; /* *rotrdi3_1_nf */
          if (pnum_clobbers == NULL
              || !(
#line 18498 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1109; /* *rotrdi3_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_109 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern569 (x2))
    {
    case 0:
      if (pattern572 (x2, 
E_V32HImode, 
E_SImode, 
E_V32HFmode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7617 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 758 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 3898; /* avx512fp16_vcvtph2uw_v32hi_mask */

    case 1:
      if (pattern714 (x2, 
E_V16SImode, 
E_HImode) != 0)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16HFmode:
          if (!vector_operand (operands[1], E_V16HFmode)
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7617 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 758 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 3906; /* avx512fp16_vcvtph2udq_v16si_mask */

        case E_V16SFmode:
          if (!nonimmediate_operand (operands[1], E_V16SFmode)
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8706 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 675 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4288; /* avx512f_fixuns_notruncv16sfv16si_mask */

        default:
          return -1;
        }

    case 2:
      switch (pattern1000 (x2, 
E_V8DImode))
        {
        case 0:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7617 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 758 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 3914; /* avx512fp16_vcvtph2uqq_v8di_mask */

        case 1:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8739 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 627 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4308; /* avx512dq_cvtps2uqqv8di_mask */

        case 2:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9721 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 537 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4530; /* fixuns_notruncv8dfv8di2_mask */

        default:
          return -1;
        }

    case 3:
      if (pattern572 (x2, 
E_V16HImode, 
E_HImode, 
E_V16HFmode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7617 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 759 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 3922; /* avx512fp16_vcvtph2uw_v16hi_mask */

    case 4:
      switch (pattern1000 (x2, 
E_V8SImode))
        {
        case 0:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7617 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 759 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 3930; /* avx512fp16_vcvtph2udq_v8si_mask */

        case 1:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8706 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 675 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4292; /* avx512vl_fixuns_notruncv8sfv8si_mask */

        case 2:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 471 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4436; /* fixuns_notruncv8dfv8si2_mask */

        default:
          return -1;
        }

    case 5:
      switch (pattern1001 (x2, 
E_V4DImode))
        {
        case 0:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7617 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 760 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 3938; /* avx512fp16_vcvtph2uqq_v4di_mask */

        case 1:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8739 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 627 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4312; /* avx512dq_cvtps2uqqv4di_mask */

        case 2:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9721 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 537 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4534; /* fixuns_notruncv4dfv4di2_mask */

        default:
          return -1;
        }

    case 6:
      if (pattern572 (x2, 
E_V8HImode, 
E_QImode, 
E_V8HFmode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7617 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 760 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 3945; /* avx512fp16_vcvtph2uw_v8hi_mask */

    case 7:
      switch (pattern1001 (x2, 
E_V4SImode))
        {
        case 0:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7617 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 761 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 3949; /* avx512fp16_vcvtph2udq_v4si_mask */

        case 1:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8706 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 675 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4295; /* avx512vl_fixuns_notruncv4sfv4si_mask */

        case 2:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 471 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4440; /* fixuns_notruncv4dfv4si2_mask */

        default:
          return -1;
        }

    case 8:
      switch (pattern1002 (x2))
        {
        case 0:
          if (!vector_operand (operands[1], E_V8HFmode)
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7617 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 761 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 3953; /* avx512fp16_vcvtph2uqq_v2di_mask */

        case 1:
          if (!nonimmediate_operand (operands[1], E_V2DFmode)
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9721 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 537 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4537; /* fixuns_notruncv2dfv2di2_mask */

        default:
          return -1;
        }

    case 9:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8752 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL)))
        return -1;
      return 4315; /* avx512dq_cvtps2uqqv2di_mask */

    default:
      return -1;
    }
}

 int
recog_116 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_0_to_15_operand (operands[2], E_SImode))
    return -1;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  x7 = XEXP (x2, 2);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      if (pattern407 (x2, 
E_V32HFmode, 
E_SImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29882 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
        return -1;
      return 9379; /* avx512bw_getmantv32hf_mask */

    case E_V16HFmode:
      if (pattern407 (x2, 
E_V16HFmode, 
E_HImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29882 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 526 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
        return -1;
      return 9383; /* avx512vl_getmantv16hf_mask */

    case E_V8HFmode:
      if (pattern407 (x2, 
E_V8HFmode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29882 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
        return -1;
      return 9386; /* avx512fp16_getmantv8hf_mask */

    case E_V16SFmode:
      if (pattern407 (x2, 
E_V16SFmode, 
E_HImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29882 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 9389; /* avx512f_getmantv16sf_mask */

    case E_V8SFmode:
      if (pattern407 (x2, 
E_V8SFmode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29882 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 9393; /* avx512vl_getmantv8sf_mask */

    case E_V4SFmode:
      if (pattern407 (x2, 
E_V4SFmode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29882 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 9396; /* avx512vl_getmantv4sf_mask */

    case E_V8DFmode:
      if (pattern407 (x2, 
E_V8DFmode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29882 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 529 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 9399; /* avx512f_getmantv8df_mask */

    case E_V4DFmode:
      if (pattern407 (x2, 
E_V4DFmode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29882 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 529 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 9403; /* avx512vl_getmantv4df_mask */

    case E_V2DFmode:
      if (pattern407 (x2, 
E_V2DFmode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29882 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 529 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 9406; /* avx512vl_getmantv2df_mask */

    default:
      return -1;
    }
}

 int
recog_121 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern422 (x2))
    {
    case 0:
      if (!(
#line 30433 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9585; /* vpshrdv_v32hi_mask */

    case 1:
      if (!(
#line 30433 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9586; /* vpshrdv_v16si_mask */

    case 2:
      if (!(
#line 30433 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9587; /* vpshrdv_v8di_mask */

    case 3:
      if (!(
#line 30433 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 759 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9588; /* vpshrdv_v16hi_mask */

    case 4:
      if (!(
#line 30433 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 759 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9589; /* vpshrdv_v8si_mask */

    case 5:
      if (!(
#line 30433 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 760 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9590; /* vpshrdv_v4di_mask */

    case 6:
      if (!(
#line 30433 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 760 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9591; /* vpshrdv_v8hi_mask */

    case 7:
      if (!(
#line 30433 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 761 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9592; /* vpshrdv_v4si_mask */

    case 8:
      if (!(
#line 30433 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 761 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9593; /* vpshrdv_v2di_mask */

    case 9:
      if (!(
#line 30463 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9594; /* vpshrdv_v32hi_maskz_1 */

    case 10:
      if (!(
#line 30463 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9595; /* vpshrdv_v16si_maskz_1 */

    case 11:
      if (!(
#line 30463 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9596; /* vpshrdv_v8di_maskz_1 */

    case 12:
      if (!(
#line 30463 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 759 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9597; /* vpshrdv_v16hi_maskz_1 */

    case 13:
      if (!(
#line 30463 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 759 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9598; /* vpshrdv_v8si_maskz_1 */

    case 14:
      if (!(
#line 30463 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 760 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9599; /* vpshrdv_v4di_maskz_1 */

    case 15:
      if (!(
#line 30463 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 760 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9600; /* vpshrdv_v8hi_maskz_1 */

    case 16:
      if (!(
#line 30463 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 761 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9601; /* vpshrdv_v4si_maskz_1 */

    case 17:
      if (!(
#line 30463 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 761 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9602; /* vpshrdv_v2di_maskz_1 */

    default:
      return -1;
    }
}

 int
recog_128 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (XINT (x3, 1))
    {
    case 192:
      x4 = XEXP (x2, 2);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[2] = x6;
      x7 = XVECEXP (x3, 0, 2);
      operands[3] = x7;
      if (!const_0_to_255_operand (operands[3], E_SImode))
        return -1;
      switch (pattern397 (x2))
        {
        case 0:
          if (!(
#line 4041 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V8HFmode))) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 2700; /* reducesv8hf */

        case 1:
          if (!
#line 4041 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V4SFmode))))
            return -1;
          return 2704; /* reducesv4sf */

        case 2:
          if (!(
#line 4041 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V2DFmode))) && 
#line 480 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 2708; /* reducesv2df */

        default:
          return -1;
        }

    case 59:
      x4 = XEXP (x2, 2);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[2] = x6;
      x7 = XVECEXP (x3, 0, 2);
      operands[3] = x7;
      if (!cmpps_imm_operand (operands[3], E_SImode))
        return -1;
      switch (pattern1009 (x2))
        {
        case 0:
          if (!
#line 4314 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 2744; /* avx_vmcmpv4sf3 */

        case 1:
          if (!(
#line 4314 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 475 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 2745; /* avx_vmcmpv2df3 */

        default:
          return -1;
        }

    case 133:
      return recog_118 (x1, insn, pnum_clobbers);

    case 217:
      switch (pattern411 (x2))
        {
        case 0:
          if (!(
#line 7147 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 555 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3804; /* fma_fmaddc_v32hf_maskz_1 */

        case 1:
          if (!(
#line 7147 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 555 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3812; /* fma_fmaddc_v16hf_maskz_1 */

        case 2:
          if (!(
#line 7147 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 555 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3819; /* fma_fmaddc_v8hf_maskz_1 */

        case 3:
          if (!(
#line 7285 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 555 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3846; /* avx512bw_fmaddc_v32hf_mask */

        case 4:
          if (!(
#line 7285 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 555 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3850; /* avx512vl_fmaddc_v16hf_mask */

        case 5:
          if (!(
#line 7285 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 555 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3854; /* avx512fp16_fmaddc_v8hf_mask */

        case 6:
          if (!
#line 7474 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
            return -1;
          return 3876; /* avx512fp16_fma_fmaddcsh_v8hf */

        default:
          return -1;
        }

    case 219:
      switch (pattern411 (x2))
        {
        case 0:
          if (!(
#line 7147 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 555 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3808; /* fma_fcmaddc_v32hf_maskz_1 */

        case 1:
          if (!(
#line 7147 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 555 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3816; /* fma_fcmaddc_v16hf_maskz_1 */

        case 2:
          if (!(
#line 7147 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 555 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3821; /* fma_fcmaddc_v8hf_maskz_1 */

        case 3:
          if (!(
#line 7285 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 555 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3848; /* avx512bw_fcmaddc_v32hf_mask */

        case 4:
          if (!(
#line 7285 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 555 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3852; /* avx512vl_fcmaddc_v16hf_mask */

        case 5:
          if (!(
#line 7285 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 555 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3855; /* avx512fp16_fcmaddc_v8hf_mask */

        case 6:
          if (!
#line 7474 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
            return -1;
          return 3880; /* avx512fp16_fma_fcmaddcsh_v8hf */

        default:
          return -1;
        }

    case 167:
      return recog_125 (x1, insn, pnum_clobbers);

    case 121:
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[2] = x6;
      x7 = XVECEXP (x3, 0, 2);
      operands[3] = x7;
      if (!const_0_to_255_mul_8_operand (operands[3], E_SImode))
        return -1;
      x8 = XEXP (x2, 1);
      operands[4] = x8;
      x4 = XEXP (x2, 2);
      operands[5] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V64QImode:
          if (pattern417 (x2, 
E_V64QImode, 
E_DImode) != 0
              || !(
#line 23223 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && (64 == 64 || TARGET_AVX512VL)) && 
#line 633 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 8006; /* avx512bw_palignrv64qi_mask */

        case E_V32QImode:
          if (pattern417 (x2, 
E_V32QImode, 
E_SImode) != 0
              || !(
#line 23223 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && (32 == 64 || TARGET_AVX512VL)) && 
#line 633 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 8007; /* avx2_palignrv32qi_mask */

        case E_V16QImode:
          if (pattern417 (x2, 
E_V16QImode, 
E_HImode) != 0
              || !
#line 23223 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && (16 == 64 || TARGET_AVX512VL)))
            return -1;
          return 8008; /* ssse3_palignrv16qi_mask */

        default:
          return -1;
        }

    case 128:
      switch (pattern413 (x2, 
E_SImode))
        {
        case 0:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 23817 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 8089; /* avx10_2_mpsadbw_mask */

        case 1:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 23829 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 601 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 8091; /* avx2_mpsadbw_mask */

        case 2:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 23829 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
            return -1;
          return 8093; /* sse4_1_mpsadbw_mask */

        default:
          return -1;
        }

    case 155:
      return recog_117 (x1, insn, pnum_clobbers);

    case 194:
      return recog_122 (x1, insn, pnum_clobbers);

    case 166:
      x4 = XEXP (x2, 2);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[2] = x6;
      x7 = XVECEXP (x3, 0, 2);
      operands[3] = x7;
      if (!const_0_to_15_operand (operands[3], E_SImode))
        return -1;
      switch (pattern397 (x2))
        {
        case 0:
          if (!(
#line 29903 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 9407; /* avx512f_vgetmantv8hf */

        case 1:
          if (!
#line 29903 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return -1;
          return 9411; /* avx512f_vgetmantv4sf */

        case 2:
          if (!(
#line 29903 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 480 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 9415; /* avx512f_vgetmantv2df */

        default:
          return -1;
        }

    case 186:
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[2] = x6;
      x7 = XVECEXP (x3, 0, 2);
      operands[3] = x7;
      if (!const_0_to_255_operand (operands[3], E_SImode))
        return -1;
      x8 = XEXP (x2, 1);
      operands[4] = x8;
      x4 = XEXP (x2, 2);
      operands[5] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern1181 (x2, 
E_QImode, 
E_V8HImode, 
E_V16QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29924 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 686 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9420; /* avx512bw_dbpsadbwv8hi_mask */

        case E_V16HImode:
          if (pattern1181 (x2, 
E_HImode, 
E_V16HImode, 
E_V32QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29924 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 686 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9422; /* avx512bw_dbpsadbwv16hi_mask */

        case E_V32HImode:
          if (pattern1181 (x2, 
E_SImode, 
E_V32HImode, 
E_V64QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29924 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 686 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 9424; /* avx512bw_dbpsadbwv32hi_mask */

        default:
          return -1;
        }

    case 195:
      switch (pattern416 (x2))
        {
        case 0:
          if (!(
#line 30242 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512IFMA) && 
#line 624 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9480; /* vpmadd52luqv8di_maskz_1 */

        case 1:
          if (!(
#line 30242 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512IFMA) && 
#line 624 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9482; /* vpmadd52luqv4di_maskz_1 */

        case 2:
          if (!(
#line 30242 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512IFMA) && 
#line 624 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9484; /* vpmadd52luqv2di_maskz_1 */

        case 3:
          if (!(
#line 30258 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512IFMA) && 
#line 624 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9486; /* vpmadd52luqv8di_mask */

        case 4:
          if (!(
#line 30258 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512IFMA) && 
#line 624 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9488; /* vpmadd52luqv4di_mask */

        case 5:
          if (!(
#line 30258 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512IFMA) && 
#line 624 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9490; /* vpmadd52luqv2di_mask */

        default:
          return -1;
        }

    case 196:
      switch (pattern416 (x2))
        {
        case 0:
          if (!(
#line 30242 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512IFMA) && 
#line 624 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9481; /* vpmadd52huqv8di_maskz_1 */

        case 1:
          if (!(
#line 30242 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512IFMA) && 
#line 624 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9483; /* vpmadd52huqv4di_maskz_1 */

        case 2:
          if (!(
#line 30242 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512IFMA) && 
#line 624 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9485; /* vpmadd52huqv2di_maskz_1 */

        case 3:
          if (!(
#line 30258 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512IFMA) && 
#line 624 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9487; /* vpmadd52huqv8di_mask */

        case 4:
          if (!(
#line 30258 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512IFMA) && 
#line 624 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9489; /* vpmadd52huqv4di_mask */

        case 5:
          if (!(
#line 30258 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512IFMA) && 
#line 624 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9491; /* vpmadd52huqv2di_mask */

        default:
          return -1;
        }

    case 198:
      switch (pattern413 (x2, 
E_VOIDmode))
        {
        case 0:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30346 "../../../gcc/config/i386/sse.md"
(TARGET_GFNI) && 
#line 636 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 9523; /* vgf2p8affineinvqb_v64qi_mask */

        case 1:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30346 "../../../gcc/config/i386/sse.md"
(TARGET_GFNI) && 
#line 636 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 9525; /* vgf2p8affineinvqb_v32qi_mask */

        case 2:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 30346 "../../../gcc/config/i386/sse.md"
(TARGET_GFNI)))
            return -1;
          return 9527; /* vgf2p8affineinvqb_v16qi_mask */

        default:
          return -1;
        }

    case 199:
      switch (pattern413 (x2, 
E_VOIDmode))
        {
        case 0:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30363 "../../../gcc/config/i386/sse.md"
(TARGET_GFNI) && 
#line 636 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 9529; /* vgf2p8affineqb_v64qi_mask */

        case 1:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30363 "../../../gcc/config/i386/sse.md"
(TARGET_GFNI) && 
#line 636 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 9531; /* vgf2p8affineqb_v32qi_mask */

        case 2:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 30363 "../../../gcc/config/i386/sse.md"
(TARGET_GFNI)))
            return -1;
          return 9533; /* vgf2p8affineqb_v16qi_mask */

        default:
          return -1;
        }

    case 202:
      return recog_126 (x1, insn, pnum_clobbers);

    case 201:
      return recog_127 (x1, insn, pnum_clobbers);

    case 203:
      return recog_121 (x1, insn, pnum_clobbers);

    case 204:
      return recog_120 (x1, insn, pnum_clobbers);

    case 205:
      switch (pattern423 (x2))
        {
        case 0:
          if (!(
#line 30609 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 675 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9633; /* vpdpbusd_v16si_mask */

        case 1:
          if (!(
#line 30609 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 675 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9634; /* vpdpbusd_v8si_mask */

        case 2:
          if (!(
#line 30609 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 675 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9635; /* vpdpbusd_v4si_mask */

        case 3:
          if (!(
#line 30638 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 675 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9636; /* vpdpbusd_v16si_maskz_1 */

        case 4:
          if (!(
#line 30638 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 675 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9637; /* vpdpbusd_v8si_maskz_1 */

        case 5:
          if (!(
#line 30638 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 675 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9638; /* vpdpbusd_v4si_maskz_1 */

        default:
          return -1;
        }

    case 206:
      switch (pattern423 (x2))
        {
        case 0:
          if (!(
#line 30678 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 675 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9642; /* vpdpbusds_v16si_mask */

        case 1:
          if (!(
#line 30678 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 675 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9643; /* vpdpbusds_v8si_mask */

        case 2:
          if (!(
#line 30678 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 675 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9644; /* vpdpbusds_v4si_mask */

        case 3:
          if (!(
#line 30707 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 675 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9645; /* vpdpbusds_v16si_maskz_1 */

        case 4:
          if (!(
#line 30707 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 675 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9646; /* vpdpbusds_v8si_maskz_1 */

        case 5:
          if (!(
#line 30707 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 675 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9647; /* vpdpbusds_v4si_maskz_1 */

        default:
          return -1;
        }

    case 207:
      switch (pattern423 (x2))
        {
        case 0:
          if (!(
#line 30747 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 675 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9651; /* vpdpwssd_v16si_mask */

        case 1:
          if (!(
#line 30747 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 675 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9652; /* vpdpwssd_v8si_mask */

        case 2:
          if (!(
#line 30747 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 675 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9653; /* vpdpwssd_v4si_mask */

        case 3:
          if (!(
#line 30776 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 675 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9654; /* vpdpwssd_v16si_maskz_1 */

        case 4:
          if (!(
#line 30776 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 675 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9655; /* vpdpwssd_v8si_maskz_1 */

        case 5:
          if (!(
#line 30776 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 675 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9656; /* vpdpwssd_v4si_maskz_1 */

        default:
          return -1;
        }

    case 208:
      switch (pattern423 (x2))
        {
        case 0:
          if (!(
#line 30816 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 675 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9660; /* vpdpwssds_v16si_mask */

        case 1:
          if (!(
#line 30816 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 675 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9661; /* vpdpwssds_v8si_mask */

        case 2:
          if (!(
#line 30816 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 675 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9662; /* vpdpwssds_v4si_mask */

        case 3:
          if (!(
#line 30845 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 675 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9663; /* vpdpwssds_v16si_maskz_1 */

        case 4:
          if (!(
#line 30845 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 675 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9664; /* vpdpwssds_v8si_maskz_1 */

        case 5:
          if (!(
#line 30845 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 675 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9665; /* vpdpwssds_v4si_maskz_1 */

        default:
          return -1;
        }

    case 216:
      return recog_123 (x1, insn, pnum_clobbers);

    case 227:
      switch (pattern425 (x2))
        {
        case 0:
          if (!(
#line 31586 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 678 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 9746; /* vpdpbssd_v16si_mask */

        case 1:
          if (!
#line 31586 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9752; /* vpdpbssd_v8si_mask */

        case 2:
          if (!
#line 31586 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9758; /* vpdpbssd_v4si_mask */

        case 3:
          if (!(
#line 31613 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 678 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 9764; /* *vpdpbssd_v16si_maskz */

        case 4:
          if (!
#line 31613 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9770; /* *vpdpbssd_v8si_maskz */

        case 5:
          if (!
#line 31613 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9776; /* *vpdpbssd_v4si_maskz */

        default:
          return -1;
        }

    case 228:
      switch (pattern425 (x2))
        {
        case 0:
          if (!(
#line 31586 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 678 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 9747; /* vpdpbssds_v16si_mask */

        case 1:
          if (!
#line 31586 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9753; /* vpdpbssds_v8si_mask */

        case 2:
          if (!
#line 31586 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9759; /* vpdpbssds_v4si_mask */

        case 3:
          if (!(
#line 31613 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 678 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 9765; /* *vpdpbssds_v16si_maskz */

        case 4:
          if (!
#line 31613 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9771; /* *vpdpbssds_v8si_maskz */

        case 5:
          if (!
#line 31613 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9777; /* *vpdpbssds_v4si_maskz */

        default:
          return -1;
        }

    case 229:
      switch (pattern425 (x2))
        {
        case 0:
          if (!(
#line 31586 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 678 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 9748; /* vpdpbsud_v16si_mask */

        case 1:
          if (!
#line 31586 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9754; /* vpdpbsud_v8si_mask */

        case 2:
          if (!
#line 31586 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9760; /* vpdpbsud_v4si_mask */

        case 3:
          if (!(
#line 31613 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 678 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 9766; /* *vpdpbsud_v16si_maskz */

        case 4:
          if (!
#line 31613 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9772; /* *vpdpbsud_v8si_maskz */

        case 5:
          if (!
#line 31613 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9778; /* *vpdpbsud_v4si_maskz */

        default:
          return -1;
        }

    case 230:
      switch (pattern425 (x2))
        {
        case 0:
          if (!(
#line 31586 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 678 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 9749; /* vpdpbsuds_v16si_mask */

        case 1:
          if (!
#line 31586 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9755; /* vpdpbsuds_v8si_mask */

        case 2:
          if (!
#line 31586 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9761; /* vpdpbsuds_v4si_mask */

        case 3:
          if (!(
#line 31613 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 678 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 9767; /* *vpdpbsuds_v16si_maskz */

        case 4:
          if (!
#line 31613 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9773; /* *vpdpbsuds_v8si_maskz */

        case 5:
          if (!
#line 31613 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9779; /* *vpdpbsuds_v4si_maskz */

        default:
          return -1;
        }

    case 231:
      switch (pattern425 (x2))
        {
        case 0:
          if (!(
#line 31586 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 678 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 9750; /* vpdpbuud_v16si_mask */

        case 1:
          if (!
#line 31586 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9756; /* vpdpbuud_v8si_mask */

        case 2:
          if (!
#line 31586 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9762; /* vpdpbuud_v4si_mask */

        case 3:
          if (!(
#line 31613 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 678 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 9768; /* *vpdpbuud_v16si_maskz */

        case 4:
          if (!
#line 31613 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9774; /* *vpdpbuud_v8si_maskz */

        case 5:
          if (!
#line 31613 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9780; /* *vpdpbuud_v4si_maskz */

        default:
          return -1;
        }

    case 232:
      switch (pattern425 (x2))
        {
        case 0:
          if (!(
#line 31586 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 678 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 9751; /* vpdpbuuds_v16si_mask */

        case 1:
          if (!
#line 31586 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9757; /* vpdpbuuds_v8si_mask */

        case 2:
          if (!
#line 31586 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9763; /* vpdpbuuds_v4si_mask */

        case 3:
          if (!(
#line 31613 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 678 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 9769; /* *vpdpbuuds_v16si_maskz */

        case 4:
          if (!
#line 31613 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9775; /* *vpdpbuuds_v8si_maskz */

        case 5:
          if (!
#line 31613 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9781; /* *vpdpbuuds_v4si_maskz */

        default:
          return -1;
        }

    case 233:
      switch (pattern425 (x2))
        {
        case 0:
          if (!(
#line 31995 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 678 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 9900; /* vpdpwusd_v16si_mask */

        case 1:
          if (!
#line 31995 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9906; /* vpdpwusd_v8si_mask */

        case 2:
          if (!
#line 31995 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9912; /* vpdpwusd_v4si_mask */

        case 3:
          if (!(
#line 32022 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 678 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 9918; /* *vpdpwusd_v16si_maskz */

        case 4:
          if (!
#line 32022 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9924; /* *vpdpwusd_v8si_maskz */

        case 5:
          if (!
#line 32022 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9930; /* *vpdpwusd_v4si_maskz */

        default:
          return -1;
        }

    case 234:
      switch (pattern425 (x2))
        {
        case 0:
          if (!(
#line 31995 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 678 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 9901; /* vpdpwusds_v16si_mask */

        case 1:
          if (!
#line 31995 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9907; /* vpdpwusds_v8si_mask */

        case 2:
          if (!
#line 31995 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9913; /* vpdpwusds_v4si_mask */

        case 3:
          if (!(
#line 32022 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 678 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 9919; /* *vpdpwusds_v16si_maskz */

        case 4:
          if (!
#line 32022 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9925; /* *vpdpwusds_v8si_maskz */

        case 5:
          if (!
#line 32022 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9931; /* *vpdpwusds_v4si_maskz */

        default:
          return -1;
        }

    case 235:
      switch (pattern425 (x2))
        {
        case 0:
          if (!(
#line 31995 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 678 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 9902; /* vpdpwsud_v16si_mask */

        case 1:
          if (!
#line 31995 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9908; /* vpdpwsud_v8si_mask */

        case 2:
          if (!
#line 31995 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9914; /* vpdpwsud_v4si_mask */

        case 3:
          if (!(
#line 32022 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 678 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 9920; /* *vpdpwsud_v16si_maskz */

        case 4:
          if (!
#line 32022 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9926; /* *vpdpwsud_v8si_maskz */

        case 5:
          if (!
#line 32022 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9932; /* *vpdpwsud_v4si_maskz */

        default:
          return -1;
        }

    case 236:
      switch (pattern425 (x2))
        {
        case 0:
          if (!(
#line 31995 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 678 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 9903; /* vpdpwsuds_v16si_mask */

        case 1:
          if (!
#line 31995 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9909; /* vpdpwsuds_v8si_mask */

        case 2:
          if (!
#line 31995 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9915; /* vpdpwsuds_v4si_mask */

        case 3:
          if (!(
#line 32022 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 678 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 9921; /* *vpdpwsuds_v16si_maskz */

        case 4:
          if (!
#line 32022 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9927; /* *vpdpwsuds_v8si_maskz */

        case 5:
          if (!
#line 32022 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9933; /* *vpdpwsuds_v4si_maskz */

        default:
          return -1;
        }

    case 237:
      switch (pattern425 (x2))
        {
        case 0:
          if (!(
#line 31995 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 678 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 9904; /* vpdpwuud_v16si_mask */

        case 1:
          if (!
#line 31995 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9910; /* vpdpwuud_v8si_mask */

        case 2:
          if (!
#line 31995 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9916; /* vpdpwuud_v4si_mask */

        case 3:
          if (!(
#line 32022 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 678 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 9922; /* *vpdpwuud_v16si_maskz */

        case 4:
          if (!
#line 32022 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9928; /* *vpdpwuud_v8si_maskz */

        case 5:
          if (!
#line 32022 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9934; /* *vpdpwuud_v4si_maskz */

        default:
          return -1;
        }

    case 238:
      switch (pattern425 (x2))
        {
        case 0:
          if (!(
#line 31995 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 678 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 9905; /* vpdpwuuds_v16si_mask */

        case 1:
          if (!
#line 31995 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9911; /* vpdpwuuds_v8si_mask */

        case 2:
          if (!
#line 31995 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9917; /* vpdpwuuds_v4si_mask */

        case 3:
          if (!(
#line 32022 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 678 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 9923; /* *vpdpwuuds_v16si_maskz */

        case 4:
          if (!
#line 32022 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9929; /* *vpdpwuuds_v8si_maskz */

        case 5:
          if (!
#line 32022 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9935; /* *vpdpwuuds_v4si_maskz */

        default:
          return -1;
        }

    case 244:
      return recog_124 (x1, insn, pnum_clobbers);

    case 278:
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[2] = x6;
      x7 = XVECEXP (x3, 0, 2);
      operands[3] = x7;
      if (!const_0_to_255_operand (operands[3], E_SImode))
        return -1;
      x8 = XEXP (x2, 1);
      operands[4] = x8;
      x4 = XEXP (x2, 2);
      operands[5] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V32BFmode:
          if (pattern1182 (x2, 
E_SImode, 
E_V32BFmode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32637 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 565 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
            return -1;
          return 10283; /* avx10_2_minmaxnepbf16_v32bf_mask */

        case E_V16BFmode:
          if (pattern1182 (x2, 
E_HImode, 
E_V16BFmode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32637 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
            return -1;
          return 10285; /* avx10_2_minmaxnepbf16_v16bf_mask */

        case E_V8BFmode:
          if (pattern1182 (x2, 
E_QImode, 
E_V8BFmode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32637 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
            return -1;
          return 10287; /* avx10_2_minmaxnepbf16_v8bf_mask */

        default:
          return -1;
        }

    case 279:
      return recog_119 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_151 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 1);
  switch (XVECLEN (x6, 0))
    {
    case 16:
      x7 = XVECEXP (x6, 0, 0);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x6, 0, 1);
      if (GET_CODE (x8) == CONST_INT)
        {
          res = recog_146 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x7;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      operands[4] = x8;
      x10 = XVECEXP (x6, 0, 2);
      operands[5] = x10;
      x11 = XVECEXP (x6, 0, 3);
      operands[6] = x11;
      x12 = XVECEXP (x6, 0, 4);
      operands[7] = x12;
      x13 = XVECEXP (x6, 0, 5);
      operands[8] = x13;
      x14 = XVECEXP (x6, 0, 6);
      operands[9] = x14;
      x15 = XVECEXP (x6, 0, 7);
      operands[10] = x15;
      x16 = XVECEXP (x6, 0, 8);
      operands[11] = x16;
      x17 = XVECEXP (x6, 0, 9);
      operands[12] = x17;
      x18 = XVECEXP (x6, 0, 10);
      operands[13] = x18;
      x19 = XVECEXP (x6, 0, 11);
      operands[14] = x19;
      x20 = XVECEXP (x6, 0, 12);
      operands[15] = x20;
      x21 = XVECEXP (x6, 0, 13);
      operands[16] = x21;
      x22 = XVECEXP (x6, 0, 14);
      operands[17] = x22;
      x23 = XVECEXP (x6, 0, 15);
      operands[18] = x23;
      x24 = XEXP (x2, 1);
      operands[19] = x24;
      x25 = XEXP (x2, 2);
      operands[20] = x25;
      if (!register_operand (operands[20], E_HImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SFmode:
          if (pattern1505 (x2, 
E_V16SFmode, 
E_V32SFmode) != 0
              || !nonimm_or_0_operand (operands[19], E_V16SFmode))
            return -1;
          if (const_0_to_3_operand (operands[3], E_VOIDmode)
              && const_0_to_3_operand (operands[4], E_VOIDmode)
              && const_16_to_19_operand (operands[5], E_VOIDmode)
              && const_16_to_19_operand (operands[6], E_VOIDmode)
              && const_4_to_7_operand (operands[7], E_VOIDmode)
              && const_4_to_7_operand (operands[8], E_VOIDmode)
              && const_20_to_23_operand (operands[9], E_VOIDmode)
              && const_20_to_23_operand (operands[10], E_VOIDmode)
              && const_8_to_11_operand (operands[11], E_VOIDmode)
              && const_8_to_11_operand (operands[12], E_VOIDmode)
              && const_24_to_27_operand (operands[13], E_VOIDmode)
              && const_24_to_27_operand (operands[14], E_VOIDmode)
              && const_12_to_15_operand (operands[15], E_VOIDmode)
              && const_12_to_15_operand (operands[16], E_VOIDmode)
              && const_28_to_31_operand (operands[17], E_VOIDmode)
              && const_28_to_31_operand (operands[18], E_VOIDmode)
              && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 14284 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512
   && (INTVAL (operands[3]) == (INTVAL (operands[7]) - 4)
       && INTVAL (operands[4]) == (INTVAL (operands[8]) - 4)
       && INTVAL (operands[5]) == (INTVAL (operands[9]) - 4)
       && INTVAL (operands[6]) == (INTVAL (operands[10]) - 4)
       && INTVAL (operands[3]) == (INTVAL (operands[11]) - 8)
       && INTVAL (operands[4]) == (INTVAL (operands[12]) - 8)
       && INTVAL (operands[5]) == (INTVAL (operands[13]) - 8)
       && INTVAL (operands[6]) == (INTVAL (operands[14]) - 8)
       && INTVAL (operands[3]) == (INTVAL (operands[15]) - 12)
       && INTVAL (operands[4]) == (INTVAL (operands[16]) - 12)
       && INTVAL (operands[5]) == (INTVAL (operands[17]) - 12)
       && INTVAL (operands[6]) == (INTVAL (operands[18]) - 12)))))
            return 6610; /* avx512f_shufps512_1_mask */
          if (!const_0_to_15_operand (operands[3], E_VOIDmode)
              || pattern1728 () != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20413 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[3]) & 3) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && INTVAL (operands[3]) == INTVAL (operands[5]) - 2
   && INTVAL (operands[3]) == INTVAL (operands[6]) - 3
   && (INTVAL (operands[7]) & 3) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && INTVAL (operands[7]) == INTVAL (operands[9]) - 2
   && INTVAL (operands[7]) == INTVAL (operands[10]) - 3
   && (INTVAL (operands[11]) & 3) == 0
   && INTVAL (operands[11]) == INTVAL (operands[12]) - 1
   && INTVAL (operands[11]) == INTVAL (operands[13]) - 2
   && INTVAL (operands[11]) == INTVAL (operands[14]) - 3
   && (INTVAL (operands[15]) & 3) == 0
   && INTVAL (operands[15]) == INTVAL (operands[16]) - 1
   && INTVAL (operands[15]) == INTVAL (operands[17]) - 2
   && INTVAL (operands[15]) == INTVAL (operands[18]) - 3) && 
#line 722 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7845; /* avx512f_shuf_f32x4_1_mask */

        case E_V16SImode:
          if (pattern1505 (x2, 
E_V16SImode, 
E_V32SImode) != 0
              || !const_0_to_15_operand (operands[3], E_VOIDmode)
              || pattern1728 () != 0
              || !nonimm_or_0_operand (operands[19], E_V16SImode)
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20413 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[3]) & 3) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && INTVAL (operands[3]) == INTVAL (operands[5]) - 2
   && INTVAL (operands[3]) == INTVAL (operands[6]) - 3
   && (INTVAL (operands[7]) & 3) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && INTVAL (operands[7]) == INTVAL (operands[9]) - 2
   && INTVAL (operands[7]) == INTVAL (operands[10]) - 3
   && (INTVAL (operands[11]) & 3) == 0
   && INTVAL (operands[11]) == INTVAL (operands[12]) - 1
   && INTVAL (operands[11]) == INTVAL (operands[13]) - 2
   && INTVAL (operands[11]) == INTVAL (operands[14]) - 3
   && (INTVAL (operands[15]) & 3) == 0
   && INTVAL (operands[15]) == INTVAL (operands[16]) - 1
   && INTVAL (operands[15]) == INTVAL (operands[17]) - 2
   && INTVAL (operands[15]) == INTVAL (operands[18]) - 3) && 
#line 722 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7847; /* avx512f_shuf_i32x4_1_mask */

        default:
          return -1;
        }

    case 8:
      x7 = XVECEXP (x6, 0, 0);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x6, 0, 1);
      if (GET_CODE (x8) == CONST_INT)
        {
          res = recog_147 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x7;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      operands[4] = x8;
      x10 = XVECEXP (x6, 0, 2);
      operands[5] = x10;
      x11 = XVECEXP (x6, 0, 3);
      operands[6] = x11;
      x12 = XVECEXP (x6, 0, 4);
      operands[7] = x12;
      x13 = XVECEXP (x6, 0, 5);
      operands[8] = x13;
      x14 = XVECEXP (x6, 0, 6);
      operands[9] = x14;
      x15 = XVECEXP (x6, 0, 7);
      operands[10] = x15;
      x24 = XEXP (x2, 1);
      operands[11] = x24;
      x25 = XEXP (x2, 2);
      operands[12] = x25;
      if (!register_operand (operands[12], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (pattern1615 (x2, 
E_V8SFmode, 
E_V16SFmode) != 0)
            return -1;
          if (const_0_to_3_operand (operands[3], E_VOIDmode)
              && const_0_to_3_operand (operands[4], E_VOIDmode)
              && const_8_to_11_operand (operands[5], E_VOIDmode)
              && const_8_to_11_operand (operands[6], E_VOIDmode)
              && const_4_to_7_operand (operands[7], E_VOIDmode)
              && const_4_to_7_operand (operands[8], E_VOIDmode)
              && const_12_to_15_operand (operands[9], E_VOIDmode)
              && const_12_to_15_operand (operands[10], E_VOIDmode)
              && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 11477 "../../../gcc/config/i386/sse.md"
(TARGET_AVX
   && TARGET_AVX512VL
   && (INTVAL (operands[3]) == (INTVAL (operands[7]) - 4)
       && INTVAL (operands[4]) == (INTVAL (operands[8]) - 4)
       && INTVAL (operands[5]) == (INTVAL (operands[9]) - 4)
       && INTVAL (operands[6]) == (INTVAL (operands[10]) - 4)))))
            return 4692; /* avx_shufps256_1_mask */
          if (!const_0_to_7_operand (operands[3], E_VOIDmode)
              || pattern1705 () != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 20334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL
   && (INTVAL (operands[3]) & 3) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && INTVAL (operands[3]) == INTVAL (operands[5]) - 2
   && INTVAL (operands[3]) == INTVAL (operands[6]) - 3
   && (INTVAL (operands[7]) & 3) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && INTVAL (operands[7]) == INTVAL (operands[9]) - 2
   && INTVAL (operands[7]) == INTVAL (operands[10]) - 3)))
            return -1;
          return 7843; /* avx512vl_shuf_f32x4_1_mask */

        case E_V8DFmode:
          if (pattern1615 (x2, 
E_V8DFmode, 
E_V16DFmode) != 0)
            return -1;
          if (const_0_to_1_operand (operands[3], E_VOIDmode)
              && const_8_to_9_operand (operands[4], E_VOIDmode)
              && const_2_to_3_operand (operands[5], E_VOIDmode)
              && const_10_to_11_operand (operands[6], E_VOIDmode)
              && const_4_to_5_operand (operands[7], E_VOIDmode)
              && const_12_to_13_operand (operands[8], E_VOIDmode)
              && const_6_to_7_operand (operands[9], E_VOIDmode)
              && const_14_to_15_operand (operands[10], E_VOIDmode)
              && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 14349 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return 6612; /* avx512f_shufpd512_1_mask */
          if (!const_0_to_7_operand (operands[3], E_VOIDmode)
              || pattern1705 () != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20236 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[3]) & 1) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && (INTVAL (operands[5]) & 1) == 0
   && INTVAL (operands[5]) == INTVAL (operands[6]) - 1
   && (INTVAL (operands[7]) & 1) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && (INTVAL (operands[9]) & 1) == 0
   && INTVAL (operands[9]) == INTVAL (operands[10]) - 1) && 
#line 718 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7833; /* avx512f_shuf_f64x2_1_mask */

        case E_V8DImode:
          if (pattern1616 (x2, 
E_V8DImode, 
E_V16DImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20236 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[3]) & 1) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && (INTVAL (operands[5]) & 1) == 0
   && INTVAL (operands[5]) == INTVAL (operands[6]) - 1
   && (INTVAL (operands[7]) & 1) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && (INTVAL (operands[9]) & 1) == 0
   && INTVAL (operands[9]) == INTVAL (operands[10]) - 1) && 
#line 718 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7835; /* avx512f_shuf_i64x2_1_mask */

        case E_V8SImode:
          if (pattern1616 (x2, 
E_V8SImode, 
E_V16SImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 20334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL
   && (INTVAL (operands[3]) & 3) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && INTVAL (operands[3]) == INTVAL (operands[5]) - 2
   && INTVAL (operands[3]) == INTVAL (operands[6]) - 3
   && (INTVAL (operands[7]) & 3) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && INTVAL (operands[7]) == INTVAL (operands[9]) - 2
   && INTVAL (operands[7]) == INTVAL (operands[10]) - 3)))
            return -1;
          return 7841; /* avx512vl_shuf_i32x4_1_mask */

        default:
          return -1;
        }

    case 4:
      x7 = XVECEXP (x6, 0, 0);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x6, 0, 1);
      if (GET_CODE (x8) == CONST_INT)
        {
          res = recog_148 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x7;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      operands[4] = x8;
      x10 = XVECEXP (x6, 0, 2);
      operands[5] = x10;
      x11 = XVECEXP (x6, 0, 3);
      operands[6] = x11;
      x24 = XEXP (x2, 1);
      operands[7] = x24;
      x25 = XEXP (x2, 2);
      operands[8] = x25;
      if (!register_operand (operands[8], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern1504 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
              || !
#line 11530 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 4693; /* sse_shufps_v4sf_mask */

        case E_V4DFmode:
          if (pattern1505 (x2, 
E_V4DFmode, 
E_V8DFmode) != 0
              || !nonimm_or_0_operand (operands[7], E_V4DFmode))
            return -1;
          if (const_0_to_1_operand (operands[3], E_VOIDmode)
              && const_4_to_5_operand (operands[4], E_VOIDmode)
              && const_2_to_3_operand (operands[5], E_VOIDmode)
              && const_6_to_7_operand (operands[6], E_VOIDmode)
              && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 14398 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && TARGET_AVX512VL)))
            return 6614; /* avx_shufpd256_1_mask */
          if (!const_0_to_3_operand (operands[3], E_VOIDmode)
              || !const_0_to_3_operand (operands[4], E_VOIDmode)
              || !const_4_to_7_operand (operands[5], E_VOIDmode)
              || !const_4_to_7_operand (operands[6], E_VOIDmode)
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 20179 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL
   && (INTVAL (operands[3]) & 1) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && (INTVAL (operands[5]) & 1) == 0
   && INTVAL (operands[5]) == INTVAL (operands[6]) - 1)))
            return -1;
          return 7831; /* avx512dq_shuf_f64x2_1_mask */

        case E_V4DImode:
          if (pattern1504 (x2, 
E_V4DImode, 
E_V8DImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 20179 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL
   && (INTVAL (operands[3]) & 1) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && (INTVAL (operands[5]) & 1) == 0
   && INTVAL (operands[5]) == INTVAL (operands[6]) - 1)))
            return -1;
          return 7829; /* avx512dq_shuf_i64x2_1_mask */

        default:
          return -1;
        }

    case 2:
      x7 = XVECEXP (x6, 0, 0);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x6, 0, 1);
      if (GET_CODE (x8) == CONST_INT)
        {
          res = recog_149 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x7;
      if (!const_0_to_1_operand (operands[3], E_VOIDmode)
          || pattern1113 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0)
        return -1;
      operands[4] = x8;
      if (!const_2_to_3_operand (operands[4], E_VOIDmode))
        return -1;
      x24 = XEXP (x2, 1);
      operands[5] = x24;
      if (!nonimm_or_0_operand (operands[5], E_V2DFmode))
        return -1;
      x25 = XEXP (x2, 2);
      operands[6] = x25;
      if (!register_operand (operands[6], E_QImode)
          || !
#line 14440 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return -1;
      return 6615; /* sse2_shufpd_v2df_mask */

    case 64:
      return recog_150 (x1, insn, pnum_clobbers);

    case 32:
      if (pattern822 (x6) != 0)
        return -1;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      x24 = XEXP (x2, 1);
      operands[3] = x24;
      x25 = XEXP (x2, 2);
      operands[4] = x25;
      if (!register_operand (operands[4], E_SImode))
        return -1;
      x7 = XVECEXP (x6, 0, 0);
      switch (XWINT (x7, 0))
        {
        case 8LL:
          x8 = XVECEXP (x6, 0, 1);
          if (XWINT (x8, 0) != 40LL)
            return -1;
          x10 = XVECEXP (x6, 0, 2);
          if (XWINT (x10, 0) != 9LL)
            return -1;
          x11 = XVECEXP (x6, 0, 3);
          if (XWINT (x11, 0) != 41LL)
            return -1;
          x12 = XVECEXP (x6, 0, 4);
          if (XWINT (x12, 0) != 10LL)
            return -1;
          x13 = XVECEXP (x6, 0, 5);
          if (XWINT (x13, 0) != 42LL)
            return -1;
          x14 = XVECEXP (x6, 0, 6);
          if (XWINT (x14, 0) != 11LL)
            return -1;
          x15 = XVECEXP (x6, 0, 7);
          if (XWINT (x15, 0) != 43LL
              || pattern1743 (x6) != 0)
            return -1;
          x26 = XVECEXP (x6, 0, 16);
          if (XWINT (x26, 0) != 24LL)
            return -1;
          x27 = XVECEXP (x6, 0, 17);
          if (XWINT (x27, 0) != 56LL)
            return -1;
          x28 = XVECEXP (x6, 0, 18);
          if (XWINT (x28, 0) != 25LL)
            return -1;
          x29 = XVECEXP (x6, 0, 19);
          if (XWINT (x29, 0) != 57LL)
            return -1;
          x30 = XVECEXP (x6, 0, 20);
          if (XWINT (x30, 0) != 26LL)
            return -1;
          x31 = XVECEXP (x6, 0, 21);
          if (XWINT (x31, 0) != 58LL)
            return -1;
          x32 = XVECEXP (x6, 0, 22);
          if (XWINT (x32, 0) != 27LL)
            return -1;
          x33 = XVECEXP (x6, 0, 23);
          if (XWINT (x33, 0) != 59LL
              || pattern1748 (x6) != 0
              || pattern1450 (x2, 
E_V32QImode, 
E_V64QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19452 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL && TARGET_AVX512BW)))
            return -1;
          return 7737; /* avx2_interleave_highv32qi_mask */

        case 0LL:
          x8 = XVECEXP (x6, 0, 1);
          if (XWINT (x8, 0) != 32LL)
            return -1;
          x10 = XVECEXP (x6, 0, 2);
          if (XWINT (x10, 0) != 1LL)
            return -1;
          x11 = XVECEXP (x6, 0, 3);
          if (XWINT (x11, 0) != 33LL)
            return -1;
          x12 = XVECEXP (x6, 0, 4);
          if (XWINT (x12, 0) != 2LL)
            return -1;
          x13 = XVECEXP (x6, 0, 5);
          if (XWINT (x13, 0) != 34LL)
            return -1;
          x14 = XVECEXP (x6, 0, 6);
          if (XWINT (x14, 0) != 3LL)
            return -1;
          x15 = XVECEXP (x6, 0, 7);
          if (XWINT (x15, 0) != 35LL)
            return -1;
          x26 = XVECEXP (x6, 0, 16);
          if (XWINT (x26, 0) != 16LL)
            return -1;
          x27 = XVECEXP (x6, 0, 17);
          if (XWINT (x27, 0) != 48LL)
            return -1;
          x28 = XVECEXP (x6, 0, 18);
          if (XWINT (x28, 0) != 17LL)
            return -1;
          x29 = XVECEXP (x6, 0, 19);
          if (XWINT (x29, 0) != 49LL)
            return -1;
          x30 = XVECEXP (x6, 0, 20);
          if (XWINT (x30, 0) != 18LL)
            return -1;
          x31 = XVECEXP (x6, 0, 21);
          if (XWINT (x31, 0) != 50LL)
            return -1;
          x32 = XVECEXP (x6, 0, 22);
          if (XWINT (x32, 0) != 19LL)
            return -1;
          x33 = XVECEXP (x6, 0, 23);
          if (XWINT (x33, 0) != 51LL)
            return -1;
          x16 = XVECEXP (x6, 0, 8);
          switch (XWINT (x16, 0))
            {
            case 4LL:
              x17 = XVECEXP (x6, 0, 9);
              if (XWINT (x17, 0) != 36LL)
                return -1;
              x18 = XVECEXP (x6, 0, 10);
              if (XWINT (x18, 0) != 5LL)
                return -1;
              x19 = XVECEXP (x6, 0, 11);
              if (XWINT (x19, 0) != 37LL)
                return -1;
              x20 = XVECEXP (x6, 0, 12);
              if (XWINT (x20, 0) != 6LL)
                return -1;
              x21 = XVECEXP (x6, 0, 13);
              if (XWINT (x21, 0) != 38LL)
                return -1;
              x22 = XVECEXP (x6, 0, 14);
              if (XWINT (x22, 0) != 7LL)
                return -1;
              x23 = XVECEXP (x6, 0, 15);
              if (XWINT (x23, 0) != 39LL)
                return -1;
              x34 = XVECEXP (x6, 0, 24);
              if (XWINT (x34, 0) != 20LL)
                return -1;
              x35 = XVECEXP (x6, 0, 25);
              if (XWINT (x35, 0) != 52LL)
                return -1;
              x36 = XVECEXP (x6, 0, 26);
              if (XWINT (x36, 0) != 21LL)
                return -1;
              x37 = XVECEXP (x6, 0, 27);
              if (XWINT (x37, 0) != 53LL)
                return -1;
              x38 = XVECEXP (x6, 0, 28);
              if (XWINT (x38, 0) != 22LL)
                return -1;
              x39 = XVECEXP (x6, 0, 29);
              if (XWINT (x39, 0) != 54LL)
                return -1;
              x40 = XVECEXP (x6, 0, 30);
              if (XWINT (x40, 0) != 23LL)
                return -1;
              x41 = XVECEXP (x6, 0, 31);
              if (XWINT (x41, 0) != 55LL
                  || pattern1450 (x2, 
E_V32QImode, 
E_V64QImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19548 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL && TARGET_AVX512BW)))
                return -1;
              return 7743; /* avx2_interleave_lowv32qi_mask */

            case 8LL:
              x17 = XVECEXP (x6, 0, 9);
              if (XWINT (x17, 0) != 40LL)
                return -1;
              x18 = XVECEXP (x6, 0, 10);
              if (XWINT (x18, 0) != 9LL)
                return -1;
              x19 = XVECEXP (x6, 0, 11);
              if (XWINT (x19, 0) != 41LL)
                return -1;
              x20 = XVECEXP (x6, 0, 12);
              if (XWINT (x20, 0) != 10LL)
                return -1;
              x21 = XVECEXP (x6, 0, 13);
              if (XWINT (x21, 0) != 42LL)
                return -1;
              x22 = XVECEXP (x6, 0, 14);
              if (XWINT (x22, 0) != 11LL)
                return -1;
              x23 = XVECEXP (x6, 0, 15);
              if (XWINT (x23, 0) != 43LL)
                return -1;
              x34 = XVECEXP (x6, 0, 24);
              if (XWINT (x34, 0) != 24LL)
                return -1;
              x35 = XVECEXP (x6, 0, 25);
              if (XWINT (x35, 0) != 56LL)
                return -1;
              x36 = XVECEXP (x6, 0, 26);
              if (XWINT (x36, 0) != 25LL)
                return -1;
              x37 = XVECEXP (x6, 0, 27);
              if (XWINT (x37, 0) != 57LL)
                return -1;
              x38 = XVECEXP (x6, 0, 28);
              if (XWINT (x38, 0) != 26LL)
                return -1;
              x39 = XVECEXP (x6, 0, 29);
              if (XWINT (x39, 0) != 58LL)
                return -1;
              x40 = XVECEXP (x6, 0, 30);
              if (XWINT (x40, 0) != 27LL)
                return -1;
              x41 = XVECEXP (x6, 0, 31);
              if (XWINT (x41, 0) != 59LL)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V32HImode:
                  if (pattern1450 (x2, 
E_V32HImode, 
E_V64HImode) != 0
                      || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19668 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1033 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 7765; /* avx512bw_interleave_lowv32hi_mask */

                case E_V32HFmode:
                  if (pattern1450 (x2, 
E_V32HFmode, 
E_V64HFmode) != 0
                      || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19668 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1033 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 7767; /* avx512bw_interleave_lowv32hf_mask */

                case E_V32BFmode:
                  if (pattern1450 (x2, 
E_V32BFmode, 
E_V64BFmode) != 0
                      || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19668 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1033 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 7769; /* avx512bw_interleave_lowv32bf_mask */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 4LL:
          x8 = XVECEXP (x6, 0, 1);
          if (XWINT (x8, 0) != 36LL)
            return -1;
          x10 = XVECEXP (x6, 0, 2);
          if (XWINT (x10, 0) != 5LL)
            return -1;
          x11 = XVECEXP (x6, 0, 3);
          if (XWINT (x11, 0) != 37LL)
            return -1;
          x12 = XVECEXP (x6, 0, 4);
          if (XWINT (x12, 0) != 6LL)
            return -1;
          x13 = XVECEXP (x6, 0, 5);
          if (XWINT (x13, 0) != 38LL)
            return -1;
          x14 = XVECEXP (x6, 0, 6);
          if (XWINT (x14, 0) != 7LL)
            return -1;
          x15 = XVECEXP (x6, 0, 7);
          if (XWINT (x15, 0) != 39LL
              || pattern1743 (x6) != 0)
            return -1;
          x26 = XVECEXP (x6, 0, 16);
          if (XWINT (x26, 0) != 20LL)
            return -1;
          x27 = XVECEXP (x6, 0, 17);
          if (XWINT (x27, 0) != 52LL)
            return -1;
          x28 = XVECEXP (x6, 0, 18);
          if (XWINT (x28, 0) != 21LL)
            return -1;
          x29 = XVECEXP (x6, 0, 19);
          if (XWINT (x29, 0) != 53LL)
            return -1;
          x30 = XVECEXP (x6, 0, 20);
          if (XWINT (x30, 0) != 22LL)
            return -1;
          x31 = XVECEXP (x6, 0, 21);
          if (XWINT (x31, 0) != 54LL)
            return -1;
          x32 = XVECEXP (x6, 0, 22);
          if (XWINT (x32, 0) != 23LL)
            return -1;
          x33 = XVECEXP (x6, 0, 23);
          if (XWINT (x33, 0) != 55LL
              || pattern1748 (x6) != 0)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HImode:
              if (pattern1450 (x2, 
E_V32HImode, 
E_V64HImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19600 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1033 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 7747; /* avx512bw_interleave_highv32hi_mask */

            case E_V32HFmode:
              if (pattern1450 (x2, 
E_V32HFmode, 
E_V64HFmode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19600 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1033 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 7749; /* avx512bw_interleave_highv32hf_mask */

            case E_V32BFmode:
              if (pattern1450 (x2, 
E_V32BFmode, 
E_V64BFmode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19600 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1033 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 7751; /* avx512bw_interleave_highv32bf_mask */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_179 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern140 (x2))
    {
    case 0:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24117 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512BW && TARGET_AVX512VL)))
        return -1;
      return 8120; /* avx2_sign_extendv16qiv16hi2_mask */

    case 1:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24171 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
        return -1;
      return 8128; /* avx512bw_sign_extendv32qiv32hi2_mask */

    case 2:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24241 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512BW && TARGET_AVX512VL)))
        return -1;
      return 8140; /* *sse4_1_sign_extendv8qiv8hi2_mask_1 */

    case 3:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24366 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8152; /* avx512f_sign_extendv16qiv16si2_mask */

    case 4:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24509 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8180; /* avx512f_sign_extendv16hiv16si2_mask */

    case 5:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24398 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
        return -1;
      return 8160; /* *avx2_sign_extendv8qiv8si2_mask_1 */

    case 6:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24562 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
        return -1;
      return 8188; /* avx2_sign_extendv8hiv8si2_mask */

    case 7:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24459 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
        return -1;
      return 8172; /* *sse4_1_sign_extendv4qiv4si2_mask_1 */

    case 8:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24632 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
        return -1;
      return 8200; /* *sse4_1_sign_extendv4hiv4si2_mask_1 */

    case 9:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24763 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8216; /* *avx512f_sign_extendv8qiv8di2_mask_1 */

    case 10:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24934 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8247; /* avx512f_sign_extendv8hiv8di2_mask */

    case 11:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 25071 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8275; /* avx512f_sign_extendv8siv8di2_mask */

    case 12:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24821 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
        return -1;
      return 8228; /* *avx2_sign_extendv4qiv4di2_mask_1 */

    case 13:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24964 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
        return -1;
      return 8255; /* *avx2_sign_extendv4hiv4di2_mask_1 */

    case 14:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 25122 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
        return -1;
      return 8281; /* avx2_sign_extendv4siv4di2_mask */

    case 15:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24883 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
        return -1;
      return 8240; /* *sse4_1_sign_extendv2qiv2di2_mask_1 */

    case 16:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 25022 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
        return -1;
      return 8267; /* *sse4_1_sign_extendv2hiv2di2_mask_1 */

    case 17:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 25188 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
        return -1;
      return 8291; /* *sse4_1_sign_extendv2siv2di2_mask_1 */

    case 18:
      x3 = XEXP (x2, 0);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (pattern826 (x2))
        {
        case 0:
          if ((
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24229 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512BW && TARGET_AVX512VL)))
            return 8136; /* sse4_1_sign_extendv8qiv8hi2_mask */
          break;

        case 1:
          if ((
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24387 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
            return 8156; /* avx2_sign_extendv8qiv8si2_mask */
          break;

        case 2:
          if ((
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24753 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return 8212; /* avx512f_sign_extendv8qiv8di2_mask */
          break;

        case 3:
          if ((
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24447 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
            return 8168; /* sse4_1_sign_extendv4qiv4si2_mask */
          break;

        case 4:
          if ((
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24620 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
            return 8196; /* sse4_1_sign_extendv4hiv4si2_mask */
          break;

        case 5:
          if ((
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24810 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
            return 8224; /* avx2_sign_extendv4qiv4di2_mask */
          break;

        case 6:
          if ((
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24953 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
            return 8251; /* avx2_sign_extendv4hiv4di2_mask */
          break;

        case 7:
          if ((
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24871 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
            return 8236; /* sse4_1_sign_extendv2qiv2di2_mask */
          break;

        case 8:
          if ((
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 25010 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
            return 8263; /* sse4_1_sign_extendv2hiv2di2_mask */
          break;

        case 9:
          if ((
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 25176 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
            return 8287; /* sse4_1_sign_extendv2siv2di2_mask */
          break;

        default:
          break;
        }
      if (GET_CODE (x5) != SUBREG)
        return -1;
      switch (pattern829 (x2))
        {
        case 0:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24265 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512BW && TARGET_AVX512VL
   && ix86_pre_reload_split ())))
            return -1;
          return 8144; /* *sse4_1_sign_extendv8qiv8hi2_mask_2 */

        case 1:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24417 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL
   && ix86_pre_reload_split ())))
            return -1;
          return 8164; /* *avx2_sign_extendv8qiv8si2_mask_2 */

        case 2:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24781 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512 && ix86_pre_reload_split ())))
            return -1;
          return 8220; /* *avx512f_sign_extendv8qiv8di2_mask_2 */

        case 3:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24651 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL
   && ix86_pre_reload_split ())))
            return -1;
          return 8204; /* *sse4_1_sign_extendv4hiv4si2_mask_2 */

        case 4:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24981 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL
   && ix86_pre_reload_split ())))
            return -1;
          return 8259; /* *avx2_sign_extendv4hiv4di2_mask_2 */

        case 5:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 25206 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL
   && ix86_pre_reload_split ())))
            return -1;
          return 8295; /* *sse4_1_sign_extendv2siv2di2_mask_2 */

        case 6:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24482 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL
   && ix86_pre_reload_split ())))
            return -1;
          return 8176; /* *sse4_1_sign_extendv4qiv4si2_mask_2 */

        case 7:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24842 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL
   && ix86_pre_reload_split ())))
            return -1;
          return 8232; /* *avx2_sign_extendv4qiv4di2_mask_2 */

        case 8:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 25044 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL
   && ix86_pre_reload_split ())))
            return -1;
          return 8271; /* *sse4_1_sign_extendv2hiv2di2_mask_2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_190 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  x7 = XEXP (x2, 2);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V8SFmode:
      if (pattern118 (x2, 
E_V8SFmode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5349 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 32 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 429 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
        return -1;
      return 3202; /* *iorv8sf3_mask */

    case E_V4SFmode:
      if (pattern118 (x2, 
E_V4SFmode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 5349 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 32 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
        return -1;
      return 3208; /* *iorv4sf3_mask */

    case E_V4DFmode:
      if (pattern118 (x2, 
E_V4DFmode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5349 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 64 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 430 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
        return -1;
      return 3214; /* *iorv4df3_mask */

    case E_V2DFmode:
      if (pattern118 (x2, 
E_V2DFmode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5349 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 64 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 430 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
        return -1;
      return 3220; /* *iorv2df3_mask */

    case E_V16SFmode:
      if (pattern119 (x2, 
E_V16SFmode, 
E_HImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5419 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (!true || 32 != 16)) && 
#line 494 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 3232; /* *iorv16sf3_mask */

    case E_V8DFmode:
      if (pattern119 (x2, 
E_V8DFmode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5419 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (!true || 64 != 16)) && 
#line 495 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 3238; /* *iorv8df3_mask */

    case E_V16SImode:
      if (pattern426 (x2, 
E_V16SImode, 
E_HImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 18731 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (IOR, V16SImode, operands)) && 
#line 808 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
        return -1;
      return 7422; /* *iorv16si3_mask */

    case E_V8SImode:
      if (pattern426 (x2, 
E_V8SImode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 18731 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (32 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (IOR, V8SImode, operands)) && 
#line 808 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
        return -1;
      return 7428; /* *iorv8si3_mask */

    case E_V4SImode:
      if (pattern426 (x2, 
E_V4SImode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 18731 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (16 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (IOR, V4SImode, operands))))
        return -1;
      return 7434; /* *iorv4si3_mask */

    case E_V8DImode:
      if (pattern426 (x2, 
E_V8DImode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 18731 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (IOR, V8DImode, operands)) && 
#line 809 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
        return -1;
      return 7440; /* *iorv8di3_mask */

    case E_V4DImode:
      if (pattern426 (x2, 
E_V4DImode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 18731 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (32 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (IOR, V4DImode, operands)) && 
#line 809 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
        return -1;
      return 7446; /* *iorv4di3_mask */

    case E_V2DImode:
      if (pattern426 (x2, 
E_V2DImode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 18731 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (16 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (IOR, V2DImode, operands))))
        return -1;
      return 7452; /* *iorv2di3_mask */

    default:
      return -1;
    }
}

 int
recog_200 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x2) != E_V16SImode
          || !nonimmediate_operand (operands[1], E_V16SImode)
          || !(
#line 29946 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9437; /* *conflictv16si */

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x2) != E_V8SImode
          || !nonimmediate_operand (operands[1], E_V8SImode)
          || !(
#line 29946 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9439; /* *conflictv8si */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x2) != E_V4SImode
          || !nonimmediate_operand (operands[1], E_V4SImode)
          || !(
#line 29946 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9441; /* *conflictv4si */

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x2) != E_V8DImode
          || !nonimmediate_operand (operands[1], E_V8DImode)
          || !(
#line 29946 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 502 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9443; /* *conflictv8di */

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x2) != E_V4DImode
          || !nonimmediate_operand (operands[1], E_V4DImode)
          || !(
#line 29946 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 502 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9445; /* *conflictv4di */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x2) != E_V2DImode
          || !nonimmediate_operand (operands[1], E_V2DImode)
          || !(
#line 29946 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 502 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9447; /* *conflictv2di */

    default:
      return -1;
    }
}

 int
recog_206 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  switch (pattern1034 (x2))
    {
    case 0:
      if (pattern1463 (x2, 
E_V32HFmode, 
E_SImode) != 0
          || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6138 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 5914 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
        return -1;
      return 3421; /* fma_fnmadd_v32hf_maskz_1_round */

    case 1:
      if (pattern1463 (x2, 
E_V16HFmode, 
E_HImode) != 0
          || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6138 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 5915 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
        return -1;
      return 3425; /* fma_fnmadd_v16hf_maskz_1_round */

    case 2:
      if (pattern1463 (x2, 
E_V16SFmode, 
E_HImode) != 0
          || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6138 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 5918 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 3433; /* fma_fnmadd_v16sf_maskz_1_round */

    case 3:
      if (pattern1463 (x2, 
E_V8SFmode, 
E_QImode) != 0
          || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6138 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode)))) && 
#line 5919 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 3437; /* fma_fnmadd_v8sf_maskz_1_round */

    case 4:
      if (pattern1463 (x2, 
E_V8DFmode, 
E_QImode) != 0
          || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6138 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 5920 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 3444; /* fma_fnmadd_v8df_maskz_1_round */

    case 5:
      if (pattern1463 (x2, 
E_V4DFmode, 
E_QImode) != 0
          || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6138 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 5921 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 3448; /* fma_fnmadd_v4df_maskz_1_round */

    case 6:
      if (pattern1464 (x2, 
E_V32HFmode, 
E_SImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V32HFmode)
          && register_operand (operands[3], E_V32HFmode))
        {
          x7 = XEXP (x3, 1);
          if (rtx_equal_p (x7, operands[1])
              && (
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6181 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
            return 3452; /* avx512bw_fnmadd_v32hf_mask_round */
        }
      if (!register_operand (operands[1], E_V32HFmode)
          || !nonimmediate_operand (operands[3], E_V32HFmode))
        return -1;
      x7 = XEXP (x3, 1);
      if (!rtx_equal_p (x7, operands[3])
          || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6199 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
        return -1;
      return 3467; /* avx512bw_fnmadd_v32hf_mask3_round */

    case 7:
      if (pattern1464 (x2, 
E_V16HFmode, 
E_HImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V16HFmode)
          && register_operand (operands[3], E_V16HFmode))
        {
          x7 = XEXP (x3, 1);
          if (rtx_equal_p (x7, operands[1])
              && (
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6181 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 526 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return 3454; /* avx512vl_fnmadd_v16hf_mask_round */
        }
      if (!register_operand (operands[1], E_V16HFmode)
          || !nonimmediate_operand (operands[3], E_V16HFmode))
        return -1;
      x7 = XEXP (x3, 1);
      if (!rtx_equal_p (x7, operands[3])
          || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6199 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 526 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
        return -1;
      return 3469; /* avx512vl_fnmadd_v16hf_mask3_round */

    case 8:
      if (pattern1464 (x2, 
E_V16SFmode, 
E_HImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V16SFmode)
          && register_operand (operands[3], E_V16SFmode))
        {
          x7 = XEXP (x3, 1);
          if (rtx_equal_p (x7, operands[1])
              && (
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6181 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return 3457; /* avx512f_fnmadd_v16sf_mask_round */
        }
      if (!register_operand (operands[1], E_V16SFmode)
          || !nonimmediate_operand (operands[3], E_V16SFmode))
        return -1;
      x7 = XEXP (x3, 1);
      if (!rtx_equal_p (x7, operands[3])
          || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6199 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 3472; /* avx512f_fnmadd_v16sf_mask3_round */

    case 9:
      if (pattern1464 (x2, 
E_V8SFmode, 
E_QImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8SFmode)
          && register_operand (operands[3], E_V8SFmode))
        {
          x7 = XEXP (x3, 1);
          if (rtx_equal_p (x7, operands[1])
              && (
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6181 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode)))) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return 3459; /* avx512vl_fnmadd_v8sf_mask_round */
        }
      if (!register_operand (operands[1], E_V8SFmode)
          || !nonimmediate_operand (operands[3], E_V8SFmode))
        return -1;
      x7 = XEXP (x3, 1);
      if (!rtx_equal_p (x7, operands[3])
          || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6199 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode)))) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 3474; /* avx512vl_fnmadd_v8sf_mask3_round */

    case 10:
      if (pattern1464 (x2, 
E_V8DFmode, 
E_QImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8DFmode)
          && register_operand (operands[3], E_V8DFmode))
        {
          x7 = XEXP (x3, 1);
          if (rtx_equal_p (x7, operands[1])
              && (
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6181 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 529 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return 3462; /* avx512f_fnmadd_v8df_mask_round */
        }
      if (!register_operand (operands[1], E_V8DFmode)
          || !nonimmediate_operand (operands[3], E_V8DFmode))
        return -1;
      x7 = XEXP (x3, 1);
      if (!rtx_equal_p (x7, operands[3])
          || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6199 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 529 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 3477; /* avx512f_fnmadd_v8df_mask3_round */

    case 11:
      if (pattern1464 (x2, 
E_V4DFmode, 
E_QImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V4DFmode)
          && register_operand (operands[3], E_V4DFmode))
        {
          x7 = XEXP (x3, 1);
          if (rtx_equal_p (x7, operands[1])
              && (
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6181 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 529 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return 3464; /* avx512vl_fnmadd_v4df_mask_round */
        }
      if (!register_operand (operands[1], E_V4DFmode)
          || !nonimmediate_operand (operands[3], E_V4DFmode))
        return -1;
      x7 = XEXP (x3, 1);
      if (!rtx_equal_p (x7, operands[3])
          || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6199 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 529 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 3479; /* avx512vl_fnmadd_v4df_mask3_round */

    case 12:
      if (pattern1514 (x2, 
E_V8HFmode) != 0
          || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6619 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
        return -1;
      return 3711; /* *fmai_fnmadd_v8hf_round */

    case 13:
      if (pattern1514 (x2, 
E_V4SFmode) != 0
          || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 6619 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F)))
        return -1;
      return 3713; /* *fmai_fnmadd_v4sf_round */

    case 14:
      if (pattern1514 (x2, 
E_V2DFmode) != 0
          || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6619 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F) && 
#line 480 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
        return -1;
      return 3715; /* *fmai_fnmadd_v2df_round */

    case 15:
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
          operands[4] = x7;
          x8 = XEXP (x3, 2);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 1);
          operands[6] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (pattern1465 (x2, 
E_V4SFmode) != 0
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 6213 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4)))
                return -1;
              return 3488; /* *fma_fnmsub_v4sf */

            case E_V2DFmode:
              if (pattern1465 (x2, 
E_V2DFmode) != 0
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 6213 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4)))
                return -1;
              return 3492; /* *fma_fnmsub_v2df */

            case E_V8SFmode:
              if (pattern1466 (x2, 
E_V8SFmode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V8SFmode)
                  && nonimmediate_operand (operands[2], E_V8SFmode)
                  && nonimmediate_operand (operands[3], E_V8SFmode)
                  && (
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 6213 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4)))
                return 3496; /* *fma_fnmsub_v8sf */
              if (!register_operand (operands[1], E_V8SFmode)
                  || !register_operand (operands[2], E_V8SFmode)
                  || !register_operand (operands[3], E_V8SFmode)
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6246 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode)))) && 
#line 5919 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 3520; /* fma_fnmsub_v8sf_maskz_1_round */

            case E_V4DFmode:
              if (pattern1466 (x2, 
E_V4DFmode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V4DFmode)
                  && nonimmediate_operand (operands[2], E_V4DFmode)
                  && nonimmediate_operand (operands[3], E_V4DFmode)
                  && (
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 6213 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4)))
                return 3500; /* *fma_fnmsub_v4df */
              if (!register_operand (operands[1], E_V4DFmode)
                  || !register_operand (operands[2], E_V4DFmode)
                  || !register_operand (operands[3], E_V4DFmode)
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6246 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 5921 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 3531; /* fma_fnmsub_v4df_maskz_1_round */

            case E_V32HFmode:
              if (pattern1467 (x2, 
E_SImode, 
E_V32HFmode) != 0
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6246 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 5914 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                return -1;
              return 3504; /* fma_fnmsub_v32hf_maskz_1_round */

            case E_V16HFmode:
              if (pattern1467 (x2, 
E_HImode, 
E_V16HFmode) != 0
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6246 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 5915 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                return -1;
              return 3508; /* fma_fnmsub_v16hf_maskz_1_round */

            case E_V16SFmode:
              if (pattern1467 (x2, 
E_HImode, 
E_V16SFmode) != 0
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6246 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 5918 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 3516; /* fma_fnmsub_v16sf_maskz_1_round */

            case E_V8DFmode:
              if (pattern1467 (x2, 
E_QImode, 
E_V8DFmode) != 0
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6246 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 5920 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 3527; /* fma_fnmsub_v8df_maskz_1_round */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          switch (pattern1033 (x2))
            {
            case 0:
              if (pattern1468 (x2, 
E_V32HFmode, 
E_SImode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V32HFmode)
                  && register_operand (operands[3], E_V32HFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6291 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                return 3535; /* avx512bw_fnmsub_v32hf_mask_round */
              if (!register_operand (operands[1], E_V32HFmode)
                  || !nonimmediate_operand (operands[3], E_V32HFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6310 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                return -1;
              return 3550; /* avx512bw_fnmsub_v32hf_mask3_round */

            case 1:
              if (pattern1468 (x2, 
E_V16HFmode, 
E_HImode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V16HFmode)
                  && register_operand (operands[3], E_V16HFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6291 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 526 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                return 3537; /* avx512vl_fnmsub_v16hf_mask_round */
              if (!register_operand (operands[1], E_V16HFmode)
                  || !nonimmediate_operand (operands[3], E_V16HFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6310 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 526 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                return -1;
              return 3552; /* avx512vl_fnmsub_v16hf_mask3_round */

            case 2:
              if (pattern1468 (x2, 
E_V16SFmode, 
E_HImode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V16SFmode)
                  && register_operand (operands[3], E_V16SFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6291 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return 3540; /* avx512f_fnmsub_v16sf_mask_round */
              if (!register_operand (operands[1], E_V16SFmode)
                  || !nonimmediate_operand (operands[3], E_V16SFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6310 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 3555; /* avx512f_fnmsub_v16sf_mask3_round */

            case 3:
              if (pattern1468 (x2, 
E_V8SFmode, 
E_QImode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V8SFmode)
                  && register_operand (operands[3], E_V8SFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6291 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode)))) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return 3542; /* avx512vl_fnmsub_v8sf_mask_round */
              if (!register_operand (operands[1], E_V8SFmode)
                  || !nonimmediate_operand (operands[3], E_V8SFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6310 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode)))) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 3557; /* avx512vl_fnmsub_v8sf_mask3_round */

            case 4:
              if (pattern1468 (x2, 
E_V8DFmode, 
E_QImode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V8DFmode)
                  && register_operand (operands[3], E_V8DFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6291 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 529 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return 3545; /* avx512f_fnmsub_v8df_mask_round */
              if (!register_operand (operands[1], E_V8DFmode)
                  || !nonimmediate_operand (operands[3], E_V8DFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6310 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 529 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 3560; /* avx512f_fnmsub_v8df_mask3_round */

            case 5:
              if (pattern1468 (x2, 
E_V4DFmode, 
E_QImode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V4DFmode)
                  && register_operand (operands[3], E_V4DFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6291 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 529 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return 3547; /* avx512vl_fnmsub_v4df_mask_round */
              if (!register_operand (operands[1], E_V4DFmode)
                  || !nonimmediate_operand (operands[3], E_V4DFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6310 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 529 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 3562; /* avx512vl_fnmsub_v4df_mask3_round */

            case 6:
              if (pattern1515 (x2, 
E_V8HFmode) != 0
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6638 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 3717; /* *fmai_fnmsub_v8hf_round */

            case 7:
              if (pattern1515 (x2, 
E_V4SFmode) != 0
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 6638 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F)))
                return -1;
              return 3719; /* *fmai_fnmsub_v4sf_round */

            case 8:
              if (pattern1515 (x2, 
E_V2DFmode) != 0
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6638 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F) && 
#line 480 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 3721; /* *fmai_fnmsub_v2df_round */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_219 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 17)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[0] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || !vector_operand (operands[1], E_V16QImode)
          || !
#line 25315 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)))
        return -1;
      return 8304; /* *sse4_1_ptestv16qi */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || !vector_operand (operands[1], E_V8HImode)
          || !
#line 25315 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)))
        return -1;
      return 8305; /* *sse4_1_ptestv8hi */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || !vector_operand (operands[1], E_V4SImode)
          || !
#line 25315 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)))
        return -1;
      return 8306; /* *sse4_1_ptestv4si */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || !vector_operand (operands[1], E_V2DImode)
          || !
#line 25315 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)))
        return -1;
      return 8307; /* *sse4_1_ptestv2di */

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || !vector_operand (operands[1], E_V1TImode)
          || !
#line 25315 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)))
        return -1;
      return 8308; /* *sse4_1_ptestv1ti */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || !vector_operand (operands[1], E_V4SFmode)
          || !
#line 25315 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)))
        return -1;
      return 8309; /* *sse4_1_ptestv4sf */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || !vector_operand (operands[1], E_V2DFmode)
          || !
#line 25315 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)))
        return -1;
      return 8310; /* *sse4_1_ptestv2df */

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || !vector_operand (operands[1], E_V32QImode)
          || !(
#line 25315 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)) && 
#line 606 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 8311; /* *avx_ptestv32qi */

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || !vector_operand (operands[1], E_V16HImode)
          || !(
#line 25315 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)) && 
#line 606 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 8312; /* *avx_ptestv16hi */

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || !vector_operand (operands[1], E_V8SImode)
          || !(
#line 25315 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)) && 
#line 607 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 8313; /* *avx_ptestv8si */

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || !vector_operand (operands[1], E_V4DImode)
          || !(
#line 25315 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)) && 
#line 607 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 8314; /* *avx_ptestv4di */

    case E_V2TImode:
      if (!register_operand (operands[0], E_V2TImode)
          || !vector_operand (operands[1], E_V2TImode)
          || !(
#line 25315 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)) && 
#line 607 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 8315; /* *avx_ptestv2ti */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || !vector_operand (operands[1], E_V8SFmode)
          || !(
#line 25315 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)) && 
#line 608 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 8316; /* *avx_ptestv8sf */

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || !vector_operand (operands[1], E_V4DFmode)
          || !(
#line 25315 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)) && 
#line 608 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 8317; /* *avx_ptestv4df */

    default:
      return -1;
    }
}

 int
recog_221 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8SImode:
      if (pattern724 (x3, 
E_V8SImode) != 0
          || !
#line 27314 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8480; /* avx2_permvarv8si */

    case E_V8SFmode:
      if (pattern725 (x3, 
E_V8SImode, 
E_V8SFmode) != 0
          || !
#line 27314 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8482; /* avx2_permvarv8sf */

    case E_V16SImode:
      if (pattern724 (x3, 
E_V16SImode) != 0
          || !(
#line 27314 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1) && 
#line 998 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8484; /* avx512f_permvarv16si */

    case E_V16SFmode:
      if (pattern725 (x3, 
E_V16SImode, 
E_V16SFmode) != 0
          || !(
#line 27314 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1) && 
#line 999 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8486; /* avx512f_permvarv16sf */

    case E_V8DImode:
      if (pattern724 (x3, 
E_V8DImode) != 0
          || !(
#line 27314 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1) && 
#line 1000 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8488; /* avx512f_permvarv8di */

    case E_V8DFmode:
      if (pattern725 (x3, 
E_V8DImode, 
E_V8DFmode) != 0
          || !(
#line 27314 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1) && 
#line 1001 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8490; /* avx512f_permvarv8df */

    case E_V4DImode:
      if (pattern724 (x3, 
E_V4DImode) != 0
          || !(
#line 27314 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1) && 
#line 1002 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 8492; /* avx2_permvarv4di */

    case E_V4DFmode:
      if (pattern725 (x3, 
E_V4DImode, 
E_V4DFmode) != 0
          || !(
#line 27314 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1) && 
#line 1002 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 8494; /* avx2_permvarv4df */

    case E_V64QImode:
      if (pattern724 (x3, 
E_V64QImode) != 0
          || !(
#line 27333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && 1) && 
#line 328 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 8496; /* avx512bw_permvarv64qi */

    case E_V16QImode:
      if (pattern724 (x3, 
E_V16QImode) != 0
          || !(
#line 27333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && 1) && 
#line 328 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 8498; /* avx512vl_permvarv16qi */

    case E_V32QImode:
      if (pattern724 (x3, 
E_V32QImode) != 0
          || !(
#line 27333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && 1) && 
#line 328 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 8500; /* avx512vl_permvarv32qi */

    case E_V8HImode:
      if (pattern724 (x3, 
E_V8HImode) != 0
          || !(
#line 27345 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && 1) && 
#line 689 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 8502; /* avx512vl_permvarv8hi */

    case E_V16HImode:
      if (pattern724 (x3, 
E_V16HImode) != 0
          || !(
#line 27345 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && 1) && 
#line 689 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 8504; /* avx512vl_permvarv16hi */

    case E_V32HImode:
      if (pattern724 (x3, 
E_V32HImode) != 0
          || !(
#line 27345 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && 1) && 
#line 689 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 8506; /* avx512bw_permvarv32hi */

    case E_V8HFmode:
      if (pattern725 (x3, 
E_V8HImode, 
E_V8HFmode) != 0
          || !(
#line 27345 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && 1) && 
#line 690 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 8508; /* avx512fp16_permvarv8hf */

    case E_V16HFmode:
      if (pattern725 (x3, 
E_V16HImode, 
E_V16HFmode) != 0
          || !(
#line 27345 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && 1) && 
#line 690 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 8510; /* avx512vl_permvarv16hf */

    case E_V32HFmode:
      if (pattern725 (x3, 
E_V32HImode, 
E_V32HFmode) != 0
          || !(
#line 27345 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && 1) && 
#line 690 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 8512; /* avx512bw_permvarv32hf */

    case E_V8BFmode:
      if (pattern725 (x3, 
E_V8HImode, 
E_V8BFmode) != 0
          || !(
#line 27345 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && 1) && 
#line 691 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 8514; /* avx512vl_permvarv8bf */

    case E_V16BFmode:
      if (pattern725 (x3, 
E_V16HImode, 
E_V16BFmode) != 0
          || !(
#line 27345 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && 1) && 
#line 691 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 8516; /* avx512vl_permvarv16bf */

    case E_V32BFmode:
      if (pattern725 (x3, 
E_V32HImode, 
E_V32BFmode) != 0
          || !(
#line 27345 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && 1) && 
#line 691 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 8518; /* avx512bw_permvarv32bf */

    default:
      return -1;
    }
}

 int
recog_225 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      if (pattern63 (x3, 
E_V32HFmode) != 0
          || !(
#line 13623 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 4849; /* avx512bw_scalefv32hf */

    case E_V16HFmode:
      if (pattern63 (x3, 
E_V16HFmode) != 0
          || !(
#line 13623 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 526 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 4853; /* avx512vl_scalefv16hf */

    case E_V8HFmode:
      if (pattern63 (x3, 
E_V8HFmode) != 0
          || !(
#line 13623 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 4857; /* avx512fp16_scalefv8hf */

    case E_V16SFmode:
      if (pattern63 (x3, 
E_V16SFmode) != 0
          || !(
#line 13623 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 4859; /* avx512f_scalefv16sf */

    case E_V8SFmode:
      if (pattern63 (x3, 
E_V8SFmode) != 0
          || !(
#line 13623 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4863; /* avx512vl_scalefv8sf */

    case E_V4SFmode:
      if (pattern63 (x3, 
E_V4SFmode) != 0
          || !(
#line 13623 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4867; /* avx512vl_scalefv4sf */

    case E_V8DFmode:
      if (pattern63 (x3, 
E_V8DFmode) != 0
          || !(
#line 13623 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 529 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 4869; /* avx512f_scalefv8df */

    case E_V4DFmode:
      if (pattern63 (x3, 
E_V4DFmode) != 0
          || !(
#line 13623 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 529 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4873; /* avx512vl_scalefv4df */

    case E_V2DFmode:
      if (pattern63 (x3, 
E_V2DFmode) != 0
          || !(
#line 13623 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 529 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4877; /* avx512vl_scalefv2df */

    default:
      return -1;
    }
}

 int
recog_229 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 2);
  if (GET_MODE (x3) != E_V16QImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_V16QImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (GET_MODE (x2) != E_V16QImode)
    return -1;
  switch (pattern975 (x2, 
E_V16QImode))
    {
    case 0:
      if (!(
#line 22461 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
        return -1;
      return 7945; /* *sse2_maskmovdqu */

    case 1:
      if (!(
#line 22461 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
        return -1;
      return 7946; /* *sse2_maskmovdqu */

    default:
      return -1;
    }
}

 int
recog_231 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      switch (GET_CODE (x4))
        {
        case MEM:
          res = recog_229 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case REG:
        case SUBREG:
          operands[2] = x4;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          x6 = XVECEXP (x2, 0, 1);
          if (rtx_equal_p (x6, operands[0]))
            {
              switch (GET_MODE (operands[0]))
                {
                case E_V16SImode:
                  if (pattern839 (x2, 
E_HImode, 
E_V16SImode) == 0
                      && (
#line 28733 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 8867; /* avx512f_storev16si_mask */
                  break;

                case E_V8DImode:
                  if (pattern839 (x2, 
E_QImode, 
E_V8DImode) == 0
                      && (
#line 28733 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 8870; /* avx512f_storev8di_mask */
                  break;

                case E_V16SFmode:
                  if (pattern839 (x2, 
E_HImode, 
E_V16SFmode) == 0
                      && (
#line 28733 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 8873; /* avx512f_storev16sf_mask */
                  break;

                case E_V8SFmode:
                  if (pattern839 (x2, 
E_QImode, 
E_V8SFmode) == 0
                      && (
#line 28733 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 8874; /* avx512vl_storev8sf_mask */
                  break;

                case E_V4SFmode:
                  if (pattern839 (x2, 
E_QImode, 
E_V4SFmode) == 0
                      && (
#line 28733 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 8875; /* avx512vl_storev4sf_mask */
                  break;

                case E_V8DFmode:
                  if (pattern839 (x2, 
E_QImode, 
E_V8DFmode) == 0
                      && (
#line 28733 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 298 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 8876; /* avx512f_storev8df_mask */
                  break;

                case E_V4DFmode:
                  if (pattern839 (x2, 
E_QImode, 
E_V4DFmode) == 0
                      && (
#line 28733 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 298 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 8877; /* avx512vl_storev4df_mask */
                  break;

                case E_V2DFmode:
                  if (pattern839 (x2, 
E_QImode, 
E_V2DFmode) == 0
                      && (
#line 28733 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 298 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 8878; /* avx512vl_storev2df_mask */
                  break;

                case E_V64QImode:
                  if (pattern839 (x2, 
E_DImode, 
E_V64QImode) == 0
                      && (
#line 28762 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 8879; /* avx512bw_storev64qi_mask */
                  break;

                case E_V16QImode:
                  if (pattern839 (x2, 
E_HImode, 
E_V16QImode) == 0
                      && (
#line 28762 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 8880; /* avx512vl_storev16qi_mask */
                  break;

                case E_V32QImode:
                  if (pattern839 (x2, 
E_SImode, 
E_V32QImode) == 0
                      && (
#line 28762 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 8881; /* avx512vl_storev32qi_mask */
                  break;

                case E_V32HImode:
                  if (pattern839 (x2, 
E_SImode, 
E_V32HImode) == 0
                      && (
#line 28762 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 8882; /* avx512bw_storev32hi_mask */
                  break;

                case E_V16HImode:
                  if (pattern839 (x2, 
E_HImode, 
E_V16HImode) == 0
                      && (
#line 28762 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 8883; /* avx512vl_storev16hi_mask */
                  break;

                case E_V8HImode:
                  if (pattern839 (x2, 
E_QImode, 
E_V8HImode) == 0
                      && (
#line 28762 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 8884; /* avx512vl_storev8hi_mask */
                  break;

                case E_V32HFmode:
                  if (pattern839 (x2, 
E_SImode, 
E_V32HFmode) == 0
                      && (
#line 28762 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 8885; /* avx512bw_storev32hf_mask */
                  break;

                case E_V16HFmode:
                  if (pattern839 (x2, 
E_HImode, 
E_V16HFmode) == 0
                      && (
#line 28762 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 8886; /* avx512vl_storev16hf_mask */
                  break;

                case E_V8HFmode:
                  if (pattern839 (x2, 
E_QImode, 
E_V8HFmode) == 0
                      && (
#line 28762 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 8887; /* avx512fp16_storev8hf_mask */
                  break;

                case E_V32BFmode:
                  if (pattern839 (x2, 
E_SImode, 
E_V32BFmode) == 0
                      && (
#line 28762 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 325 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 8888; /* avx512bw_storev32bf_mask */
                  break;

                case E_V16BFmode:
                  if (pattern839 (x2, 
E_HImode, 
E_V16BFmode) == 0
                      && (
#line 28762 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 325 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 8889; /* avx512vl_storev16bf_mask */
                  break;

                case E_V8BFmode:
                  if (pattern839 (x2, 
E_QImode, 
E_V8BFmode) == 0
                      && (
#line 28762 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 325 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 8890; /* avx512vl_storev8bf_mask */
                  break;

                default:
                  break;
                }
            }
          break;

        default:
          break;
        }
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern729 (x2, 
E_V4SFmode, 
E_V4SImode) != 0
              || !
#line 28642 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 8859; /* avx_maskstoreps */

        case E_V2DFmode:
          if (pattern729 (x2, 
E_V2DFmode, 
E_V2DImode) != 0
              || !
#line 28642 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 8860; /* avx_maskstorepd */

        case E_V4DImode:
          if (!memory_operand (operands[0], E_V4DImode)
              || GET_MODE (x2) != E_V4DImode
              || !register_operand (operands[1], E_V4DImode))
            return -1;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          if (register_operand (operands[2], E_V4DImode)
              && rtx_equal_p (x4, operands[0])
              && 
#line 28642 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return 8861; /* avx2_maskstoreq256 */
          operands[2] = x4;
          if (!register_operand (operands[2], E_QImode)
              || !rtx_equal_p (x6, operands[0])
              || !(
#line 28733 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8871; /* avx512vl_storev4di_mask */

        case E_V2DImode:
          if (!memory_operand (operands[0], E_V2DImode)
              || GET_MODE (x2) != E_V2DImode
              || !register_operand (operands[1], E_V2DImode))
            return -1;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          if (register_operand (operands[2], E_V2DImode)
              && rtx_equal_p (x4, operands[0])
              && 
#line 28642 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return 8862; /* avx2_maskstoreq */
          operands[2] = x4;
          if (!register_operand (operands[2], E_QImode)
              || !rtx_equal_p (x6, operands[0])
              || !(
#line 28733 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8872; /* avx512vl_storev2di_mask */

        case E_V8SFmode:
          if (pattern729 (x2, 
E_V8SFmode, 
E_V8SImode) != 0
              || !
#line 28642 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 8863; /* avx_maskstoreps256 */

        case E_V4DFmode:
          if (pattern729 (x2, 
E_V4DFmode, 
E_V4DImode) != 0
              || !
#line 28642 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 8864; /* avx_maskstorepd256 */

        case E_V8SImode:
          if (!memory_operand (operands[0], E_V8SImode)
              || GET_MODE (x2) != E_V8SImode
              || !register_operand (operands[1], E_V8SImode))
            return -1;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          if (register_operand (operands[2], E_V8SImode)
              && rtx_equal_p (x4, operands[0])
              && 
#line 28642 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return 8865; /* avx2_maskstored256 */
          operands[2] = x4;
          if (!register_operand (operands[2], E_QImode)
              || !rtx_equal_p (x6, operands[0])
              || !(
#line 28733 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8868; /* avx512vl_storev8si_mask */

        case E_V4SImode:
          if (!memory_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || !register_operand (operands[1], E_V4SImode))
            return -1;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          if (register_operand (operands[2], E_V4SImode)
              && rtx_equal_p (x4, operands[0])
              && 
#line 28642 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return 8866; /* avx2_maskstored */
          operands[2] = x4;
          if (!register_operand (operands[2], E_QImode)
              || !rtx_equal_p (x6, operands[0])
              || !(
#line 28733 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8869; /* avx512vl_storev4si_mask */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[2] = x4;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern731 (x2))
        {
        case 0:
          if (!(
#line 28776 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 8891; /* *avx512bw_storev64qi_mask_1 */

        case 1:
          if (!(
#line 28776 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 8892; /* *avx512vl_storev32qi_mask_1 */

        case 2:
          if (!
#line 28776 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()))
            return -1;
          return 8893; /* *avx512vl_storev16qi_mask_1 */

        case 3:
          if (!(
#line 28776 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 8894; /* *avx512bw_storev32hi_mask_1 */

        case 4:
          if (!(
#line 28776 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 8895; /* *avx512vl_storev16hi_mask_1 */

        case 5:
          if (!
#line 28776 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()))
            return -1;
          return 8896; /* *avx512vl_storev8hi_mask_1 */

        case 6:
          if (!(
#line 28776 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 8897; /* *avx512f_storev16si_mask_1 */

        case 7:
          if (!(
#line 28776 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 8898; /* *avx512vl_storev8si_mask_1 */

        case 8:
          if (!
#line 28776 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()))
            return -1;
          return 8899; /* *avx512vl_storev4si_mask_1 */

        case 9:
          if (!(
#line 28776 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 8900; /* *avx512f_storev8di_mask_1 */

        case 10:
          if (!(
#line 28776 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 8901; /* *avx512vl_storev4di_mask_1 */

        case 11:
          if (!
#line 28776 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()))
            return -1;
          return 8902; /* *avx512vl_storev2di_mask_1 */

        case 12:
          if (!(
#line 28776 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 8903; /* *avx512bw_storev32hf_mask_1 */

        case 13:
          if (!(
#line 28776 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 8904; /* *avx512vl_storev16hf_mask_1 */

        case 14:
          if (!
#line 28776 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()))
            return -1;
          return 8905; /* *avx512fp16_storev8hf_mask_1 */

        case 15:
          if (!(
#line 28776 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 8906; /* *avx512bw_storev32bf_mask_1 */

        case 16:
          if (!(
#line 28776 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 8907; /* *avx512vl_storev16bf_mask_1 */

        case 17:
          if (!
#line 28776 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()))
            return -1;
          return 8908; /* *avx512vl_storev8bf_mask_1 */

        case 18:
          if (!(
#line 28776 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 8909; /* *avx512f_storev16sf_mask_1 */

        case 19:
          if (!(
#line 28776 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 8910; /* *avx512vl_storev8sf_mask_1 */

        case 20:
          if (!
#line 28776 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()))
            return -1;
          return 8911; /* *avx512vl_storev4sf_mask_1 */

        case 21:
          if (!(
#line 28776 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 8912; /* *avx512f_storev8df_mask_1 */

        case 22:
          if (!(
#line 28776 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 8913; /* *avx512vl_storev4df_mask_1 */

        case 23:
          if (!(
#line 28776 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 8914; /* *avx512vl_storev2df_mask_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_237 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      if (pattern838 (x3, 
E_HImode, 
E_V16SImode) != 0
          || !(
#line 29654 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9253; /* avx512f_compressv16si_mask */

    case E_V16SFmode:
      if (pattern838 (x3, 
E_HImode, 
E_V16SFmode) != 0
          || !(
#line 29654 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9254; /* avx512f_compressv16sf_mask */

    case E_V8DImode:
      if (pattern838 (x3, 
E_QImode, 
E_V8DImode) != 0
          || !(
#line 29654 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9255; /* avx512f_compressv8di_mask */

    case E_V8DFmode:
      if (pattern838 (x3, 
E_QImode, 
E_V8DFmode) != 0
          || !(
#line 29654 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9256; /* avx512f_compressv8df_mask */

    case E_V8SImode:
      if (pattern838 (x3, 
E_QImode, 
E_V8SImode) != 0
          || !(
#line 29654 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9257; /* avx512vl_compressv8si_mask */

    case E_V8SFmode:
      if (pattern838 (x3, 
E_QImode, 
E_V8SFmode) != 0
          || !(
#line 29654 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9258; /* avx512vl_compressv8sf_mask */

    case E_V4DImode:
      if (pattern838 (x3, 
E_QImode, 
E_V4DImode) != 0
          || !(
#line 29654 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9259; /* avx512vl_compressv4di_mask */

    case E_V4DFmode:
      if (pattern838 (x3, 
E_QImode, 
E_V4DFmode) != 0
          || !(
#line 29654 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9260; /* avx512vl_compressv4df_mask */

    case E_V4SImode:
      if (pattern838 (x3, 
E_QImode, 
E_V4SImode) != 0
          || !(
#line 29654 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9261; /* avx512vl_compressv4si_mask */

    case E_V4SFmode:
      if (pattern838 (x3, 
E_QImode, 
E_V4SFmode) != 0
          || !(
#line 29654 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9262; /* avx512vl_compressv4sf_mask */

    case E_V2DImode:
      if (pattern838 (x3, 
E_QImode, 
E_V2DImode) != 0
          || !(
#line 29654 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1015 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9263; /* avx512vl_compressv2di_mask */

    case E_V2DFmode:
      if (pattern838 (x3, 
E_QImode, 
E_V2DFmode) != 0
          || !(
#line 29654 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1015 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9264; /* avx512vl_compressv2df_mask */

    case E_V64QImode:
      if (pattern838 (x3, 
E_DImode, 
E_V64QImode) != 0
          || !(
#line 29667 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9265; /* compressv64qi_mask */

    case E_V16QImode:
      if (pattern838 (x3, 
E_HImode, 
E_V16QImode) != 0
          || !(
#line 29667 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9266; /* compressv16qi_mask */

    case E_V32QImode:
      if (pattern838 (x3, 
E_SImode, 
E_V32QImode) != 0
          || !(
#line 29667 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9267; /* compressv32qi_mask */

    case E_V32HImode:
      if (pattern838 (x3, 
E_SImode, 
E_V32HImode) != 0
          || !(
#line 29667 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 319 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9268; /* compressv32hi_mask */

    case E_V16HImode:
      if (pattern838 (x3, 
E_HImode, 
E_V16HImode) != 0
          || !(
#line 29667 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 319 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9269; /* compressv16hi_mask */

    case E_V8HImode:
      if (pattern838 (x3, 
E_QImode, 
E_V8HImode) != 0
          || !(
#line 29667 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 319 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9270; /* compressv8hi_mask */

    default:
      return -1;
    }
}

 int
recog_243 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern164 (x1))
    {
    case 0:
      if (!(
#line 30418 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9576; /* vpshrdv_v32hi */

    case 1:
      if (!(
#line 30418 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9577; /* vpshrdv_v16si */

    case 2:
      if (!(
#line 30418 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9578; /* vpshrdv_v8di */

    case 3:
      if (!(
#line 30418 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 759 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9579; /* vpshrdv_v16hi */

    case 4:
      if (!(
#line 30418 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 759 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9580; /* vpshrdv_v8si */

    case 5:
      if (!(
#line 30418 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 760 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9581; /* vpshrdv_v4di */

    case 6:
      if (!(
#line 30418 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 760 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9582; /* vpshrdv_v8hi */

    case 7:
      if (!(
#line 30418 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 761 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9583; /* vpshrdv_v4si */

    case 8:
      if (!(
#line 30418 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 761 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9584; /* vpshrdv_v2di */

    default:
      return -1;
    }
}

 int
recog_248 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (pattern606 (x3))
    {
    case 0:
      if ((
#line 7147 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1 && 1) && 
#line 555 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 3802; /* fma_fmaddc_v32hf */
      break;

    case 1:
      if ((
#line 7147 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1 && 1) && 
#line 555 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 3810; /* fma_fmaddc_v16hf */
      break;

    case 2:
      if ((
#line 7147 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1 && 1) && 
#line 555 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 3818; /* fma_fmaddc_v8hf */
      break;

    default:
      break;
    }
  if (GET_CODE (x5) != SUBREG
      || maybe_ne (SUBREG_BYTE (x5), 0))
    return -1;
  switch (pattern545 (x3))
    {
    case 0:
      if (!(
#line 7226 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()) && 
#line 555 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 3840; /* fma_v32hf_fmaddc_bcst */

    case 1:
      if (!(
#line 7226 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()) && 
#line 555 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3841; /* fma_v16hf_fmaddc_bcst */

    case 2:
      if (!(
#line 7226 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()) && 
#line 555 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3842; /* fma_v8hf_fmaddc_bcst */

    default:
      return -1;
    }
}

 int
recog_253 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern736 (x2, 
E_V2SFmode, 
E_V4SFmode) == 0
              && 
#line 11832 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return 4709; /* *vec_concatv4sf */
          break;

        case E_V8HFmode:
          if (pattern736 (x2, 
E_V4HFmode, 
E_V8HFmode) == 0
              && 
#line 11832 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return 4710; /* *vec_concatv8hf */
          break;

        case E_V8BFmode:
          if (pattern736 (x2, 
E_V4BFmode, 
E_V8BFmode) == 0
              && 
#line 11832 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return 4711; /* *vec_concatv8bf */
          break;

        case E_V16QImode:
          if (pattern736 (x2, 
E_V8QImode, 
E_V16QImode) == 0
              && 
#line 21572 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return 7889; /* *vec_concatv16qi */
          break;

        case E_V8HImode:
          if (pattern736 (x2, 
E_V4HImode, 
E_V8HImode) == 0
              && 
#line 21572 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return 7890; /* *vec_concatv8hi */
          break;

        case E_V4SImode:
          if (pattern736 (x2, 
E_V2SImode, 
E_V4SImode) == 0
              && 
#line 21572 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return 7891; /* *vec_concatv4si */
          break;

        case E_V2DImode:
          if (pattern736 (x2, 
E_DImode, 
E_V2DImode) == 0
              && 
#line 21660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return 7897; /* vec_concatv2di */
          break;

        case E_V32QImode:
          if (register_operand (operands[0], E_V32QImode)
              && GET_MODE (x2) == E_V32QImode
              && rtx_equal_p (x4, operands[1]))
            {
              if (memory_operand (operands[1], E_V16QImode)
                  && 
#line 27886 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))
                return 8658; /* avx2_vbroadcasti128_v32qi */
              if (nonimmediate_operand (operands[1], E_V16QImode)
                  && 
#line 28000 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))
                return 8677; /* avx_vbroadcastf128_v32qi */
            }
          break;

        case E_V16HImode:
          if (register_operand (operands[0], E_V16HImode)
              && GET_MODE (x2) == E_V16HImode
              && rtx_equal_p (x4, operands[1]))
            {
              if (memory_operand (operands[1], E_V8HImode)
                  && 
#line 27886 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))
                return 8659; /* avx2_vbroadcasti128_v16hi */
              if (nonimmediate_operand (operands[1], E_V8HImode)
                  && 
#line 28000 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))
                return 8678; /* avx_vbroadcastf128_v16hi */
            }
          break;

        case E_V8SImode:
          if (register_operand (operands[0], E_V8SImode)
              && GET_MODE (x2) == E_V8SImode
              && rtx_equal_p (x4, operands[1]))
            {
              if (memory_operand (operands[1], E_V4SImode)
                  && 
#line 27886 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))
                return 8660; /* avx2_vbroadcasti128_v8si */
              if (nonimmediate_operand (operands[1], E_V4SImode)
                  && 
#line 28000 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))
                return 8679; /* avx_vbroadcastf128_v8si */
            }
          break;

        case E_V4DImode:
          if (register_operand (operands[0], E_V4DImode)
              && GET_MODE (x2) == E_V4DImode
              && memory_operand (operands[1], E_V2DImode)
              && rtx_equal_p (x4, operands[1])
              && 
#line 27886 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return 8661; /* avx2_vbroadcasti128_v4di */
          break;

        case E_V8SFmode:
          if (pattern737 (x2, 
E_V4SFmode, 
E_V8SFmode) == 0
              && 
#line 28000 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return 8681; /* avx_vbroadcastf128_v8sf */
          break;

        case E_V4DFmode:
          if (pattern737 (x2, 
E_V2DFmode, 
E_V4DFmode) == 0
              && 
#line 28000 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return 8682; /* avx_vbroadcastf128_v4df */
          break;

        case E_V16HFmode:
          if (pattern737 (x2, 
E_V8HFmode, 
E_V16HFmode) == 0
              && 
#line 28000 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return 8683; /* avx_vbroadcastf128_v16hf */
          break;

        case E_V16BFmode:
          if (pattern737 (x2, 
E_V8BFmode, 
E_V16BFmode) == 0
              && 
#line 28000 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return 8684; /* avx_vbroadcastf128_v16bf */
          break;

        default:
          break;
        }
      break;

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern846 (x2, 
E_V2SFmode, 
E_V4SFmode) == 0
              && 
#line 11848 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
            return 4712; /* *vec_concatv4sf_0 */
          break;

        case E_V8HFmode:
          if (pattern846 (x2, 
E_V4HFmode, 
E_V8HFmode) == 0
              && 
#line 11848 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
            return 4713; /* *vec_concatv8hf_0 */
          break;

        case E_V8BFmode:
          if (pattern846 (x2, 
E_V4BFmode, 
E_V8BFmode) == 0
              && 
#line 11848 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
            return 4714; /* *vec_concatv8bf_0 */
          break;

        case E_V16QImode:
          if (pattern846 (x2, 
E_V8QImode, 
E_V16QImode) == 0
              && 
#line 21643 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
            return 7894; /* *vec_concatv16qi_0 */
          break;

        case E_V8HImode:
          if (pattern846 (x2, 
E_V4HImode, 
E_V8HImode) == 0
              && 
#line 21643 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
            return 7895; /* *vec_concatv8hi_0 */
          break;

        case E_V4SImode:
          if (pattern846 (x2, 
E_V2SImode, 
E_V4SImode) == 0
              && 
#line 21643 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
            return 7896; /* *vec_concatv4si_0 */
          break;

        case E_V2DImode:
          if (pattern846 (x2, 
E_DImode, 
E_V2DImode) == 0
              && 
#line 21721 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
            return 7898; /* *vec_concatv2di_0 */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DFmode:
      if (pattern738 (x2, 
E_DFmode, 
E_V2DFmode) != 0
          || !
#line 14909 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 6640; /* vec_concatv2df */

    case E_V32QImode:
      if (pattern738 (x2, 
E_V16QImode, 
E_V32QImode) != 0
          || !
#line 28945 "../../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V16QImode)
       || !MEM_P (operands[1]))))
        return -1;
      return 8972; /* avx_vec_concatv32qi */

    case E_V16HImode:
      if (pattern738 (x2, 
E_V8HImode, 
E_V16HImode) != 0
          || !
#line 28945 "../../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V8HImode)
       || !MEM_P (operands[1]))))
        return -1;
      return 8973; /* avx_vec_concatv16hi */

    case E_V16HFmode:
      if (pattern738 (x2, 
E_V8HFmode, 
E_V16HFmode) != 0
          || !
#line 28945 "../../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V8HFmode)
       || !MEM_P (operands[1]))))
        return -1;
      return 8974; /* avx_vec_concatv16hf */

    case E_V16BFmode:
      if (pattern738 (x2, 
E_V8BFmode, 
E_V16BFmode) != 0
          || !
#line 28945 "../../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V8BFmode)
       || !MEM_P (operands[1]))))
        return -1;
      return 8975; /* avx_vec_concatv16bf */

    case E_V8SImode:
      if (pattern738 (x2, 
E_V4SImode, 
E_V8SImode) != 0
          || !
#line 28945 "../../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V4SImode)
       || !MEM_P (operands[1]))))
        return -1;
      return 8976; /* avx_vec_concatv8si */

    case E_V8SFmode:
      if (pattern738 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
          || !
#line 28945 "../../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V4SFmode)
       || !MEM_P (operands[1]))))
        return -1;
      return 8978; /* avx_vec_concatv8sf */

    case E_V4DFmode:
      if (pattern738 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
          || !
#line 28945 "../../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V2DFmode)
       || !MEM_P (operands[1]))))
        return -1;
      return 8979; /* avx_vec_concatv4df */

    case E_V64QImode:
      if (pattern738 (x2, 
E_V32QImode, 
E_V64QImode) != 0
          || !(
#line 28945 "../../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V32QImode)
       || !MEM_P (operands[1]))) && 
#line 364 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8980; /* avx_vec_concatv64qi */

    case E_V32HImode:
      if (pattern738 (x2, 
E_V16HImode, 
E_V32HImode) != 0
          || !(
#line 28945 "../../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V16HImode)
       || !MEM_P (operands[1]))) && 
#line 365 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8981; /* avx_vec_concatv32hi */

    case E_V32HFmode:
      if (pattern738 (x2, 
E_V16HFmode, 
E_V32HFmode) != 0
          || !(
#line 28945 "../../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V16HFmode)
       || !MEM_P (operands[1]))) && 
#line 366 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8982; /* avx_vec_concatv32hf */

    case E_V32BFmode:
      if (pattern738 (x2, 
E_V16BFmode, 
E_V32BFmode) != 0
          || !(
#line 28945 "../../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V16BFmode)
       || !MEM_P (operands[1]))) && 
#line 367 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8983; /* avx_vec_concatv32bf */

    case E_V16SImode:
      if (pattern738 (x2, 
E_V8SImode, 
E_V16SImode) != 0
          || !(
#line 28945 "../../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V8SImode)
       || !MEM_P (operands[1]))) && 
#line 368 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8984; /* avx_vec_concatv16si */

    case E_V8DImode:
      if (pattern738 (x2, 
E_V4DImode, 
E_V8DImode) != 0
          || !(
#line 28945 "../../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V4DImode)
       || !MEM_P (operands[1]))) && 
#line 369 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8985; /* avx_vec_concatv8di */

    case E_V16SFmode:
      if (pattern738 (x2, 
E_V8SFmode, 
E_V16SFmode) != 0
          || !(
#line 28945 "../../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V8SFmode)
       || !MEM_P (operands[1]))) && 
#line 370 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8986; /* avx_vec_concatv16sf */

    case E_V8DFmode:
      if (pattern738 (x2, 
E_V4DFmode, 
E_V8DFmode) != 0
          || !(
#line 28945 "../../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V4DFmode)
       || !MEM_P (operands[1]))) && 
#line 371 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8987; /* avx_vec_concatv8df */

    default:
      return -1;
    }
}

 int
recog_259 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x3, 0, 0);
  switch (XWINT (x6, 0))
    {
    case 6LL:
      x7 = XVECEXP (x3, 0, 1);
      if (XWINT (x7, 0) != 7LL
          || XWINT (x4, 0) != 2LL
          || XWINT (x5, 0) != 3LL
          || pattern1428 (x2) != 0
          || !
#line 11060 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 4662; /* sse_movhlps */

    case 0LL:
      x7 = XVECEXP (x3, 0, 1);
      switch (XWINT (x7, 0))
        {
        case 1LL:
          if (XWINT (x4, 0) != 4LL
              || XWINT (x5, 0) != 5LL
              || pattern1428 (x2) != 0
              || !
#line 11105 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (UNKNOWN, V4SFmode, operands)))
            return -1;
          return 4663; /* sse_movlhps */

        case 4LL:
          switch (XWINT (x4, 0))
            {
            case 1LL:
              if (XWINT (x5, 0) != 5LL
                  || pattern1217 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
                  || !
#line 11322 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
                return -1;
              return 4678; /* vec_interleave_lowv4sf */

            case 2LL:
              if (XWINT (x5, 0) != 6LL)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4DFmode:
                  if (!register_operand (operands[0], E_V4DFmode)
                      || GET_MODE (x2) != E_V4DFmode)
                    return -1;
                  x8 = XEXP (x2, 0);
                  if (GET_MODE (x8) != E_V8DFmode)
                    return -1;
                  if (nonimmediate_operand (operands[1], E_V4DFmode))
                    {
                      x9 = XEXP (x8, 1);
                      if (rtx_equal_p (x9, operands[1])
                          && 
#line 13469 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && 1))
                        return 4831; /* avx_movddup256 */
                    }
                  if (!register_operand (operands[1], E_V4DFmode))
                    return -1;
                  x9 = XEXP (x8, 1);
                  operands[2] = x9;
                  if (!nonimmediate_operand (operands[2], E_V4DFmode)
                      || !
#line 13483 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && 1))
                    return -1;
                  return 4833; /* avx_unpcklpd256 */

                case E_V4DImode:
                  if (pattern1486 (x2, 
E_V4DImode, 
E_V8DImode) != 0
                      || !
#line 14515 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
                    return -1;
                  return 6622; /* avx2_interleave_lowv4di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 0LL:
          if (XWINT (x4, 0) != 6LL
              || XWINT (x5, 0) != 6LL
              || pattern1429 (x2) != 0
              || !
#line 11412 "../../../gcc/config/i386/sse.md"
(TARGET_SSE3 && 1))
            return -1;
          return 4687; /* sse3_movsldup */

        default:
          return -1;
        }

    case 2LL:
      x7 = XVECEXP (x3, 0, 1);
      if (XWINT (x7, 0) != 6LL
          || XWINT (x4, 0) != 3LL
          || XWINT (x5, 0) != 7LL
          || pattern1217 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
          || !
#line 11217 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1))
        return -1;
      return 4671; /* vec_interleave_highv4sf */

    case 1LL:
      if (XWINT (x5, 0) != 7LL)
        return -1;
      x7 = XVECEXP (x3, 0, 1);
      switch (XWINT (x7, 0))
        {
        case 1LL:
          if (XWINT (x4, 0) != 7LL
              || pattern1429 (x2) != 0
              || !
#line 11359 "../../../gcc/config/i386/sse.md"
(TARGET_SSE3 && 1))
            return -1;
          return 4681; /* sse3_movshdup */

        case 5LL:
          if (XWINT (x4, 0) != 3LL)
            return -1;
          x8 = XEXP (x2, 0);
          x9 = XEXP (x8, 1);
          operands[2] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V4DFmode:
              if (pattern1305 (x2, 
E_V4DFmode, 
E_V8DFmode) != 0
                  || !
#line 13339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && 1))
                return -1;
              return 4823; /* avx_unpckhpd256 */

            case E_V4DImode:
              if (pattern1305 (x2, 
E_V4DImode, 
E_V8DImode) != 0
                  || !
#line 14465 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
                return -1;
              return 6616; /* avx2_interleave_highv4di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_260 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x2, 1);
  x6 = XVECEXP (x5, 0, 1);
  operands[4] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[5] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[6] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (pattern1392 (x2, 
E_V4SImode, 
E_V8SImode) != 0
          || !
#line 11556 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
        return -1;
      return 4694; /* sse_shufps_v4si */

    case E_V4SFmode:
      if (pattern1392 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
          || !
#line 11556 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
        return -1;
      return 4695; /* sse_shufps_v4sf */

    case E_V4DFmode:
      if (pattern1305 (x2, 
E_V4DFmode, 
E_V8DFmode) != 0)
        return -1;
      if (const_0_to_1_operand (operands[3], E_VOIDmode)
          && const_4_to_5_operand (operands[4], E_VOIDmode)
          && const_2_to_3_operand (operands[5], E_VOIDmode)
          && const_6_to_7_operand (operands[6], E_VOIDmode)
          && 
#line 14398 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && 1))
        return 6613; /* avx_shufpd256_1 */
      if (!const_0_to_3_operand (operands[3], E_VOIDmode)
          || !const_0_to_3_operand (operands[4], E_VOIDmode)
          || !const_4_to_7_operand (operands[5], E_VOIDmode)
          || !const_4_to_7_operand (operands[6], E_VOIDmode)
          || !
#line 20179 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL
   && (INTVAL (operands[3]) & 1) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && (INTVAL (operands[5]) & 1) == 0
   && INTVAL (operands[5]) == INTVAL (operands[6]) - 1))
        return -1;
      return 7830; /* *avx512dq_shuf_f64x2_1 */

    case E_V4DImode:
      if (pattern1305 (x2, 
E_V4DImode, 
E_V8DImode) != 0
          || pattern1391 () != 0
          || !
#line 20179 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL
   && (INTVAL (operands[3]) & 1) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && (INTVAL (operands[5]) & 1) == 0
   && INTVAL (operands[5]) == INTVAL (operands[6]) - 1))
        return -1;
      return 7828; /* *avx512dq_shuf_i64x2_1 */

    default:
      return -1;
    }
}

 int
recog_263 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) == CONST_INT)
    {
      res = recog_262 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x4;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 1);
  operands[2] = x7;
  operands[4] = x5;
  x8 = XVECEXP (x3, 0, 2);
  operands[5] = x8;
  x9 = XVECEXP (x3, 0, 3);
  operands[6] = x9;
  x10 = XVECEXP (x3, 0, 4);
  operands[7] = x10;
  x11 = XVECEXP (x3, 0, 5);
  operands[8] = x11;
  x12 = XVECEXP (x3, 0, 6);
  operands[9] = x12;
  x13 = XVECEXP (x3, 0, 7);
  operands[10] = x13;
  switch (GET_MODE (operands[0]))
    {
    case E_V8SFmode:
      if (pattern1305 (x2, 
E_V8SFmode, 
E_V16SFmode) != 0)
        return -1;
      if (const_0_to_3_operand (operands[3], E_VOIDmode)
          && const_0_to_3_operand (operands[4], E_VOIDmode)
          && const_8_to_11_operand (operands[5], E_VOIDmode)
          && const_8_to_11_operand (operands[6], E_VOIDmode)
          && const_4_to_7_operand (operands[7], E_VOIDmode)
          && const_4_to_7_operand (operands[8], E_VOIDmode)
          && const_12_to_15_operand (operands[9], E_VOIDmode)
          && const_12_to_15_operand (operands[10], E_VOIDmode)
          && 
#line 11477 "../../../gcc/config/i386/sse.md"
(TARGET_AVX
   && 1
   && (INTVAL (operands[3]) == (INTVAL (operands[7]) - 4)
       && INTVAL (operands[4]) == (INTVAL (operands[8]) - 4)
       && INTVAL (operands[5]) == (INTVAL (operands[9]) - 4)
       && INTVAL (operands[6]) == (INTVAL (operands[10]) - 4))))
        return 4691; /* avx_shufps256_1 */
      if (!const_0_to_7_operand (operands[3], E_VOIDmode)
          || pattern1541 () != 0
          || !
#line 20334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL
   && (INTVAL (operands[3]) & 3) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && INTVAL (operands[3]) == INTVAL (operands[5]) - 2
   && INTVAL (operands[3]) == INTVAL (operands[6]) - 3
   && (INTVAL (operands[7]) & 3) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && INTVAL (operands[7]) == INTVAL (operands[9]) - 2
   && INTVAL (operands[7]) == INTVAL (operands[10]) - 3))
        return -1;
      return 7842; /* avx512vl_shuf_f32x4_1 */

    case E_V8DFmode:
      if (pattern1305 (x2, 
E_V8DFmode, 
E_V16DFmode) != 0)
        return -1;
      if (const_0_to_1_operand (operands[3], E_VOIDmode)
          && const_8_to_9_operand (operands[4], E_VOIDmode)
          && const_2_to_3_operand (operands[5], E_VOIDmode)
          && const_10_to_11_operand (operands[6], E_VOIDmode)
          && const_4_to_5_operand (operands[7], E_VOIDmode)
          && const_12_to_13_operand (operands[8], E_VOIDmode)
          && const_6_to_7_operand (operands[9], E_VOIDmode)
          && const_14_to_15_operand (operands[10], E_VOIDmode)
          && 
#line 14349 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return 6611; /* avx512f_shufpd512_1 */
      if (!const_0_to_7_operand (operands[3], E_VOIDmode)
          || pattern1541 () != 0
          || !(
#line 20236 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[3]) & 1) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && (INTVAL (operands[5]) & 1) == 0
   && INTVAL (operands[5]) == INTVAL (operands[6]) - 1
   && (INTVAL (operands[7]) & 1) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && (INTVAL (operands[9]) & 1) == 0
   && INTVAL (operands[9]) == INTVAL (operands[10]) - 1) && 
#line 718 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7832; /* avx512f_shuf_f64x2_1 */

    case E_V8DImode:
      if (pattern1542 (x2, 
E_V8DImode, 
E_V16DImode) != 0
          || !(
#line 20236 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[3]) & 1) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && (INTVAL (operands[5]) & 1) == 0
   && INTVAL (operands[5]) == INTVAL (operands[6]) - 1
   && (INTVAL (operands[7]) & 1) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && (INTVAL (operands[9]) & 1) == 0
   && INTVAL (operands[9]) == INTVAL (operands[10]) - 1) && 
#line 718 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7834; /* avx512f_shuf_i64x2_1 */

    case E_V8SImode:
      if (pattern1542 (x2, 
E_V8SImode, 
E_V16SImode) != 0
          || !
#line 20334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL
   && (INTVAL (operands[3]) & 3) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && INTVAL (operands[3]) == INTVAL (operands[5]) - 2
   && INTVAL (operands[3]) == INTVAL (operands[6]) - 3
   && (INTVAL (operands[7]) & 3) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && INTVAL (operands[7]) == INTVAL (operands[9]) - 2
   && INTVAL (operands[7]) == INTVAL (operands[10]) - 3))
        return -1;
      return 7840; /* avx512vl_shuf_i32x4_1 */

    default:
      return -1;
    }
}

 int
recog_266 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) == CONST_INT)
    {
      x6 = XEXP (x2, 0);
      x7 = XEXP (x6, 1);
      operands[2] = x7;
      switch (XWINT (x4, 0))
        {
        case 1LL:
          if (XWINT (x5, 0) == 3LL)
            {
              switch (GET_MODE (operands[0]))
                {
                case E_V2DFmode:
                  if (pattern1363 (x2, 
E_V2DFmode, 
E_V4DFmode) == 0
                      && 
#line 13412 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_vec_interleave_v2df_operator_ok (operands, 1)))
                    return 4826; /* *vec_interleave_highv2df */
                  break;

                case E_V2DImode:
                  if (pattern1364 (x2, 
E_V2DImode, 
E_V4DImode) == 0
                      && 
#line 14495 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1))
                    return 6620; /* vec_interleave_highv2di */
                  break;

                default:
                  break;
                }
            }
          break;

        case 0LL:
          if (XWINT (x5, 0) == 2LL)
            {
              switch (GET_MODE (operands[0]))
                {
                case E_V2DFmode:
                  if (pattern1363 (x2, 
E_V2DFmode, 
E_V4DFmode) == 0
                      && 
#line 13555 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_vec_interleave_v2df_operator_ok (operands, 0)))
                    return 4836; /* *vec_interleave_lowv2df */
                  break;

                case E_V2DImode:
                  if (pattern1364 (x2, 
E_V2DImode, 
E_V4DImode) == 0
                      && 
#line 14545 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1))
                    return 6626; /* vec_interleave_lowv2di */
                  break;

                default:
                  break;
                }
            }
          break;

        default:
          break;
        }
    }
  operands[3] = x4;
  if (!const_0_to_1_operand (operands[3], E_VOIDmode))
    return -1;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 1);
  operands[2] = x7;
  operands[4] = x5;
  if (!const_2_to_3_operand (operands[4], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (pattern1364 (x2, 
E_V2DImode, 
E_V4DImode) != 0
          || !
#line 14563 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
        return -1;
      return 6628; /* sse2_shufpd_v2di */

    case E_V2DFmode:
      if (pattern1364 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
          || !
#line 14563 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
        return -1;
      return 6629; /* sse2_shufpd_v2df */

    default:
      return -1;
    }
}

 int
recog_267 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55, x56, x57;
  rtx x58, x59, x60, x61, x62, x63, x64, x65;
  rtx x66, x67;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (pattern613 (x3) != 0)
    return -1;
  x4 = XVECEXP (x3, 0, 32);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 33);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x3, 0, 34);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x3, 0, 35);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x3, 0, 36);
  if (GET_CODE (x8) != CONST_INT)
    return -1;
  x9 = XVECEXP (x3, 0, 37);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XVECEXP (x3, 0, 38);
  if (GET_CODE (x10) != CONST_INT)
    return -1;
  x11 = XVECEXP (x3, 0, 39);
  if (GET_CODE (x11) != CONST_INT)
    return -1;
  x12 = XVECEXP (x3, 0, 40);
  if (GET_CODE (x12) != CONST_INT)
    return -1;
  x13 = XVECEXP (x3, 0, 41);
  if (GET_CODE (x13) != CONST_INT)
    return -1;
  x14 = XVECEXP (x3, 0, 42);
  if (GET_CODE (x14) != CONST_INT)
    return -1;
  x15 = XVECEXP (x3, 0, 43);
  if (GET_CODE (x15) != CONST_INT)
    return -1;
  x16 = XVECEXP (x3, 0, 44);
  if (GET_CODE (x16) != CONST_INT)
    return -1;
  x17 = XVECEXP (x3, 0, 45);
  if (GET_CODE (x17) != CONST_INT)
    return -1;
  x18 = XVECEXP (x3, 0, 46);
  if (GET_CODE (x18) != CONST_INT)
    return -1;
  x19 = XVECEXP (x3, 0, 47);
  if (GET_CODE (x19) != CONST_INT)
    return -1;
  x20 = XVECEXP (x3, 0, 48);
  if (GET_CODE (x20) != CONST_INT)
    return -1;
  x21 = XVECEXP (x3, 0, 49);
  if (GET_CODE (x21) != CONST_INT)
    return -1;
  x22 = XVECEXP (x3, 0, 50);
  if (GET_CODE (x22) != CONST_INT)
    return -1;
  x23 = XVECEXP (x3, 0, 51);
  if (GET_CODE (x23) != CONST_INT)
    return -1;
  x24 = XVECEXP (x3, 0, 52);
  if (GET_CODE (x24) != CONST_INT)
    return -1;
  x25 = XVECEXP (x3, 0, 53);
  if (GET_CODE (x25) != CONST_INT)
    return -1;
  x26 = XVECEXP (x3, 0, 54);
  if (GET_CODE (x26) != CONST_INT)
    return -1;
  x27 = XVECEXP (x3, 0, 55);
  if (GET_CODE (x27) != CONST_INT)
    return -1;
  x28 = XVECEXP (x3, 0, 56);
  if (GET_CODE (x28) != CONST_INT)
    return -1;
  x29 = XVECEXP (x3, 0, 57);
  if (GET_CODE (x29) != CONST_INT)
    return -1;
  x30 = XVECEXP (x3, 0, 58);
  if (GET_CODE (x30) != CONST_INT)
    return -1;
  x31 = XVECEXP (x3, 0, 59);
  if (GET_CODE (x31) != CONST_INT)
    return -1;
  x32 = XVECEXP (x3, 0, 60);
  if (GET_CODE (x32) != CONST_INT)
    return -1;
  x33 = XVECEXP (x3, 0, 61);
  if (GET_CODE (x33) != CONST_INT)
    return -1;
  x34 = XVECEXP (x3, 0, 62);
  if (GET_CODE (x34) != CONST_INT)
    return -1;
  x35 = XVECEXP (x3, 0, 63);
  if (GET_CODE (x35) != CONST_INT
      || pattern1486 (x2, 
E_V64QImode, 
E_V128QImode) != 0)
    return -1;
  x36 = XVECEXP (x3, 0, 0);
  switch (XWINT (x36, 0))
    {
    case 8LL:
      x37 = XVECEXP (x3, 0, 1);
      if (XWINT (x37, 0) != 72LL)
        return -1;
      x38 = XVECEXP (x3, 0, 2);
      if (XWINT (x38, 0) != 9LL)
        return -1;
      x39 = XVECEXP (x3, 0, 3);
      if (XWINT (x39, 0) != 73LL)
        return -1;
      x40 = XVECEXP (x3, 0, 4);
      if (XWINT (x40, 0) != 10LL)
        return -1;
      x41 = XVECEXP (x3, 0, 5);
      if (XWINT (x41, 0) != 74LL)
        return -1;
      x42 = XVECEXP (x3, 0, 6);
      if (XWINT (x42, 0) != 11LL)
        return -1;
      x43 = XVECEXP (x3, 0, 7);
      if (XWINT (x43, 0) != 75LL)
        return -1;
      x44 = XVECEXP (x3, 0, 8);
      if (XWINT (x44, 0) != 12LL)
        return -1;
      x45 = XVECEXP (x3, 0, 9);
      if (XWINT (x45, 0) != 76LL)
        return -1;
      x46 = XVECEXP (x3, 0, 10);
      if (XWINT (x46, 0) != 13LL)
        return -1;
      x47 = XVECEXP (x3, 0, 11);
      if (XWINT (x47, 0) != 77LL)
        return -1;
      x48 = XVECEXP (x3, 0, 12);
      if (XWINT (x48, 0) != 14LL)
        return -1;
      x49 = XVECEXP (x3, 0, 13);
      if (XWINT (x49, 0) != 78LL)
        return -1;
      x50 = XVECEXP (x3, 0, 14);
      if (XWINT (x50, 0) != 15LL)
        return -1;
      x51 = XVECEXP (x3, 0, 15);
      if (XWINT (x51, 0) != 79LL)
        return -1;
      x52 = XVECEXP (x3, 0, 16);
      if (XWINT (x52, 0) != 24LL)
        return -1;
      x53 = XVECEXP (x3, 0, 17);
      if (XWINT (x53, 0) != 88LL)
        return -1;
      x54 = XVECEXP (x3, 0, 18);
      if (XWINT (x54, 0) != 25LL)
        return -1;
      x55 = XVECEXP (x3, 0, 19);
      if (XWINT (x55, 0) != 89LL)
        return -1;
      x56 = XVECEXP (x3, 0, 20);
      if (XWINT (x56, 0) != 26LL)
        return -1;
      x57 = XVECEXP (x3, 0, 21);
      if (XWINT (x57, 0) != 90LL)
        return -1;
      x58 = XVECEXP (x3, 0, 22);
      if (XWINT (x58, 0) != 27LL)
        return -1;
      x59 = XVECEXP (x3, 0, 23);
      if (XWINT (x59, 0) != 91LL)
        return -1;
      x60 = XVECEXP (x3, 0, 24);
      if (XWINT (x60, 0) != 28LL)
        return -1;
      x61 = XVECEXP (x3, 0, 25);
      if (XWINT (x61, 0) != 92LL)
        return -1;
      x62 = XVECEXP (x3, 0, 26);
      if (XWINT (x62, 0) != 29LL)
        return -1;
      x63 = XVECEXP (x3, 0, 27);
      if (XWINT (x63, 0) != 93LL)
        return -1;
      x64 = XVECEXP (x3, 0, 28);
      if (XWINT (x64, 0) != 30LL)
        return -1;
      x65 = XVECEXP (x3, 0, 29);
      if (XWINT (x65, 0) != 94LL)
        return -1;
      x66 = XVECEXP (x3, 0, 30);
      if (XWINT (x66, 0) != 31LL)
        return -1;
      x67 = XVECEXP (x3, 0, 31);
      if (XWINT (x67, 0) != 95LL
          || XWINT (x4, 0) != 40LL
          || XWINT (x5, 0) != 104LL
          || XWINT (x6, 0) != 41LL
          || XWINT (x7, 0) != 105LL
          || XWINT (x8, 0) != 42LL
          || XWINT (x9, 0) != 106LL
          || XWINT (x10, 0) != 43LL
          || XWINT (x11, 0) != 107LL
          || XWINT (x12, 0) != 44LL
          || XWINT (x13, 0) != 108LL
          || XWINT (x14, 0) != 45LL
          || XWINT (x15, 0) != 109LL
          || XWINT (x16, 0) != 46LL
          || XWINT (x17, 0) != 110LL
          || XWINT (x18, 0) != 47LL
          || XWINT (x19, 0) != 111LL
          || XWINT (x20, 0) != 56LL
          || XWINT (x21, 0) != 120LL
          || XWINT (x22, 0) != 57LL
          || XWINT (x23, 0) != 121LL
          || XWINT (x24, 0) != 58LL
          || XWINT (x25, 0) != 122LL
          || XWINT (x26, 0) != 59LL
          || XWINT (x27, 0) != 123LL
          || XWINT (x28, 0) != 60LL
          || XWINT (x29, 0) != 124LL
          || XWINT (x30, 0) != 61LL
          || XWINT (x31, 0) != 125LL
          || XWINT (x32, 0) != 62LL
          || XWINT (x33, 0) != 126LL
          || XWINT (x34, 0) != 63LL
          || XWINT (x35, 0) != 127LL
          || !
#line 19424 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
        return -1;
      return 7734; /* avx512bw_interleave_highv64qi */

    case 0LL:
      x37 = XVECEXP (x3, 0, 1);
      if (XWINT (x37, 0) != 64LL)
        return -1;
      x38 = XVECEXP (x3, 0, 2);
      if (XWINT (x38, 0) != 1LL)
        return -1;
      x39 = XVECEXP (x3, 0, 3);
      if (XWINT (x39, 0) != 65LL)
        return -1;
      x40 = XVECEXP (x3, 0, 4);
      if (XWINT (x40, 0) != 2LL)
        return -1;
      x41 = XVECEXP (x3, 0, 5);
      if (XWINT (x41, 0) != 66LL)
        return -1;
      x42 = XVECEXP (x3, 0, 6);
      if (XWINT (x42, 0) != 3LL)
        return -1;
      x43 = XVECEXP (x3, 0, 7);
      if (XWINT (x43, 0) != 67LL)
        return -1;
      x44 = XVECEXP (x3, 0, 8);
      if (XWINT (x44, 0) != 4LL)
        return -1;
      x45 = XVECEXP (x3, 0, 9);
      if (XWINT (x45, 0) != 68LL)
        return -1;
      x46 = XVECEXP (x3, 0, 10);
      if (XWINT (x46, 0) != 5LL)
        return -1;
      x47 = XVECEXP (x3, 0, 11);
      if (XWINT (x47, 0) != 69LL)
        return -1;
      x48 = XVECEXP (x3, 0, 12);
      if (XWINT (x48, 0) != 6LL)
        return -1;
      x49 = XVECEXP (x3, 0, 13);
      if (XWINT (x49, 0) != 70LL)
        return -1;
      x50 = XVECEXP (x3, 0, 14);
      if (XWINT (x50, 0) != 7LL)
        return -1;
      x51 = XVECEXP (x3, 0, 15);
      if (XWINT (x51, 0) != 71LL)
        return -1;
      x52 = XVECEXP (x3, 0, 16);
      if (XWINT (x52, 0) != 16LL)
        return -1;
      x53 = XVECEXP (x3, 0, 17);
      if (XWINT (x53, 0) != 80LL)
        return -1;
      x54 = XVECEXP (x3, 0, 18);
      if (XWINT (x54, 0) != 17LL)
        return -1;
      x55 = XVECEXP (x3, 0, 19);
      if (XWINT (x55, 0) != 81LL)
        return -1;
      x56 = XVECEXP (x3, 0, 20);
      if (XWINT (x56, 0) != 18LL)
        return -1;
      x57 = XVECEXP (x3, 0, 21);
      if (XWINT (x57, 0) != 82LL)
        return -1;
      x58 = XVECEXP (x3, 0, 22);
      if (XWINT (x58, 0) != 19LL)
        return -1;
      x59 = XVECEXP (x3, 0, 23);
      if (XWINT (x59, 0) != 83LL)
        return -1;
      x60 = XVECEXP (x3, 0, 24);
      if (XWINT (x60, 0) != 20LL)
        return -1;
      x61 = XVECEXP (x3, 0, 25);
      if (XWINT (x61, 0) != 84LL)
        return -1;
      x62 = XVECEXP (x3, 0, 26);
      if (XWINT (x62, 0) != 21LL)
        return -1;
      x63 = XVECEXP (x3, 0, 27);
      if (XWINT (x63, 0) != 85LL)
        return -1;
      x64 = XVECEXP (x3, 0, 28);
      if (XWINT (x64, 0) != 22LL)
        return -1;
      x65 = XVECEXP (x3, 0, 29);
      if (XWINT (x65, 0) != 86LL)
        return -1;
      x66 = XVECEXP (x3, 0, 30);
      if (XWINT (x66, 0) != 23LL)
        return -1;
      x67 = XVECEXP (x3, 0, 31);
      if (XWINT (x67, 0) != 87LL
          || XWINT (x4, 0) != 32LL
          || XWINT (x5, 0) != 96LL
          || XWINT (x6, 0) != 33LL
          || XWINT (x7, 0) != 97LL
          || XWINT (x8, 0) != 34LL
          || XWINT (x9, 0) != 98LL
          || XWINT (x10, 0) != 35LL
          || XWINT (x11, 0) != 99LL
          || XWINT (x12, 0) != 36LL
          || XWINT (x13, 0) != 100LL
          || XWINT (x14, 0) != 37LL
          || XWINT (x15, 0) != 101LL
          || XWINT (x16, 0) != 38LL
          || XWINT (x17, 0) != 102LL
          || XWINT (x18, 0) != 39LL
          || XWINT (x19, 0) != 103LL
          || XWINT (x20, 0) != 48LL
          || XWINT (x21, 0) != 112LL
          || XWINT (x22, 0) != 49LL
          || XWINT (x23, 0) != 113LL
          || XWINT (x24, 0) != 50LL
          || XWINT (x25, 0) != 114LL
          || XWINT (x26, 0) != 51LL
          || XWINT (x27, 0) != 115LL
          || XWINT (x28, 0) != 52LL
          || XWINT (x29, 0) != 116LL
          || XWINT (x30, 0) != 53LL
          || XWINT (x31, 0) != 117LL
          || XWINT (x32, 0) != 54LL
          || XWINT (x33, 0) != 118LL
          || XWINT (x34, 0) != 55LL
          || XWINT (x35, 0) != 119LL
          || !
#line 19520 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
        return -1;
      return 7740; /* avx512bw_interleave_lowv64qi */

    default:
      return -1;
    }
}

 int
recog_285 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16BFmode:
      if (GET_MODE (x2) != E_V16BFmode)
        return -1;
      if (register_operand (operands[0], E_V16BFmode)
          && vector_operand (operands[1], E_V16BFmode)
          && vector_operand (operands[2], E_V16BFmode)
          && (
#line 5349 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 16 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 427 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 3187; /* *andv16bf3 */
      if (!nonimmediate_operand (operands[0], E_V16BFmode)
          || !nonimmediate_operand (operands[1], E_V16BFmode)
          || !float_vector_all_ones_operand (operands[2], E_V16BFmode)
          || !(
#line 5457 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 413 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 3242; /* *bit_and_float_vector_all_ones */

    case E_V8BFmode:
      if (GET_MODE (x2) != E_V8BFmode)
        return -1;
      if (register_operand (operands[0], E_V8BFmode)
          && vector_operand (operands[1], E_V8BFmode)
          && vector_operand (operands[2], E_V8BFmode)
          && (
#line 5349 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 16 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 427 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return 3190; /* *andv8bf3 */
      if (!nonimmediate_operand (operands[0], E_V8BFmode)
          || !nonimmediate_operand (operands[1], E_V8BFmode)
          || !float_vector_all_ones_operand (operands[2], E_V8BFmode)
          || !(
#line 5457 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 413 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 3243; /* *bit_and_float_vector_all_ones */

    case E_V16HFmode:
      if (GET_MODE (x2) != E_V16HFmode)
        return -1;
      if (register_operand (operands[0], E_V16HFmode)
          && vector_operand (operands[1], E_V16HFmode)
          && vector_operand (operands[2], E_V16HFmode)
          && (
#line 5349 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 16 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 428 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 3193; /* *andv16hf3 */
      if (!nonimmediate_operand (operands[0], E_V16HFmode)
          || !nonimmediate_operand (operands[1], E_V16HFmode)
          || !float_vector_all_ones_operand (operands[2], E_V16HFmode)
          || !(
#line 5457 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 415 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 3245; /* *bit_and_float_vector_all_ones */

    case E_V8HFmode:
      if (GET_MODE (x2) != E_V8HFmode)
        return -1;
      if (register_operand (operands[0], E_V8HFmode)
          && vector_operand (operands[1], E_V8HFmode)
          && vector_operand (operands[2], E_V8HFmode)
          && (
#line 5349 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 16 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 428 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return 3196; /* *andv8hf3 */
      if (!nonimmediate_operand (operands[0], E_V8HFmode)
          || !nonimmediate_operand (operands[1], E_V8HFmode)
          || !float_vector_all_ones_operand (operands[2], E_V8HFmode)
          || !(
#line 5457 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 415 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 3246; /* *bit_and_float_vector_all_ones */

    case E_V8SFmode:
      if (GET_MODE (x2) != E_V8SFmode)
        return -1;
      if (register_operand (operands[0], E_V8SFmode)
          && vector_operand (operands[1], E_V8SFmode)
          && vector_operand (operands[2], E_V8SFmode)
          && (
#line 5349 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 32 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 429 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 3199; /* *andv8sf3 */
      if (!nonimmediate_operand (operands[0], E_V8SFmode)
          || !nonimmediate_operand (operands[1], E_V8SFmode)
          || !float_vector_all_ones_operand (operands[2], E_V8SFmode)
          || !(
#line 5457 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 416 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 3248; /* *bit_and_float_vector_all_ones */

    case E_V4SFmode:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      if (register_operand (operands[0], E_V4SFmode)
          && vector_operand (operands[1], E_V4SFmode)
          && vector_operand (operands[2], E_V4SFmode)
          && 
#line 5349 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 32 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 3205; /* *andv4sf3 */
      if (!nonimmediate_operand (operands[0], E_V4SFmode)
          || !nonimmediate_operand (operands[1], E_V4SFmode)
          || !float_vector_all_ones_operand (operands[2], E_V4SFmode)
          || !
#line 5457 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()))
        return -1;
      return 3249; /* *bit_and_float_vector_all_ones */

    case E_V4DFmode:
      if (GET_MODE (x2) != E_V4DFmode)
        return -1;
      if (register_operand (operands[0], E_V4DFmode)
          && vector_operand (operands[1], E_V4DFmode)
          && vector_operand (operands[2], E_V4DFmode)
          && (
#line 5349 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 64 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 430 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 3211; /* *andv4df3 */
      if (!nonimmediate_operand (operands[0], E_V4DFmode)
          || !nonimmediate_operand (operands[1], E_V4DFmode)
          || !float_vector_all_ones_operand (operands[2], E_V4DFmode)
          || !(
#line 5457 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 418 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 3251; /* *bit_and_float_vector_all_ones */

    case E_V2DFmode:
      if (GET_MODE (x2) != E_V2DFmode)
        return -1;
      if (register_operand (operands[0], E_V2DFmode)
          && vector_operand (operands[1], E_V2DFmode)
          && vector_operand (operands[2], E_V2DFmode)
          && (
#line 5349 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 64 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 430 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return 3217; /* *andv2df3 */
      if (!nonimmediate_operand (operands[0], E_V2DFmode)
          || !nonimmediate_operand (operands[1], E_V2DFmode)
          || !float_vector_all_ones_operand (operands[2], E_V2DFmode)
          || !(
#line 5457 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 418 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 3252; /* *bit_and_float_vector_all_ones */

    case E_V32BFmode:
      if (GET_MODE (x2) != E_V32BFmode
          || !nonimmediate_operand (operands[1], E_V32BFmode))
        return -1;
      if (register_operand (operands[0], E_V32BFmode)
          && nonimmediate_operand (operands[2], E_V32BFmode)
          && (
#line 5419 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (!false || 16 != 16)) && 
#line 492 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 3223; /* *andv32bf3 */
      if (!nonimmediate_operand (operands[0], E_V32BFmode)
          || !float_vector_all_ones_operand (operands[2], E_V32BFmode)
          || !(
#line 5457 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 412 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 3241; /* *bit_and_float_vector_all_ones */

    case E_V32HFmode:
      if (GET_MODE (x2) != E_V32HFmode
          || !nonimmediate_operand (operands[1], E_V32HFmode))
        return -1;
      if (register_operand (operands[0], E_V32HFmode)
          && nonimmediate_operand (operands[2], E_V32HFmode)
          && (
#line 5419 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (!false || 16 != 16)) && 
#line 493 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 3226; /* *andv32hf3 */
      if (!nonimmediate_operand (operands[0], E_V32HFmode)
          || !float_vector_all_ones_operand (operands[2], E_V32HFmode)
          || !(
#line 5457 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 414 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 3244; /* *bit_and_float_vector_all_ones */

    case E_V16SFmode:
      if (GET_MODE (x2) != E_V16SFmode
          || !nonimmediate_operand (operands[1], E_V16SFmode))
        return -1;
      if (register_operand (operands[0], E_V16SFmode)
          && nonimmediate_operand (operands[2], E_V16SFmode)
          && (
#line 5419 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (!false || 32 != 16)) && 
#line 494 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 3229; /* *andv16sf3 */
      if (!nonimmediate_operand (operands[0], E_V16SFmode)
          || !float_vector_all_ones_operand (operands[2], E_V16SFmode)
          || !(
#line 5457 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 416 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 3247; /* *bit_and_float_vector_all_ones */

    case E_V8DFmode:
      if (GET_MODE (x2) != E_V8DFmode
          || !nonimmediate_operand (operands[1], E_V8DFmode))
        return -1;
      if (register_operand (operands[0], E_V8DFmode)
          && nonimmediate_operand (operands[2], E_V8DFmode)
          && (
#line 5419 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (!false || 64 != 16)) && 
#line 495 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 3235; /* *andv8df3 */
      if (!nonimmediate_operand (operands[0], E_V8DFmode)
          || !float_vector_all_ones_operand (operands[2], E_V8DFmode)
          || !(
#line 5457 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 417 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 3250; /* *bit_and_float_vector_all_ones */

    case E_V16SImode:
      if (pattern170 (x2, 
E_V16SImode) != 0
          || !(
#line 18731 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && ix86_binary_operator_ok (AND, V16SImode, operands)) && 
#line 808 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 7419; /* *andv16si3 */

    case E_V8SImode:
      if (pattern170 (x2, 
E_V8SImode) != 0
          || !(
#line 18731 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && ix86_binary_operator_ok (AND, V8SImode, operands)) && 
#line 808 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 7425; /* *andv8si3 */

    case E_V4SImode:
      if (pattern170 (x2, 
E_V4SImode) != 0
          || !
#line 18731 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && ix86_binary_operator_ok (AND, V4SImode, operands)))
        return -1;
      return 7431; /* *andv4si3 */

    case E_V8DImode:
      if (pattern170 (x2, 
E_V8DImode) != 0
          || !(
#line 18731 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && ix86_binary_operator_ok (AND, V8DImode, operands)) && 
#line 809 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 7437; /* *andv8di3 */

    case E_V4DImode:
      if (pattern170 (x2, 
E_V4DImode) != 0
          || !(
#line 18731 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && ix86_binary_operator_ok (AND, V4DImode, operands)) && 
#line 809 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 7443; /* *andv4di3 */

    case E_V2DImode:
      if (pattern170 (x2, 
E_V2DImode) != 0
          || !
#line 18731 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && ix86_binary_operator_ok (AND, V2DImode, operands)))
        return -1;
      return 7449; /* *andv2di3 */

    case E_V64QImode:
      if (pattern26 (x2, 
E_V64QImode) != 0
          || !(
#line 18833 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 812 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 7455; /* *andv64qi3 */

    case E_V32QImode:
      if (pattern26 (x2, 
E_V32QImode) != 0
          || !(
#line 18833 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 812 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 7458; /* *andv32qi3 */

    case E_V16QImode:
      if (pattern26 (x2, 
E_V16QImode) != 0
          || !
#line 18833 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7461; /* *andv16qi3 */

    case E_V32HImode:
      if (pattern26 (x2, 
E_V32HImode) != 0
          || !(
#line 18833 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 813 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 7464; /* *andv32hi3 */

    case E_V16HImode:
      if (pattern26 (x2, 
E_V16HImode) != 0
          || !(
#line 18833 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 813 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 7467; /* *andv16hi3 */

    case E_V8HImode:
      if (pattern26 (x2, 
E_V8HImode) != 0
          || !
#line 18833 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7470; /* *andv8hi3 */

    case E_V1TImode:
      if (pattern610 (x2, 
E_V1TImode) != 0
          || !
#line 18930 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
        return -1;
      return 7473; /* andv1ti3 */

    default:
      return -1;
    }
}

 int
recog_294 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case NOT:
      switch (pattern476 (x2))
        {
        case 0:
          if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5281; /* *avx512bw_vpternlogv32hf_1 */

        case 1:
          if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5308; /* *avx512vl_vpternlogv16hf_1 */

        case 2:
          if (!
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5335; /* *avx512fp16_vpternlogv8hf_1 */

        case 3:
          if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5362; /* *avx512bw_vpternlogv32bf_1 */

        case 4:
          if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5389; /* *avx512vl_vpternlogv16bf_1 */

        case 5:
          if (!
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5416; /* *avx512vl_vpternlogv8bf_1 */

        case 6:
          if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5443; /* *avx512f_vpternlogv16sf_1 */

        case 7:
          if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5470; /* *avx512vl_vpternlogv8sf_1 */

        case 8:
          if (!
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5497; /* *avx512vl_vpternlogv4sf_1 */

        case 9:
          if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5524; /* *avx512f_vpternlogv8df_1 */

        case 10:
          if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5551; /* *avx512vl_vpternlogv4df_1 */

        case 11:
          if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 5578; /* *avx512vl_vpternlogv2df_1 */

        case 12:
          if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5284; /* *avx512bw_vpternlogv32hf_1 */

        case 13:
          if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5311; /* *avx512vl_vpternlogv16hf_1 */

        case 14:
          if (!
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5338; /* *avx512fp16_vpternlogv8hf_1 */

        case 15:
          if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5365; /* *avx512bw_vpternlogv32bf_1 */

        case 16:
          if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5392; /* *avx512vl_vpternlogv16bf_1 */

        case 17:
          if (!
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5419; /* *avx512vl_vpternlogv8bf_1 */

        case 18:
          if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5446; /* *avx512f_vpternlogv16sf_1 */

        case 19:
          if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5473; /* *avx512vl_vpternlogv8sf_1 */

        case 20:
          if (!
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5500; /* *avx512vl_vpternlogv4sf_1 */

        case 21:
          if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5527; /* *avx512f_vpternlogv8df_1 */

        case 22:
          if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5554; /* *avx512vl_vpternlogv4df_1 */

        case 23:
          if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 5581; /* *avx512vl_vpternlogv2df_1 */

        case 24:
          if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5287; /* *avx512bw_vpternlogv32hf_1 */

        case 25:
          if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5314; /* *avx512vl_vpternlogv16hf_1 */

        case 26:
          if (!
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5341; /* *avx512fp16_vpternlogv8hf_1 */

        case 27:
          if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5368; /* *avx512bw_vpternlogv32bf_1 */

        case 28:
          if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5395; /* *avx512vl_vpternlogv16bf_1 */

        case 29:
          if (!
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5422; /* *avx512vl_vpternlogv8bf_1 */

        case 30:
          if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5449; /* *avx512f_vpternlogv16sf_1 */

        case 31:
          if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5476; /* *avx512vl_vpternlogv8sf_1 */

        case 32:
          if (!
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5503; /* *avx512vl_vpternlogv4sf_1 */

        case 33:
          if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5530; /* *avx512f_vpternlogv8df_1 */

        case 34:
          if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5557; /* *avx512vl_vpternlogv4df_1 */

        case 35:
          if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 5584; /* *avx512vl_vpternlogv2df_1 */

        case 36:
          if (!(
#line 13946 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6349; /* *avx512bw_vpternlogv32hf_3 */

        case 37:
          if (!(
#line 13946 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6358; /* *avx512vl_vpternlogv16hf_3 */

        case 38:
          if (!
#line 13946 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6367; /* *avx512fp16_vpternlogv8hf_3 */

        case 39:
          if (!(
#line 13946 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6376; /* *avx512bw_vpternlogv32bf_3 */

        case 40:
          if (!(
#line 13946 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6385; /* *avx512vl_vpternlogv16bf_3 */

        case 41:
          if (!
#line 13946 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6394; /* *avx512vl_vpternlogv8bf_3 */

        case 42:
          if (!(
#line 13946 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6403; /* *avx512f_vpternlogv16sf_3 */

        case 43:
          if (!(
#line 13946 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6412; /* *avx512vl_vpternlogv8sf_3 */

        case 44:
          if (!
#line 13946 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6421; /* *avx512vl_vpternlogv4sf_3 */

        case 45:
          if (!(
#line 13946 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6430; /* *avx512f_vpternlogv8df_3 */

        case 46:
          if (!(
#line 13946 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6439; /* *avx512vl_vpternlogv4df_3 */

        case 47:
          if (!(
#line 13946 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6448; /* *avx512vl_vpternlogv2df_3 */

        default:
          return -1;
        }

    case AND:
      switch (pattern477 (x2))
        {
        case 0:
          if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5929; /* *avx512bw_vpternlogv32hf_2 */

        case 1:
          if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5956; /* *avx512vl_vpternlogv16hf_2 */

        case 2:
          if (!
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5983; /* *avx512fp16_vpternlogv8hf_2 */

        case 3:
          if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6010; /* *avx512bw_vpternlogv32bf_2 */

        case 4:
          if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6037; /* *avx512vl_vpternlogv16bf_2 */

        case 5:
          if (!
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6064; /* *avx512vl_vpternlogv8bf_2 */

        case 6:
          if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6091; /* *avx512f_vpternlogv16sf_2 */

        case 7:
          if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6118; /* *avx512vl_vpternlogv8sf_2 */

        case 8:
          if (!
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6145; /* *avx512vl_vpternlogv4sf_2 */

        case 9:
          if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6172; /* *avx512f_vpternlogv8df_2 */

        case 10:
          if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6199; /* *avx512vl_vpternlogv4df_2 */

        case 11:
          if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6226; /* *avx512vl_vpternlogv2df_2 */

        default:
          return -1;
        }

    case IOR:
      switch (pattern477 (x2))
        {
        case 0:
          if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5932; /* *avx512bw_vpternlogv32hf_2 */

        case 1:
          if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5959; /* *avx512vl_vpternlogv16hf_2 */

        case 2:
          if (!
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5986; /* *avx512fp16_vpternlogv8hf_2 */

        case 3:
          if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6013; /* *avx512bw_vpternlogv32bf_2 */

        case 4:
          if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6040; /* *avx512vl_vpternlogv16bf_2 */

        case 5:
          if (!
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6067; /* *avx512vl_vpternlogv8bf_2 */

        case 6:
          if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6094; /* *avx512f_vpternlogv16sf_2 */

        case 7:
          if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6121; /* *avx512vl_vpternlogv8sf_2 */

        case 8:
          if (!
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6148; /* *avx512vl_vpternlogv4sf_2 */

        case 9:
          if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6175; /* *avx512f_vpternlogv8df_2 */

        case 10:
          if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6202; /* *avx512vl_vpternlogv4df_2 */

        case 11:
          if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6229; /* *avx512vl_vpternlogv2df_2 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern477 (x2))
        {
        case 0:
          if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5935; /* *avx512bw_vpternlogv32hf_2 */

        case 1:
          if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5962; /* *avx512vl_vpternlogv16hf_2 */

        case 2:
          if (!
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5989; /* *avx512fp16_vpternlogv8hf_2 */

        case 3:
          if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6016; /* *avx512bw_vpternlogv32bf_2 */

        case 4:
          if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6043; /* *avx512vl_vpternlogv16bf_2 */

        case 5:
          if (!
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6070; /* *avx512vl_vpternlogv8bf_2 */

        case 6:
          if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6097; /* *avx512f_vpternlogv16sf_2 */

        case 7:
          if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6124; /* *avx512vl_vpternlogv8sf_2 */

        case 8:
          if (!
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6151; /* *avx512vl_vpternlogv4sf_2 */

        case 9:
          if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6178; /* *avx512f_vpternlogv8df_2 */

        case 10:
          if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6205; /* *avx512vl_vpternlogv4df_2 */

        case 11:
          if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6232; /* *avx512vl_vpternlogv2df_2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_303 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      return recog_255 (x1, insn, pnum_clobbers);

    case VEC_CONCAT:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case PLUS:
          switch (pattern285 (x3, 
PLUS))
            {
            case 0:
              if (!
#line 3667 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))
                return -1;
              return 2660; /* avx_haddv4df3 */

            case 1:
              if (!
#line 3843 "../../../gcc/config/i386/sse.md"
(TARGET_SSE3))
                return -1;
              return 2668; /* sse3_haddv4sf3 */

            default:
              return -1;
            }

        case MINUS:
          switch (pattern285 (x3, 
MINUS))
            {
            case 0:
              if (!
#line 3667 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))
                return -1;
              return 2661; /* avx_hsubv4df3 */

            case 1:
              if (!
#line 3843 "../../../gcc/config/i386/sse.md"
(TARGET_SSE3))
                return -1;
              return 2669; /* sse3_hsubv4sf3 */

            default:
              return -1;
            }

        case VEC_CONCAT:
          if (GET_MODE (x5) != E_V2SFmode)
            return -1;
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != VEC_CONCAT
              || GET_MODE (x6) != E_V2SFmode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != VEC_CONCAT
              || GET_MODE (x7) != E_V4SFmode
              || pattern947 (x7, 
E_V2SFmode, 
VEC_CONCAT) != 0
              || !register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x3) != E_V8SFmode
              || GET_MODE (x4) != E_V4SFmode
              || pattern1424 (x3, 
E_SFmode) != 0)
            return -1;
          x8 = XEXP (x5, 0);
          switch (GET_CODE (x8))
            {
            case PLUS:
              if (pattern1673 (x3, 
PLUS) != 0
                  || !
#line 3815 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))
                return -1;
              return 2666; /* avx_haddv8sf3 */

            case MINUS:
              if (pattern1673 (x3, 
MINUS) != 0
                  || !
#line 3815 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))
                return -1;
              return 2667; /* avx_hsubv8sf3 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x5;
          if (pattern349 (x3) != 0)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16SImode:
              if (pattern1361 (x3, 
E_V8SImode, 
E_V4SImode, 
E_V16SImode) != 0
                  || !(
#line 30138 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1445 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9468; /* avx512f_si512_si */

            case E_V16SFmode:
              if (pattern1361 (x3, 
E_V8SFmode, 
E_V4SFmode, 
E_V16SFmode) != 0
                  || !(
#line 30138 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1445 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9469; /* avx512f_ps512_ps */

            case E_V8DFmode:
              if (pattern1361 (x3, 
E_V4DFmode, 
E_V2DFmode, 
E_V8DFmode) != 0
                  || !(
#line 30138 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1445 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9470; /* avx512f_pd512_pd */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      if (pattern91 (x3, 
E_V2DFmode, 
E_DFmode) != 0)
        return -1;
      x7 = XEXP (x3, 1);
      x9 = XEXP (x7, 0);
      x10 = XEXP (x9, 0);
      operands[2] = x10;
      if (!vector_operand (operands[2], E_V2DFmode)
          || pattern1709 (x3) != 0
          || !
#line 3706 "../../../gcc/config/i386/sse.md"
(TARGET_SSE3
   && INTVAL (operands[3]) != INTVAL (operands[4])
   && INTVAL (operands[5]) != INTVAL (operands[6])))
        return -1;
      return 2662; /* *sse3_haddv2df3 */

    case MINUS:
      if (pattern92 (x4, 
E_DFmode) != 0)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != MINUS
          || GET_MODE (x7) != E_DFmode
          || pattern1425 (x7, 
E_DFmode) != 0
          || !register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode)
        return -1;
      x5 = XEXP (x4, 0);
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_V2DFmode))
        return -1;
      x9 = XEXP (x7, 0);
      x10 = XEXP (x9, 0);
      operands[2] = x10;
      if (!vector_operand (operands[2], E_V2DFmode))
        return -1;
      x6 = XEXP (x4, 1);
      x11 = XEXP (x6, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      x12 = XEXP (x7, 1);
      x13 = XEXP (x12, 0);
      if (!rtx_equal_p (x13, operands[2])
          || !
#line 3731 "../../../gcc/config/i386/sse.md"
(TARGET_SSE3))
        return -1;
      return 2663; /* sse3_hsubv2df3 */

    case FLOAT:
      switch (pattern168 (x3))
        {
        case 0:
          if (!
#line 7665 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4000; /* *avx512fp16_vcvtdq2ph_v4si */

        case 1:
          if (!
#line 7665 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4002; /* *avx512fp16_vcvtqq2ph_v4di */

        case 2:
          if (!
#line 7754 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4014; /* *avx512fp16_vcvtqq2ph_v2di */

        case 3:
          if (!
#line 9204 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL))
            return -1;
          return 4406; /* *avx512dq_floatv2div2sf2 */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      switch (pattern168 (x3))
        {
        case 0:
          if (!
#line 7665 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4001; /* *avx512fp16_vcvtudq2ph_v4si */

        case 1:
          if (!
#line 7665 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4003; /* *avx512fp16_vcvtuqq2ph_v4di */

        case 2:
          if (!
#line 7754 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4015; /* *avx512fp16_vcvtuqq2ph_v2di */

        case 3:
          if (!
#line 9204 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL))
            return -1;
          return 4407; /* *avx512dq_floatunsv2div2sf2 */

        default:
          return -1;
        }

    case VEC_MERGE:
      return recog_254 (x1, insn, pnum_clobbers);

    case FLOAT_TRUNCATE:
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
          operands[2] = x7;
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (!register_operand (operands[0], E_V8HFmode)
                  || GET_MODE (x3) != E_V8HFmode)
                return -1;
              switch (GET_MODE (x4))
                {
                case E_V4HFmode:
                  if (!const0_operand (operands[2], E_V4HFmode))
                    return -1;
                  switch (GET_MODE (operands[1]))
                    {
                    case E_V4DFmode:
                      if (!vector_operand (operands[1], E_V4DFmode)
                          || !
#line 8145 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
                        return -1;
                      return 4206; /* *avx512fp16_vcvtpd2ph_v4df */

                    case E_V4SFmode:
                      if (!vector_operand (operands[1], E_V4SFmode)
                          || !
#line 8145 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
                        return -1;
                      return 4207; /* *avx512fp16_vcvtps2ph_v4sf */

                    default:
                      return -1;
                    }

                case E_V2HFmode:
                  if (!vector_operand (operands[1], E_V2DFmode)
                      || !const0_operand (operands[2], E_V6HFmode)
                      || !
#line 8237 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
                    return -1;
                  return 4213; /* *avx512fp16_vcvtpd2ph_v2df */

                default:
                  return -1;
                }

            case E_V4SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x3) != E_V4SFmode
                  || GET_MODE (x4) != E_V2SFmode
                  || !vector_operand (operands[1], E_V2DFmode)
                  || !const0_operand (operands[2], E_V2SFmode)
                  || !
#line 10133 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
                return -1;
              return 4603; /* *sse2_cvtpd2ps */

            case E_V8BFmode:
              if (pattern167 (x3, 
E_V4BFmode, 
E_V4SFmode, 
E_V8BFmode) != 0
                  || !
#line 31048 "../../../gcc/config/i386/sse.md"
(TARGET_AVXNECONVERT || (TARGET_AVX512BF16 && TARGET_AVX512VL)))
                return -1;
              return 9701; /* *vcvtneps2bf16_v4sf */

            default:
              return -1;
            }

        case FLOAT_TRUNCATE:
          x5 = XEXP (x4, 0);
          operands[2] = x5;
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V32BFmode:
              if (pattern733 (x3, 
E_V16SFmode, 
E_V16BFmode, 
E_V32BFmode) != 0
                  || !(
#line 31009 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BF16) && 
#line 30975 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9695; /* avx512f_cvtne2ps2bf16_v32bf */

            case E_V16BFmode:
              if (pattern733 (x3, 
E_V8SFmode, 
E_V8BFmode, 
E_V16BFmode) != 0
                  || !(
#line 31009 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BF16) && 
#line 30975 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9697; /* avx512f_cvtne2ps2bf16_v16bf */

            case E_V8BFmode:
              if (pattern733 (x3, 
E_V4SFmode, 
E_V4BFmode, 
E_V8BFmode) != 0
                  || !(
#line 31009 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BF16) && 
#line 30975 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9699; /* avx512f_cvtne2ps2bf16_v8bf */

            case E_V32HFmode:
              if (pattern734 (x3, 
E_V16SFmode, 
E_V16HFmode, 
E_V32HFmode) != 0
                  || !(
#line 31706 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1) && 
#line 562 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
                return -1;
              return 9794; /* avx10_2_cvt2ps2phx_v32hf */

            case E_V16HFmode:
              if (pattern734 (x3, 
E_V8SFmode, 
E_V8HFmode, 
E_V16HFmode) != 0
                  || !
#line 31706 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1))
                return -1;
              return 9798; /* avx10_2_cvt2ps2phx_v16hf */

            case E_V8HFmode:
              if (pattern734 (x3, 
E_V4SFmode, 
E_V4HFmode, 
E_V8HFmode) != 0
                  || !
#line 31706 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1))
                return -1;
              return 9802; /* avx10_2_cvt2ps2phx_v8hf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      return recog_256 (x1, insn, pnum_clobbers);

    case UNSIGNED_FIX:
      if (GET_MODE (x4) != E_V2SImode)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != CONST_VECTOR
          || XVECLEN (x7, 0) != 2
          || GET_MODE (x7) != E_V2SImode
          || pattern13 (x3, 
E_V2DFmode, 
E_V4SImode, 
0) != 0
          || !
#line 9591 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return -1;
      return 4462; /* *fixuns_truncv2dfv2si2 */

    case FIX:
      if (GET_MODE (x4) != E_V2SImode)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != CONST_VECTOR
          || pattern450 (x7, 
E_V2SImode, 
2) != 0
          || !register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!vector_operand (operands[1], E_V2DFmode)
          || !
#line 9951 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
        return -1;
      return 4582; /* sse2_cvttpd2dq */

    case REG:
    case SUBREG:
    case MEM:
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case VEC_SELECT:
          res = recog_252 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
        case MEM:
          res = recog_253 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case UNSPEC:
          if (XVECLEN (x7, 0) == 1
              && XINT (x7, 1) == 147)
            {
              x14 = XVECEXP (x7, 0, 0);
              if (x14 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                {
                  operands[1] = x4;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V8SImode:
                      if (pattern948 (x3, 
E_V4SImode, 
E_V8SImode) == 0
                          && 
#line 28811 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                        return 8915; /* avx_si256_si */
                      break;

                    case E_V8SFmode:
                      if (pattern948 (x3, 
E_V4SFmode, 
E_V8SFmode) == 0
                          && 
#line 28811 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                        return 8916; /* avx_ps256_ps */
                      break;

                    case E_V4DFmode:
                      if (pattern948 (x3, 
E_V2DFmode, 
E_V4DFmode) == 0
                          && 
#line 28811 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                        return 8917; /* avx_pd256_pd */
                      break;

                    case E_V16SImode:
                      if (pattern948 (x3, 
E_V8SImode, 
E_V16SImode) == 0
                          && (
#line 30155 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1445 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                        return 9471; /* avx512f_si512_256si */
                      break;

                    case E_V16SFmode:
                      if (pattern948 (x3, 
E_V8SFmode, 
E_V16SFmode) == 0
                          && (
#line 30155 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1445 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                        return 9472; /* avx512f_ps512_256ps */
                      break;

                    case E_V8DFmode:
                      if (pattern948 (x3, 
E_V4DFmode, 
E_V8DFmode) == 0
                          && (
#line 30155 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1445 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                        return 9473; /* avx512f_pd512_256pd */
                      break;

                    default:
                      break;
                    }
                }
            }
          break;

        default:
          break;
        }
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x3) != E_V4DImode)
        return -1;
      if (GET_CODE (x4) == SUBREG
          && pattern549 (x3) == 0)
        {
          x5 = XEXP (x4, 0);
          x15 = XVECEXP (x5, 0, 0);
          operands[1] = x15;
          if (memory_operand (operands[1], E_V16QImode))
            {
              x9 = XEXP (x7, 0);
              x16 = XVECEXP (x9, 0, 0);
              if (rtx_equal_p (x16, operands[1])
                  && 
#line 27908 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && ix86_pre_reload_split ()))
                return 8662; /* avx2_lddqu_inserti_to_bcasti */
            }
        }
      operands[1] = x4;
      if (!nonimmediate_operand (operands[1], E_V2DImode))
        return -1;
      if (rtx_equal_p (x7, operands[1])
          && 
#line 28000 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))
        return 8680; /* avx_vbroadcastf128_v4di */
      operands[2] = x7;
      if (!nonimm_or_0_operand (operands[2], E_V2DImode)
          || !
#line 28945 "../../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V2DImode)
       || !MEM_P (operands[1]))))
        return -1;
      return 8977; /* avx_vec_concatv4di */

    case ZERO_EXTEND:
      switch (pattern169 (x3))
        {
        case 0:
          if (!
#line 12097 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()))
            return -1;
          return 4738; /* *vec_setv2di_0_zero_extendhi_1 */

        case 1:
          if (!
#line 12211 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
            return -1;
          return 4750; /* *vec_setv2di_0_zero_extendsi_1 */

        default:
          return -1;
        }

    case SS_TRUNCATE:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
          operands[2] = x7;
          switch (pattern452 (x3))
            {
            case 0:
              if (
#line 15367 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return 6699; /* avx512vl_ss_truncatev4div4qi2 */
              break;

            case 1:
              if (
#line 15367 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return 6708; /* avx512vl_ss_truncatev4siv4qi2 */
              break;

            case 2:
              if (
#line 15367 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return 6702; /* avx512vl_ss_truncatev2div2qi2 */
              break;

            case 3:
              if (
#line 15367 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return 6705; /* avx512vl_ss_truncatev8siv8qi2 */
              break;

            case 4:
              if ((
#line 15367 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15323 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
                return 6711; /* avx512vl_ss_truncatev8hiv8qi2 */
              break;

            case 5:
              if ((
#line 15722 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15684 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
                return 6790; /* avx512vl_ss_truncatev4div4hi2 */
              break;

            case 6:
              if (
#line 15722 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return 6796; /* avx512vl_ss_truncatev4siv4hi2 */
              break;

            case 7:
              if (
#line 15722 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return 6793; /* avx512vl_ss_truncatev2div2hi2 */
              break;

            case 8:
              if (
#line 15963 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return 6845; /* avx512vl_ss_truncatev2div2si2 */
              break;

            default:
              break;
            }
          if (GET_CODE (x7) != CONST_VECTOR
              || pattern450 (x7, 
E_V8QImode, 
8) != 0)
            return -1;
          x17 = XVECEXP (x7, 0, 2);
          if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x18 = XVECEXP (x7, 0, 3);
          if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x19 = XVECEXP (x7, 0, 4);
          if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x20 = XVECEXP (x7, 0, 5);
          if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x21 = XVECEXP (x7, 0, 6);
          if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x22 = XVECEXP (x7, 0, 7);
          if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || pattern785 (x3, 
E_V8DImode, 
E_V8QImode, 
E_V16QImode) != 0
              || !
#line 16099 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 6864; /* avx512f_ss_truncatev8div16qi2 */

        case SS_TRUNCATE:
          x9 = XEXP (x7, 0);
          operands[2] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern739 (x3, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
                  || !
#line 19212 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1))
                return -1;
              return 7716; /* sse2_packsswb */

            case E_V8HImode:
              if (pattern739 (x3, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
                  || !
#line 19306 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1))
                return -1;
              return 7722; /* sse2_packssdw */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case TRUNCATE:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      switch (pattern452 (x3))
        {
        case 0:
          if (
#line 15367 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6700; /* avx512vl_truncatev4div4qi2 */
          break;

        case 1:
          if (
#line 15367 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6709; /* avx512vl_truncatev4siv4qi2 */
          break;

        case 2:
          if (
#line 15367 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6703; /* avx512vl_truncatev2div2qi2 */
          break;

        case 3:
          if (
#line 15367 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6706; /* avx512vl_truncatev8siv8qi2 */
          break;

        case 4:
          if ((
#line 15367 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15323 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return 6712; /* avx512vl_truncatev8hiv8qi2 */
          break;

        case 5:
          if ((
#line 15722 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15684 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return 6791; /* avx512vl_truncatev4div4hi2 */
          break;

        case 6:
          if (
#line 15722 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6797; /* avx512vl_truncatev4siv4hi2 */
          break;

        case 7:
          if (
#line 15722 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6794; /* avx512vl_truncatev2div2hi2 */
          break;

        case 8:
          if (
#line 15963 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6846; /* avx512vl_truncatev2div2si2 */
          break;

        default:
          break;
        }
      if (!register_operand (operands[1], E_V8DImode)
          || pattern453 (x3) != 0
          || !
#line 16099 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 6865; /* avx512f_truncatev8div16qi2 */

    case US_TRUNCATE:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      switch (pattern452 (x3))
        {
        case 0:
          if (
#line 15367 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6701; /* avx512vl_us_truncatev4div4qi2 */
          break;

        case 1:
          if (
#line 15367 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6710; /* avx512vl_us_truncatev4siv4qi2 */
          break;

        case 2:
          if (
#line 15367 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6704; /* avx512vl_us_truncatev2div2qi2 */
          break;

        case 3:
          if (
#line 15367 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6707; /* avx512vl_us_truncatev8siv8qi2 */
          break;

        case 4:
          if ((
#line 15367 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15323 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return 6713; /* avx512vl_us_truncatev8hiv8qi2 */
          break;

        case 5:
          if ((
#line 15722 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15684 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return 6792; /* avx512vl_us_truncatev4div4hi2 */
          break;

        case 6:
          if (
#line 15722 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6798; /* avx512vl_us_truncatev4siv4hi2 */
          break;

        case 7:
          if (
#line 15722 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6795; /* avx512vl_us_truncatev2div2hi2 */
          break;

        case 8:
          if (
#line 15963 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 6847; /* avx512vl_us_truncatev2div2si2 */
          break;

        default:
          break;
        }
      if (!register_operand (operands[1], E_V8DImode)
          || pattern453 (x3) != 0
          || !
#line 16099 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 6866; /* avx512f_us_truncatev8div16qi2 */

    default:
      return -1;
    }
}

 int
recog_308 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55, x56, x57;
  rtx x58, x59, x60, x61, x62, x63, x64, x65;
  rtx x66, x67, x68, x69, x70, x71, x72, x73;
  rtx x74, x75, x76;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      switch (pattern49 (x3))
        {
        case 0:
          if (!(
#line 16318 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (SS_PLUS, V64QImode, operands)) && 
#line 740 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 6930; /* *avx512bw_ssaddv64qi3 */

        case 1:
          if (!(
#line 16318 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (SS_PLUS, V32QImode, operands)) && 
#line 740 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 6938; /* *avx2_ssaddv32qi3 */

        case 2:
          if (!
#line 16318 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (SS_PLUS, V16QImode, operands)))
            return -1;
          return 6946; /* *sse2_ssaddv16qi3 */

        case 3:
          if (!(
#line 16318 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (SS_PLUS, V32HImode, operands)) && 
#line 741 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 6954; /* *avx512bw_ssaddv32hi3 */

        case 4:
          if (!(
#line 16318 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (SS_PLUS, V16HImode, operands)) && 
#line 741 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 6962; /* *avx2_ssaddv16hi3 */

        case 5:
          if (!
#line 16318 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (SS_PLUS, V8HImode, operands)))
            return -1;
          return 6970; /* *sse2_ssaddv8hi3 */

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern184 (x3))
        {
        case 0:
          if (!
#line 22567 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 7954; /* avx2_phaddswv16hi3 */

        case 1:
          if (!
#line 22590 "../../../gcc/config/i386/sse.md"
(TARGET_SSSE3))
            return -1;
          return 7958; /* ssse3_phaddswv8hi3 */

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case ZERO_EXTEND:
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != VEC_SELECT)
            return -1;
          x7 = XEXP (x6, 1);
          if (GET_CODE (x7) != PARALLEL)
            return -1;
          x8 = XEXP (x4, 1);
          if (GET_CODE (x8) != SIGN_EXTEND)
            return -1;
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != VEC_SELECT)
            return -1;
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != PARALLEL)
            return -1;
          x11 = XEXP (x3, 1);
          if (GET_CODE (x11) != MULT)
            return -1;
          x12 = XEXP (x11, 0);
          if (GET_CODE (x12) != ZERO_EXTEND)
            return -1;
          x13 = XEXP (x12, 0);
          if (GET_CODE (x13) != VEC_SELECT)
            return -1;
          x14 = XEXP (x13, 1);
          if (GET_CODE (x14) != PARALLEL)
            return -1;
          x15 = XEXP (x11, 1);
          if (GET_CODE (x15) != SIGN_EXTEND)
            return -1;
          x16 = XEXP (x15, 0);
          if (GET_CODE (x16) != VEC_SELECT)
            return -1;
          x17 = XEXP (x16, 1);
          if (GET_CODE (x17) != PARALLEL)
            return -1;
          x18 = XEXP (x6, 0);
          operands[1] = x18;
          x19 = XEXP (x9, 0);
          operands[2] = x19;
          x20 = XEXP (x13, 0);
          if (!rtx_equal_p (x20, operands[1]))
            return -1;
          x21 = XEXP (x16, 0);
          if (!rtx_equal_p (x21, operands[2]))
            return -1;
          switch (XVECLEN (x7, 0))
            {
            case 16:
              if (pattern984 (x7, 
6, 
4, 
2, 
0) != 0)
                return -1;
              x22 = XVECEXP (x7, 0, 4);
              if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
                return -1;
              x23 = XVECEXP (x7, 0, 5);
              if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
                return -1;
              x24 = XVECEXP (x7, 0, 6);
              if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
                return -1;
              x25 = XVECEXP (x7, 0, 7);
              if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 14])
                return -1;
              x26 = XVECEXP (x7, 0, 8);
              if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              x27 = XVECEXP (x7, 0, 9);
              if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 18])
                return -1;
              x28 = XVECEXP (x7, 0, 10);
              if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 20])
                return -1;
              x29 = XVECEXP (x7, 0, 11);
              if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 22])
                return -1;
              x30 = XVECEXP (x7, 0, 12);
              if (x30 != const_int_rtx[MAX_SAVED_CONST_INT + 24])
                return -1;
              x31 = XVECEXP (x7, 0, 13);
              if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 26])
                return -1;
              x32 = XVECEXP (x7, 0, 14);
              if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 28])
                return -1;
              x33 = XVECEXP (x7, 0, 15);
              if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 30]
                  || pattern1214 (x10, 
16) != 0)
                return -1;
              x34 = XVECEXP (x10, 0, 8);
              if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              x35 = XVECEXP (x10, 0, 9);
              if (x35 != const_int_rtx[MAX_SAVED_CONST_INT + 18])
                return -1;
              x36 = XVECEXP (x10, 0, 10);
              if (x36 != const_int_rtx[MAX_SAVED_CONST_INT + 20])
                return -1;
              x37 = XVECEXP (x10, 0, 11);
              if (x37 != const_int_rtx[MAX_SAVED_CONST_INT + 22])
                return -1;
              x38 = XVECEXP (x10, 0, 12);
              if (x38 != const_int_rtx[MAX_SAVED_CONST_INT + 24])
                return -1;
              x39 = XVECEXP (x10, 0, 13);
              if (x39 != const_int_rtx[MAX_SAVED_CONST_INT + 26])
                return -1;
              x40 = XVECEXP (x10, 0, 14);
              if (x40 != const_int_rtx[MAX_SAVED_CONST_INT + 28])
                return -1;
              x41 = XVECEXP (x10, 0, 15);
              if (x41 != const_int_rtx[MAX_SAVED_CONST_INT + 30]
                  || pattern1722 (x14, 
16) != 0)
                return -1;
              x42 = XVECEXP (x14, 0, 8);
              if (x42 != const_int_rtx[MAX_SAVED_CONST_INT + 17])
                return -1;
              x43 = XVECEXP (x14, 0, 9);
              if (x43 != const_int_rtx[MAX_SAVED_CONST_INT + 19])
                return -1;
              x44 = XVECEXP (x14, 0, 10);
              if (x44 != const_int_rtx[MAX_SAVED_CONST_INT + 21])
                return -1;
              x45 = XVECEXP (x14, 0, 11);
              if (x45 != const_int_rtx[MAX_SAVED_CONST_INT + 23])
                return -1;
              x46 = XVECEXP (x14, 0, 12);
              if (x46 != const_int_rtx[MAX_SAVED_CONST_INT + 25])
                return -1;
              x47 = XVECEXP (x14, 0, 13);
              if (x47 != const_int_rtx[MAX_SAVED_CONST_INT + 27])
                return -1;
              x48 = XVECEXP (x14, 0, 14);
              if (x48 != const_int_rtx[MAX_SAVED_CONST_INT + 29])
                return -1;
              x49 = XVECEXP (x14, 0, 15);
              if (x49 != const_int_rtx[MAX_SAVED_CONST_INT + 31]
                  || pattern1740 (x17, 
16) != 0)
                return -1;
              x50 = XVECEXP (x17, 0, 8);
              if (x50 != const_int_rtx[MAX_SAVED_CONST_INT + 17])
                return -1;
              x51 = XVECEXP (x17, 0, 9);
              if (x51 != const_int_rtx[MAX_SAVED_CONST_INT + 19])
                return -1;
              x52 = XVECEXP (x17, 0, 10);
              if (x52 != const_int_rtx[MAX_SAVED_CONST_INT + 21])
                return -1;
              x53 = XVECEXP (x17, 0, 11);
              if (x53 != const_int_rtx[MAX_SAVED_CONST_INT + 23])
                return -1;
              x54 = XVECEXP (x17, 0, 12);
              if (x54 != const_int_rtx[MAX_SAVED_CONST_INT + 25])
                return -1;
              x55 = XVECEXP (x17, 0, 13);
              if (x55 != const_int_rtx[MAX_SAVED_CONST_INT + 27])
                return -1;
              x56 = XVECEXP (x17, 0, 14);
              if (x56 != const_int_rtx[MAX_SAVED_CONST_INT + 29])
                return -1;
              x57 = XVECEXP (x17, 0, 15);
              if (x57 != const_int_rtx[MAX_SAVED_CONST_INT + 31]
                  || pattern1745 (x3, 
E_V32QImode, 
E_V16QImode, 
E_V16HImode) != 0
                  || GET_MODE (x8) != E_V16HImode
                  || GET_MODE (x9) != E_V16QImode
                  || !nonimmediate_operand (operands[2], E_V32QImode)
                  || pattern290 (x11, 
E_V16QImode, 
E_V16HImode) != 0
                  || !
#line 22777 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 7971; /* avx2_pmaddubsw256 */

            case 8:
              if (pattern1215 (x4) != 0
                  || pattern1722 (x14, 
8) != 0
                  || pattern1740 (x17, 
8) != 0
                  || pattern1745 (x3, 
E_V16QImode, 
E_V8QImode, 
E_V8HImode) != 0
                  || GET_MODE (x8) != E_V8HImode
                  || GET_MODE (x9) != E_V8QImode
                  || !vector_operand (operands[2], E_V16QImode)
                  || pattern290 (x11, 
E_V8QImode, 
E_V8HImode) != 0
                  || !
#line 22864 "../../../gcc/config/i386/sse.md"
(TARGET_SSSE3))
                return -1;
              return 7980; /* ssse3_pmaddubsw128 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          switch (pattern288 (x3))
            {
            case 0:
              if (!
#line 26105 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8352; /* xop_pmacssww */

            case 1:
              if (!
#line 26105 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8354; /* xop_pmacssdd */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern286 (x4) != 0)
            return -1;
          x11 = XEXP (x3, 1);
          operands[3] = x11;
          x6 = XEXP (x5, 0);
          x7 = XEXP (x6, 1);
          switch (XVECLEN (x7, 0))
            {
            case 2:
              if (pattern1216 (x3) != 0)
                return -1;
              x8 = XEXP (x4, 1);
              if (GET_MODE (x8) != E_V2DImode)
                return -1;
              x9 = XEXP (x8, 0);
              if (GET_MODE (x9) != E_V2SImode
                  || !nonimmediate_operand (operands[2], E_V4SImode))
                return -1;
              switch (pattern1686 (x4))
                {
                case 0:
                  if (!
#line 26124 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
                    return -1;
                  return 8356; /* xop_pmacssdql */

                case 1:
                  if (!
#line 26143 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
                    return -1;
                  return 8358; /* xop_pmacssdqh */

                default:
                  return -1;
                }

            case 4:
              if (pattern984 (x7, 
7, 
5, 
3, 
1) != 0)
                return -1;
              x8 = XEXP (x4, 1);
              x9 = XEXP (x8, 0);
              x10 = XEXP (x9, 1);
              if (pattern1487 (x10, 
7, 
5, 
3, 
1) != 0
                  || !register_operand (operands[0], E_V4SImode)
                  || GET_MODE (x3) != E_V4SImode
                  || GET_MODE (x4) != E_V4SImode
                  || GET_MODE (x5) != E_V4SImode
                  || GET_MODE (x6) != E_V4HImode
                  || !nonimmediate_operand (operands[1], E_V8HImode)
                  || GET_MODE (x8) != E_V4SImode
                  || GET_MODE (x9) != E_V4HImode
                  || !nonimmediate_operand (operands[2], E_V8HImode)
                  || !register_operand (operands[3], E_V4SImode)
                  || !
#line 26165 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8360; /* xop_pmacsswd */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x4) != E_V4SImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != MULT
          || pattern289 (x5) != 0)
        return -1;
      x58 = XEXP (x5, 1);
      if (GET_MODE (x58) != E_V4SImode)
        return -1;
      x59 = XEXP (x58, 0);
      if (GET_CODE (x59) != VEC_SELECT
          || GET_MODE (x59) != E_V4HImode)
        return -1;
      x60 = XEXP (x59, 1);
      if (GET_CODE (x60) != PARALLEL
          || XVECLEN (x60, 0) != 4)
        return -1;
      x61 = XVECEXP (x60, 0, 0);
      if (x61 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x62 = XVECEXP (x60, 0, 1);
      if (x62 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x63 = XVECEXP (x60, 0, 2);
      if (x63 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x64 = XVECEXP (x60, 0, 3);
      if (x64 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x8 = XEXP (x4, 1);
      if (GET_CODE (x8) != MULT
          || GET_MODE (x8) != E_V4SImode)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != SIGN_EXTEND
          || GET_MODE (x9) != E_V4SImode)
        return -1;
      x19 = XEXP (x9, 0);
      if (GET_CODE (x19) != VEC_SELECT
          || GET_MODE (x19) != E_V4HImode)
        return -1;
      x65 = XEXP (x19, 1);
      if (GET_CODE (x65) != PARALLEL
          || XVECLEN (x65, 0) != 4)
        return -1;
      x66 = XVECEXP (x65, 0, 0);
      if (x66 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x67 = XVECEXP (x65, 0, 1);
      if (x67 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x68 = XVECEXP (x65, 0, 2);
      if (x68 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x69 = XVECEXP (x65, 0, 3);
      if (x69 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x70 = XEXP (x8, 1);
      if (GET_CODE (x70) != SIGN_EXTEND
          || GET_MODE (x70) != E_V4SImode)
        return -1;
      x71 = XEXP (x70, 0);
      if (GET_CODE (x71) != VEC_SELECT
          || GET_MODE (x71) != E_V4HImode)
        return -1;
      x72 = XEXP (x71, 1);
      if (GET_CODE (x72) != PARALLEL
          || XVECLEN (x72, 0) != 4)
        return -1;
      x73 = XVECEXP (x72, 0, 0);
      if (x73 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x74 = XVECEXP (x72, 0, 1);
      if (x74 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x75 = XVECEXP (x72, 0, 2);
      if (x75 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x76 = XVECEXP (x72, 0, 3);
      if (x76 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
          || !register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || pattern1742 (x3) != 0
          || !
#line 26198 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
        return -1;
      return 8362; /* xop_pmadcsswd */

    default:
      return -1;
    }
}

 int
recog_312 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x3) != E_V16HImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V16HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17094 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 794 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
        return 7028; /* *ashrv16hi3 */
      if (!register_operand (operands[1], E_V16HImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && (
#line 17108 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 744 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return 7038; /* ashrv16hi3 */
      if (!nonimmediate_operand (operands[2], E_V16HImode)
          || !(
#line 28912 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 686 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 8932; /* avx512vl_ashrvv16hi */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17094 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 794 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
        return 7030; /* *ashrv8hi3 */
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && 
#line 17108 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
        return 7039; /* ashrv8hi3 */
      if (!nonimmediate_operand (operands[2], E_V8HImode)
          || !(
#line 28912 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 686 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 8930; /* avx512vl_ashrvv8hi */

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x3) != E_V8SImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && 
#line 17094 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return 7032; /* *ashrv8si3 */
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && (
#line 17108 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 745 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return 7040; /* ashrv8si3 */
      if (!nonimmediate_operand (operands[2], E_V8SImode)
          || !
#line 28901 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8920; /* avx2_ashrvv8si */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V4SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && 
#line 17094 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return 7034; /* *ashrv4si3 */
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && 
#line 17108 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
        return 7041; /* ashrv4si3 */
      if (!nonimmediate_operand (operands[2], E_V4SImode)
          || !
#line 28901 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8918; /* avx2_ashrvv4si */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V2DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && 
#line 17094 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return 7036; /* *ashrv2di3 */
      if (!register_operand (operands[1], E_V2DImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && 
#line 26979 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !TARGET_AVX512VL && ix86_pre_reload_split ()))
        return 8418; /* *ashrv2di3 */
      if (!nonimmediate_operand (operands[2], E_V2DImode)
          || !(
#line 28901 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1) && 
#line 682 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 8924; /* avx2_ashrvv2di */

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x3) != E_V32HImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V32HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17138 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 789 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
        return 7046; /* *ashrv32hi3 */
      if (!register_operand (operands[1], E_V32HImode)
          || !nonimmediate_operand (operands[2], E_V32HImode)
          || !(
#line 28912 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 686 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 8934; /* avx512bw_ashrvv32hi */

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x3) != E_V4DImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V4DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17138 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 790 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7048; /* *ashrv4di3 */
      if (!register_operand (operands[1], E_V4DImode)
          || !nonimmediate_operand (operands[2], E_V4DImode)
          || !(
#line 28901 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1) && 
#line 682 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 8926; /* avx2_ashrvv4di */

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x3) != E_V16SImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V16SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17138 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 790 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 7050; /* *ashrv16si3 */
      if (!register_operand (operands[1], E_V16SImode)
          || !nonimmediate_operand (operands[2], E_V16SImode)
          || !(
#line 28901 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1) && 
#line 681 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8922; /* avx512f_ashrvv16si */

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x3) != E_V8DImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17138 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 790 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 7052; /* *ashrv8di3 */
      if (!register_operand (operands[1], E_V8DImode)
          || !nonimmediate_operand (operands[2], E_V8DImode)
          || !(
#line 28901 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1) && 
#line 683 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8928; /* avx512f_ashrvv8di */

    default:
      return -1;
    }
}

 int
recog_317 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case VEC_DUPLICATE:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          if (pattern170 (x3, 
E_V32HFmode) != 0
              || !(
#line 2750 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V32HFmode, operands)
   && 1 && 1) && 
#line 390 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return -1;
          return 2260; /* *mulv32hf3 */

        case E_V16HFmode:
          if (pattern170 (x3, 
E_V16HFmode) != 0
              || !(
#line 2750 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V16HFmode, operands)
   && 1 && 1) && 
#line 391 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 2264; /* *mulv16hf3 */

        case E_V8HFmode:
          if (pattern170 (x3, 
E_V8HFmode) != 0
              || !(
#line 2750 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V8HFmode, operands)
   && 1 && 1) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 2268; /* *mulv8hf3 */

        case E_V16SFmode:
          if (pattern170 (x3, 
E_V16SFmode) != 0
              || !(
#line 2750 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V16SFmode, operands)
   && 1 && 1) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 2272; /* *mulv16sf3 */

        case E_V8SFmode:
          if (pattern170 (x3, 
E_V8SFmode) != 0
              || !(
#line 2750 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V8SFmode, operands)
   && 1 && 1) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 2276; /* *mulv8sf3 */

        case E_V4SFmode:
          if (pattern170 (x3, 
E_V4SFmode) != 0
              || !
#line 2750 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V4SFmode, operands)
   && 1 && 1))
            return -1;
          return 2280; /* *mulv4sf3 */

        case E_V8DFmode:
          if (pattern170 (x3, 
E_V8DFmode) != 0
              || !(
#line 2750 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V8DFmode, operands)
   && 1 && 1) && 
#line 394 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 2284; /* *mulv8df3 */

        case E_V4DFmode:
          if (pattern170 (x3, 
E_V4DFmode) != 0
              || !(
#line 2750 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V4DFmode, operands)
   && 1 && 1) && 
#line 394 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 2288; /* *mulv4df3 */

        case E_V2DFmode:
          if (pattern170 (x3, 
E_V2DFmode) != 0
              || !(
#line 2750 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V2DFmode, operands)
   && 1 && 1) && 
#line 395 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 2292; /* *mulv2df3 */

        case E_V32HImode:
          if (pattern26 (x3, 
E_V32HImode) != 0
              || !(
#line 16385 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1 && 1) && 
#line 653 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 6978; /* *mulv32hi3 */

        case E_V16HImode:
          if (pattern26 (x3, 
E_V16HImode) != 0
              || !(
#line 16385 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1 && 1) && 
#line 653 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 6980; /* *mulv16hi3 */

        case E_V8HImode:
          if (pattern26 (x3, 
E_V8HImode) != 0
              || !
#line 16385 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1 && 1))
            return -1;
          return 6982; /* *mulv8hi3 */

        case E_V8DImode:
          if (pattern170 (x3, 
E_V8DImode) != 0
              || !(
#line 16839 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1
  && ix86_binary_operator_ok (MULT, V8DImode, operands)) && 
#line 624 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 7016; /* *avx512dq_mulv8di3 */

        case E_V4DImode:
          if (pattern170 (x3, 
E_V4DImode) != 0
              || !(
#line 16839 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1
  && ix86_binary_operator_ok (MULT, V4DImode, operands)) && 
#line 624 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7018; /* *avx512dq_mulv4di3 */

        case E_V2DImode:
          if (pattern170 (x3, 
E_V2DImode) != 0
              || !(
#line 16839 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1
  && ix86_binary_operator_ok (MULT, V2DImode, operands)) && 
#line 624 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7020; /* *avx512dq_mulv2di3 */

        case E_V16SImode:
          if (pattern170 (x3, 
E_V16SImode) != 0
              || !(
#line 16898 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_binary_operator_ok (MULT, V16SImode, operands)
  && 1) && 
#line 672 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 7022; /* *avx512f_mulv16si3 */

        case E_V8SImode:
          if (pattern170 (x3, 
E_V8SImode) != 0
              || !(
#line 16898 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_binary_operator_ok (MULT, V8SImode, operands)
  && 1) && 
#line 672 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7024; /* *avx2_mulv8si3 */

        case E_V4SImode:
          if (pattern170 (x3, 
E_V4SImode) != 0
              || !
#line 16898 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_binary_operator_ok (MULT, V4SImode, operands)
  && 1))
            return -1;
          return 7026; /* *sse4_1_mulv4si3 */

        case E_V32BFmode:
          if (pattern27 (x3, 
E_V32BFmode) != 0
              || !(
#line 32110 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 565 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 9967; /* avx10_2_mulnepbf16_v32bf */

        case E_V16BFmode:
          if (pattern27 (x3, 
E_V16BFmode) != 0
              || !
#line 32110 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9975; /* avx10_2_mulnepbf16_v16bf */

        case E_V8BFmode:
          if (pattern27 (x3, 
E_V8BFmode) != 0
              || !
#line 32110 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9983; /* avx10_2_mulnepbf16_v8bf */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern182 (x3, 
ZERO_EXTEND))
        {
        case 0:
          if (!
#line 16468 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 6996; /* *vec_widen_umult_even_v16si */

        case 1:
          if (!
#line 16504 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 6998; /* *vec_widen_umult_even_v8si */

        case 2:
          if (!
#line 16536 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 7000; /* *vec_widen_umult_even_v4si */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern182 (x3, 
SIGN_EXTEND))
        {
        case 0:
          if (!
#line 16584 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 7002; /* *vec_widen_smult_even_v16si */

        case 1:
          if (!
#line 16620 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 7004; /* *vec_widen_smult_even_v8si */

        case 2:
          if (!
#line 16652 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 7006; /* *sse4_1_mulv2siv2di3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_325 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern28 (x1))
    {
    case 0:
      if (!(
#line 3306 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 390 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 2473; /* *sminv32hf3 */

    case 1:
      if (!(
#line 3306 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 391 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 2481; /* *sminv16hf3 */

    case 2:
      if (!(
#line 3306 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 2487; /* *sminv8hf3 */

    case 3:
      if (!(
#line 3306 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 2493; /* *sminv16sf3 */

    case 4:
      if (!(
#line 3306 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2501; /* *sminv8sf3 */

    case 5:
      if (!
#line 3306 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1))
        return -1;
      return 2507; /* *sminv4sf3 */

    case 6:
      if (!(
#line 3306 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 394 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 2513; /* *sminv8df3 */

    case 7:
      if (!(
#line 3306 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 394 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2521; /* *sminv4df3 */

    case 8:
      if (!(
#line 3306 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 395 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 2527; /* *sminv2df3 */

    case 9:
      if (nonimmediate_operand (operands[1], E_V32QImode)
          && 
#line 17667 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7174; /* *avx2_sminv32qi3 */
      if (!register_operand (operands[1], E_V32QImode)
          || !(
#line 17719 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7251; /* *sminv32qi3 */

    case 10:
      if (nonimmediate_operand (operands[1], E_V16HImode)
          && 
#line 17667 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7178; /* *avx2_sminv16hi3 */
      if (!register_operand (operands[1], E_V16HImode)
          || !(
#line 17719 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 319 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7267; /* *sminv16hi3 */

    case 11:
      if (
#line 17667 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7182; /* *avx2_sminv8si3 */
      if (!(
#line 17708 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7195; /* *avx512f_sminv8si3 */

    case 12:
      if (!(
#line 17708 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7187; /* *avx512f_sminv16si3 */

    case 13:
      if (nonimmediate_operand (operands[1], E_V4SImode)
          && nonimmediate_operand (operands[2], E_V4SImode)
          && (
#line 17708 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7203; /* *avx512f_sminv4si3 */
      if (!vector_operand (operands[1], E_V4SImode)
          || !vector_operand (operands[2], E_V4SImode)
          || !
#line 17811 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7287; /* *sse4_1_sminv4si3 */

    case 14:
      if (!(
#line 17708 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 502 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7211; /* *avx512f_sminv8di3 */

    case 15:
      if (!(
#line 17708 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 502 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7219; /* *avx512f_sminv4di3 */

    case 16:
      if (!(
#line 17708 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 502 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7227; /* *avx512f_sminv2di3 */

    case 17:
      if (!(
#line 17719 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7235; /* *sminv64qi3 */

    case 18:
      if (register_operand (operands[1], E_V16QImode)
          && nonimmediate_operand (operands[2], E_V16QImode)
          && (
#line 17719 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7243; /* *sminv16qi3 */
      if (!vector_operand (operands[1], E_V16QImode)
          || !vector_operand (operands[2], E_V16QImode)
          || !
#line 17811 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7283; /* *sse4_1_sminv16qi3 */

    case 19:
      if (!(
#line 17719 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 319 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7259; /* *sminv32hi3 */

    case 20:
      if (register_operand (operands[1], E_V8HImode)
          && nonimmediate_operand (operands[2], E_V8HImode)
          && (
#line 17719 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 319 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7275; /* *sminv8hi3 */
      if (!vector_operand (operands[1], E_V8HImode)
          || !vector_operand (operands[2], E_V8HImode)
          || !
#line 17830 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7290; /* *sminv8hi3 */

    case 21:
      if (!(
#line 32100 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 565 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
        return -1;
      return 9953; /* avx10_2_sminpbf16_v32bf */

    case 22:
      if (!
#line 32100 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
        return -1;
      return 9957; /* avx10_2_sminpbf16_v16bf */

    case 23:
      if (!
#line 32100 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
        return -1;
      return 9961; /* avx10_2_sminpbf16_v8bf */

    default:
      return -1;
    }
}

 int
recog_332 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case VEC_DUPLICATE:
      switch (pattern171 (x3))
        {
        case 0:
          if (!(
#line 2661 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V32HFmode, operands)
   && 1 && 1) && 
#line 390 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return -1;
          return 2162; /* *subv32hf3 */

        case 1:
          if (!(
#line 2661 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V16HFmode, operands)
   && 1 && 1) && 
#line 391 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 2170; /* *subv16hf3 */

        case 2:
          if (!(
#line 2661 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V8HFmode, operands)
   && 1 && 1) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 2178; /* *subv8hf3 */

        case 3:
          if (!(
#line 2661 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V16SFmode, operands)
   && 1 && 1) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 2186; /* *subv16sf3 */

        case 4:
          if (!(
#line 2661 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V8SFmode, operands)
   && 1 && 1) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 2194; /* *subv8sf3 */

        case 5:
          if (!
#line 2661 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V4SFmode, operands)
   && 1 && 1))
            return -1;
          return 2202; /* *subv4sf3 */

        case 6:
          if (!(
#line 2661 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V8DFmode, operands)
   && 1 && 1) && 
#line 394 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 2210; /* *subv8df3 */

        case 7:
          if (!(
#line 2661 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V4DFmode, operands)
   && 1 && 1) && 
#line 394 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 2218; /* *subv4df3 */

        case 8:
          if (!(
#line 2661 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V2DFmode, operands)
   && 1 && 1) && 
#line 395 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 2226; /* *subv2df3 */

        case 9:
          if (!(
#line 16267 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (MINUS, V64QImode, operands)) && 
#line 588 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 6883; /* *subv64qi3 */

        case 10:
          if (!(
#line 16267 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (MINUS, V32QImode, operands)) && 
#line 588 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 6885; /* *subv32qi3 */

        case 11:
          if (!
#line 16267 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (MINUS, V16QImode, operands)))
            return -1;
          return 6887; /* *subv16qi3 */

        case 12:
          if (!(
#line 16267 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (MINUS, V32HImode, operands)) && 
#line 589 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 6889; /* *subv32hi3 */

        case 13:
          if (!(
#line 16267 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (MINUS, V16HImode, operands)) && 
#line 589 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 6891; /* *subv16hi3 */

        case 14:
          if (!
#line 16267 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (MINUS, V8HImode, operands)))
            return -1;
          return 6893; /* *subv8hi3 */

        case 15:
          if (!(
#line 16267 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (MINUS, V16SImode, operands)) && 
#line 590 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6895; /* *subv16si3 */

        case 16:
          if (!(
#line 16267 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (MINUS, V8SImode, operands)) && 
#line 590 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 6897; /* *subv8si3 */

        case 17:
          if (!
#line 16267 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (MINUS, V4SImode, operands)))
            return -1;
          return 6899; /* *subv4si3 */

        case 18:
          if (!(
#line 16267 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (MINUS, V8DImode, operands)) && 
#line 591 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6901; /* *subv8di3 */

        case 19:
          if (!(
#line 16267 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (MINUS, V4DImode, operands)) && 
#line 591 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 6903; /* *subv4di3 */

        case 20:
          if (!
#line 16267 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (MINUS, V2DImode, operands)))
            return -1;
          return 6905; /* *subv2di3 */

        case 21:
          if (!(
#line 32110 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 565 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 9965; /* avx10_2_subnepbf16_v32bf */

        case 22:
          if (!
#line 32110 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9973; /* avx10_2_subnepbf16_v16bf */

        case 23:
          if (!
#line 32110 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9981; /* avx10_2_subnepbf16_v8bf */

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern178 (x3))
        {
        case 0:
          if (!
#line 22567 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 7955; /* avx2_phsubwv16hi3 */

        case 1:
          if (!
#line 22590 "../../../gcc/config/i386/sse.md"
(TARGET_SSSE3))
            return -1;
          return 7959; /* ssse3_phsubwv8hi3 */

        case 2:
          if (!
#line 22657 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 7966; /* avx2_phsubdv8si3 */

        case 3:
          if (!
#line 22678 "../../../gcc/config/i386/sse.md"
(TARGET_SSSE3))
            return -1;
          return 7968; /* ssse3_phsubdv4si3 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern180 (x3, 
SIGN_EXTEND))
        {
        case 0:
          if (!
#line 26430 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8391; /* xop_phsubbw */

        case 1:
          if (!
#line 26450 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8392; /* xop_phsubwd */

        case 2:
          if (!
#line 26468 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8393; /* xop_phsubdq */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_347 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XINT (x3, 1))
    {
    case 39:
      if (GET_MODE (x3) != E_CCGZmode)
        return -1;
      x4 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x4) != LTU
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 17
          || GET_MODE (x5) != E_CCmode)
        return -1;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern623 (x1, 
CLOBBER, 
E_CCGZmode) != 0)
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x8 = XVECEXP (x3, 0, 1);
      operands[2] = x8;
      if (!x86_64_general_operand (operands[2], E_SImode))
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 0);
      operands[0] = x10;
      if (!scratch_operand (operands[0], E_SImode))
        return -1;
      return 435; /* subsi3_carry_ccgz */

    case 52:
      if (GET_MODE (x3) != E_V8QImode)
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != CLOBBER)
        return -1;
      x11 = XEXP (x2, 0);
      operands[0] = x11;
      if (pattern859 (x1) != 0
          || !
#line 23150 "../../../gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSSE3))
        return -1;
      return 7996; /* *ssse3_pshufbv8qi3 */

    case 132:
      if (pattern488 (x1, 
132, 
3) != 0)
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      x8 = XVECEXP (x3, 0, 1);
      operands[2] = x8;
      if (!nonimmediate_operand (operands[2], E_V16QImode))
        return -1;
      x4 = XVECEXP (x3, 0, 2);
      operands[3] = x4;
      if (!const_0_to_255_operand (operands[3], E_SImode))
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      x12 = XEXP (x9, 1);
      x13 = XVECEXP (x12, 0, 0);
      if (!rtx_equal_p (x13, operands[1]))
        return -1;
      x14 = XVECEXP (x12, 0, 1);
      if (!rtx_equal_p (x14, operands[2]))
        return -1;
      x15 = XVECEXP (x12, 0, 2);
      if (!rtx_equal_p (x15, operands[3]))
        return -1;
      switch (pattern1631 (x3))
        {
        case 0:
          if (!
#line 26026 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_2))
            return -1;
          return 8348; /* sse4_2_pcmpistri */

        case 1:
          if (!
#line 26050 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_2))
            return -1;
          return 8349; /* sse4_2_pcmpistrm */

        default:
          return -1;
        }

    case 153:
      x4 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x4) != MEM)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 3
          || XINT (x5, 1) != 154)
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != CLOBBER)
        return -1;
      x11 = XEXP (x2, 0);
      operands[0] = x11;
      x16 = XVECEXP (x5, 0, 2);
      if (!const1248_operand (x16, E_SImode))
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[1] = x7;
          x8 = XVECEXP (x3, 0, 1);
          operands[7] = x8;
          operands[6] = x4;
          x17 = XVECEXP (x5, 0, 0);
          operands[4] = x17;
          x18 = XVECEXP (x5, 0, 1);
          operands[3] = x18;
          operands[5] = x16;
          x10 = XEXP (x9, 0);
          operands[2] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_V16SImode:
              if (!register_operand (operands[0], E_V16SImode)
                  || GET_MODE (x3) != E_V16SImode
                  || !vsib_mem_operator (operands[6], E_SImode))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V16SImode:
                  if (!register_operand (operands[1], E_V16SImode))
                    return -1;
                  switch (pattern1681 (x5, 
E_HImode, 
E_V16SImode))
                    {
                    case 0:
                      if (!(
#line 29467 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                        return -1;
                      return 9109; /* *avx512f_gathersiv16si */

                    case 1:
                      if (!(
#line 29467 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                        return -1;
                      return 9121; /* *avx512f_gathersiv16si */

                    default:
                      return -1;
                    }

                case E_V8SImode:
                  if (!register_operand (operands[1], E_V8SImode))
                    return -1;
                  switch (pattern1681 (x5, 
E_QImode, 
E_V8DImode))
                    {
                    case 0:
                      if (!(
#line 29529 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                        return -1;
                      return 9157; /* *avx512f_gatherdiv16si */

                    case 1:
                      if (!(
#line 29529 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                        return -1;
                      return 9169; /* *avx512f_gatherdiv16si */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case E_V16SFmode:
              if (!register_operand (operands[0], E_V16SFmode)
                  || GET_MODE (x3) != E_V16SFmode
                  || !vsib_mem_operator (operands[6], E_SFmode))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V16SFmode:
                  if (!register_operand (operands[1], E_V16SFmode))
                    return -1;
                  switch (pattern1681 (x5, 
E_HImode, 
E_V16SImode))
                    {
                    case 0:
                      if (!(
#line 29467 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                        return -1;
                      return 9110; /* *avx512f_gathersiv16sf */

                    case 1:
                      if (!(
#line 29467 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                        return -1;
                      return 9122; /* *avx512f_gathersiv16sf */

                    default:
                      return -1;
                    }

                case E_V8SFmode:
                  if (!register_operand (operands[1], E_V8SFmode))
                    return -1;
                  switch (pattern1681 (x5, 
E_QImode, 
E_V8DImode))
                    {
                    case 0:
                      if (!(
#line 29529 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                        return -1;
                      return 9158; /* *avx512f_gatherdiv16sf */

                    case 1:
                      if (!(
#line 29529 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                        return -1;
                      return 9170; /* *avx512f_gatherdiv16sf */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case E_V8DImode:
              switch (pattern1607 (x3, 
E_DImode, 
E_V8DImode))
                {
                case 0:
                  if (!(
#line 29467 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9111; /* *avx512f_gathersiv8di */

                case 1:
                  if (!(
#line 29529 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9159; /* *avx512f_gatherdiv8di */

                case 2:
                  if (!(
#line 29467 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9123; /* *avx512f_gathersiv8di */

                case 3:
                  if (!(
#line 29529 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9171; /* *avx512f_gatherdiv8di */

                default:
                  return -1;
                }

            case E_V8DFmode:
              switch (pattern1607 (x3, 
E_DFmode, 
E_V8DFmode))
                {
                case 0:
                  if (!(
#line 29467 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9112; /* *avx512f_gathersiv8df */

                case 1:
                  if (!(
#line 29529 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9160; /* *avx512f_gatherdiv8df */

                case 2:
                  if (!(
#line 29467 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9124; /* *avx512f_gathersiv8df */

                case 3:
                  if (!(
#line 29529 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9172; /* *avx512f_gatherdiv8df */

                default:
                  return -1;
                }

            case E_V8SImode:
              if (pattern1608 (x3, 
E_SImode, 
E_V8SImode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V8SImode:
                  if (!register_operand (operands[1], E_V8SImode))
                    return -1;
                  switch (pattern1693 (x5, 
E_V8SImode))
                    {
                    case 0:
                      if (!(
#line 29467 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                        return -1;
                      return 9113; /* *avx512f_gathersiv8si */

                    case 1:
                      if (!(
#line 29467 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                        return -1;
                      return 9125; /* *avx512f_gathersiv8si */

                    default:
                      return -1;
                    }

                case E_V4SImode:
                  if (!register_operand (operands[1], E_V4SImode))
                    return -1;
                  switch (pattern1693 (x5, 
E_V4DImode))
                    {
                    case 0:
                      if (!(
#line 29529 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                        return -1;
                      return 9161; /* *avx512f_gatherdiv8si */

                    case 1:
                      if (!(
#line 29529 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                        return -1;
                      return 9173; /* *avx512f_gatherdiv8si */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case E_V8SFmode:
              if (pattern1608 (x3, 
E_SFmode, 
E_V8SFmode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V8SFmode:
                  if (!register_operand (operands[1], E_V8SFmode))
                    return -1;
                  switch (pattern1693 (x5, 
E_V8SImode))
                    {
                    case 0:
                      if (!(
#line 29467 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                        return -1;
                      return 9114; /* *avx512f_gathersiv8sf */

                    case 1:
                      if (!(
#line 29467 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                        return -1;
                      return 9126; /* *avx512f_gathersiv8sf */

                    default:
                      return -1;
                    }

                case E_V4SFmode:
                  if (!register_operand (operands[1], E_V4SFmode))
                    return -1;
                  switch (pattern1693 (x5, 
E_V4DImode))
                    {
                    case 0:
                      if (!(
#line 29529 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                        return -1;
                      return 9162; /* *avx512f_gatherdiv8sf */

                    case 1:
                      if (!(
#line 29529 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                        return -1;
                      return 9174; /* *avx512f_gatherdiv8sf */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case E_V4DImode:
              switch (pattern1610 (x3, 
E_DImode, 
E_V4DImode))
                {
                case 0:
                  if (!(
#line 29467 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9115; /* *avx512f_gathersiv4di */

                case 1:
                  if (!(
#line 29529 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9163; /* *avx512f_gatherdiv4di */

                case 2:
                  if (!(
#line 29467 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9127; /* *avx512f_gathersiv4di */

                case 3:
                  if (!(
#line 29529 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9175; /* *avx512f_gatherdiv4di */

                default:
                  return -1;
                }

            case E_V4DFmode:
              switch (pattern1610 (x3, 
E_DFmode, 
E_V4DFmode))
                {
                case 0:
                  if (!(
#line 29467 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9116; /* *avx512f_gathersiv4df */

                case 1:
                  if (!(
#line 29529 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9164; /* *avx512f_gatherdiv4df */

                case 2:
                  if (!(
#line 29467 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9128; /* *avx512f_gathersiv4df */

                case 3:
                  if (!(
#line 29529 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9176; /* *avx512f_gatherdiv4df */

                default:
                  return -1;
                }

            case E_V4SImode:
              switch (pattern1612 (x3, 
E_SImode, 
E_V4SImode))
                {
                case 0:
                  if (!(
#line 29467 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9117; /* *avx512f_gathersiv4si */

                case 1:
                  if (!(
#line 29529 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9165; /* *avx512f_gatherdiv4si */

                case 2:
                  if (!(
#line 29467 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9129; /* *avx512f_gathersiv4si */

                case 3:
                  if (!(
#line 29529 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9177; /* *avx512f_gatherdiv4si */

                default:
                  return -1;
                }

            case E_V4SFmode:
              switch (pattern1612 (x3, 
E_SFmode, 
E_V4SFmode))
                {
                case 0:
                  if (!(
#line 29467 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9118; /* *avx512f_gathersiv4sf */

                case 1:
                  if (!(
#line 29529 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9166; /* *avx512f_gatherdiv4sf */

                case 2:
                  if (!(
#line 29467 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9130; /* *avx512f_gathersiv4sf */

                case 3:
                  if (!(
#line 29529 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9178; /* *avx512f_gatherdiv4sf */

                default:
                  return -1;
                }

            case E_V2DImode:
              switch (pattern1612 (x3, 
E_DImode, 
E_V2DImode))
                {
                case 0:
                  if (!(
#line 29467 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1015 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9119; /* *avx512f_gathersiv2di */

                case 1:
                  if (!(
#line 29529 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1015 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9167; /* *avx512f_gatherdiv2di */

                case 2:
                  if (!(
#line 29467 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1015 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9131; /* *avx512f_gathersiv2di */

                case 3:
                  if (!(
#line 29529 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1015 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9179; /* *avx512f_gatherdiv2di */

                default:
                  return -1;
                }

            case E_V2DFmode:
              switch (pattern1612 (x3, 
E_DFmode, 
E_V2DFmode))
                {
                case 0:
                  if (!(
#line 29467 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1015 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9120; /* *avx512f_gathersiv2df */

                case 1:
                  if (!(
#line 29529 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1015 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9168; /* *avx512f_gatherdiv2df */

                case 2:
                  if (!(
#line 29467 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1015 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9132; /* *avx512f_gathersiv2df */

                case 3:
                  if (!(
#line 29529 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1015 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9180; /* *avx512f_gatherdiv2df */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case PC:
          x8 = XVECEXP (x3, 0, 1);
          operands[6] = x8;
          operands[5] = x4;
          x17 = XVECEXP (x5, 0, 0);
          operands[3] = x17;
          x18 = XVECEXP (x5, 0, 1);
          operands[2] = x18;
          operands[4] = x16;
          x10 = XEXP (x9, 0);
          operands[1] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_V16SImode:
              switch (pattern1581 (x3, 
E_SImode, 
E_V16SImode))
                {
                case 0:
                  if (!(
#line 29488 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9133; /* *avx512f_gathersiv16si_2 */

                case 1:
                  if (!(
#line 29488 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9145; /* *avx512f_gathersiv16si_2 */

                case 2:
                  if (!(
#line 29550 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9181; /* *avx512f_gatherdiv16si_2 */

                case 3:
                  if (!(
#line 29550 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9193; /* *avx512f_gatherdiv16si_2 */

                default:
                  return -1;
                }

            case E_V16SFmode:
              switch (pattern1581 (x3, 
E_SFmode, 
E_V16SFmode))
                {
                case 0:
                  if (!(
#line 29488 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9134; /* *avx512f_gathersiv16sf_2 */

                case 1:
                  if (!(
#line 29488 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9146; /* *avx512f_gathersiv16sf_2 */

                case 2:
                  if (!(
#line 29550 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9182; /* *avx512f_gatherdiv16sf_2 */

                case 3:
                  if (!(
#line 29550 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9194; /* *avx512f_gatherdiv16sf_2 */

                default:
                  return -1;
                }

            case E_V8DImode:
              switch (pattern1583 (x3, 
E_DImode, 
E_V8DImode))
                {
                case 0:
                  if (!(
#line 29488 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9135; /* *avx512f_gathersiv8di_2 */

                case 1:
                  if (!(
#line 29550 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9183; /* *avx512f_gatherdiv8di_2 */

                case 2:
                  if (!(
#line 29488 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9147; /* *avx512f_gathersiv8di_2 */

                case 3:
                  if (!(
#line 29550 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9195; /* *avx512f_gatherdiv8di_2 */

                default:
                  return -1;
                }

            case E_V8DFmode:
              switch (pattern1583 (x3, 
E_DFmode, 
E_V8DFmode))
                {
                case 0:
                  if (!(
#line 29488 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9136; /* *avx512f_gathersiv8df_2 */

                case 1:
                  if (!(
#line 29550 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9184; /* *avx512f_gatherdiv8df_2 */

                case 2:
                  if (!(
#line 29488 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9148; /* *avx512f_gathersiv8df_2 */

                case 3:
                  if (!(
#line 29550 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9196; /* *avx512f_gatherdiv8df_2 */

                default:
                  return -1;
                }

            case E_V8SImode:
              switch (pattern1585 (x3, 
E_SImode, 
E_V8SImode))
                {
                case 0:
                  if (!(
#line 29488 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9137; /* *avx512f_gathersiv8si_2 */

                case 1:
                  if (!(
#line 29550 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9185; /* *avx512f_gatherdiv8si_2 */

                case 2:
                  if (!(
#line 29488 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9149; /* *avx512f_gathersiv8si_2 */

                case 3:
                  if (!(
#line 29550 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9197; /* *avx512f_gatherdiv8si_2 */

                default:
                  return -1;
                }

            case E_V8SFmode:
              switch (pattern1585 (x3, 
E_SFmode, 
E_V8SFmode))
                {
                case 0:
                  if (!(
#line 29488 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9138; /* *avx512f_gathersiv8sf_2 */

                case 1:
                  if (!(
#line 29550 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9186; /* *avx512f_gatherdiv8sf_2 */

                case 2:
                  if (!(
#line 29488 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9150; /* *avx512f_gathersiv8sf_2 */

                case 3:
                  if (!(
#line 29550 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9198; /* *avx512f_gatherdiv8sf_2 */

                default:
                  return -1;
                }

            case E_V4DImode:
              switch (pattern1587 (x3, 
E_DImode, 
E_V4DImode))
                {
                case 0:
                  if (!(
#line 29488 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9139; /* *avx512f_gathersiv4di_2 */

                case 1:
                  if (!(
#line 29550 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9187; /* *avx512f_gatherdiv4di_2 */

                case 2:
                  if (!(
#line 29488 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9151; /* *avx512f_gathersiv4di_2 */

                case 3:
                  if (!(
#line 29550 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9199; /* *avx512f_gatherdiv4di_2 */

                default:
                  return -1;
                }

            case E_V4DFmode:
              switch (pattern1587 (x3, 
E_DFmode, 
E_V4DFmode))
                {
                case 0:
                  if (!(
#line 29488 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9140; /* *avx512f_gathersiv4df_2 */

                case 1:
                  if (!(
#line 29550 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9188; /* *avx512f_gatherdiv4df_2 */

                case 2:
                  if (!(
#line 29488 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9152; /* *avx512f_gathersiv4df_2 */

                case 3:
                  if (!(
#line 29550 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9200; /* *avx512f_gatherdiv4df_2 */

                default:
                  return -1;
                }

            case E_V4SImode:
              switch (pattern1589 (x3, 
E_SImode, 
E_V4SImode))
                {
                case 0:
                  if (!(
#line 29488 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9141; /* *avx512f_gathersiv4si_2 */

                case 1:
                  if (!(
#line 29550 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9189; /* *avx512f_gatherdiv4si_2 */

                case 2:
                  if (!(
#line 29488 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9153; /* *avx512f_gathersiv4si_2 */

                case 3:
                  if (!(
#line 29550 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9201; /* *avx512f_gatherdiv4si_2 */

                default:
                  return -1;
                }

            case E_V4SFmode:
              switch (pattern1589 (x3, 
E_SFmode, 
E_V4SFmode))
                {
                case 0:
                  if (!(
#line 29488 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9142; /* *avx512f_gathersiv4sf_2 */

                case 1:
                  if (!(
#line 29550 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9190; /* *avx512f_gatherdiv4sf_2 */

                case 2:
                  if (!(
#line 29488 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9154; /* *avx512f_gathersiv4sf_2 */

                case 3:
                  if (!(
#line 29550 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9202; /* *avx512f_gatherdiv4sf_2 */

                default:
                  return -1;
                }

            case E_V2DImode:
              switch (pattern1589 (x3, 
E_DImode, 
E_V2DImode))
                {
                case 0:
                  if (!(
#line 29488 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1015 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9143; /* *avx512f_gathersiv2di_2 */

                case 1:
                  if (!(
#line 29550 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1015 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9191; /* *avx512f_gatherdiv2di_2 */

                case 2:
                  if (!(
#line 29488 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1015 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9155; /* *avx512f_gathersiv2di_2 */

                case 3:
                  if (!(
#line 29550 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1015 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9203; /* *avx512f_gatherdiv2di_2 */

                default:
                  return -1;
                }

            case E_V2DFmode:
              switch (pattern1589 (x3, 
E_DFmode, 
E_V2DFmode))
                {
                case 0:
                  if (!(
#line 29488 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1015 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9144; /* *avx512f_gathersiv2df_2 */

                case 1:
                  if (!(
#line 29550 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1015 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9192; /* *avx512f_gatherdiv2df_2 */

                case 2:
                  if (!(
#line 29488 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1015 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9156; /* *avx512f_gathersiv2df_2 */

                case 3:
                  if (!(
#line 29550 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1015 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9204; /* *avx512f_gatherdiv2df_2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_386 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  x7 = XEXP (x3, 1);
  operands[2] = x7;
  x8 = XVECEXP (x1, 0, 1);
  switch (pattern648 (x8))
    {
    case 0:
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!memory_operand (operands[1], E_SImode)
              || !(
#line 20401 "../../../gcc/config/i386/i386.md"
(!TARGET_X32 && !TARGET_INDIRECT_BRANCH_REGISTER) && 
#line 1403 "../../../gcc/config/i386/i386.md"
(word_mode == SImode)))
            return -1;
          return 1226; /* *sibcall_value_memory */

        case E_DImode:
          if (!memory_operand (operands[1], E_DImode)
              || !(
#line 20401 "../../../gcc/config/i386/i386.md"
(!TARGET_X32 && !TARGET_INDIRECT_BRANCH_REGISTER) && 
#line 1403 "../../../gcc/config/i386/i386.md"
(word_mode == DImode)))
            return -1;
          return 1227; /* *sibcall_value_memory */

        default:
          return -1;
        }

    case 1:
      x9 = XEXP (x8, 1);
      x10 = XEXP (x9, 1);
      operands[3] = x10;
      if (!immediate_operand (operands[3], E_SImode))
        return -1;
      if (call_insn_operand (operands[1], E_SImode)
          && 
#line 20460 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && !SIBLING_CALL_P (insn)))
        return 1228; /* *call_value_pop */
      if (!sibcall_insn_operand (operands[1], E_SImode)
          || !
#line 20471 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && SIBLING_CALL_P (insn)))
        return -1;
      return 1229; /* *sibcall_value_pop */

    default:
      return -1;
    }
}

 int
recog_389 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  switch (XVECLEN (x4, 0))
    {
    case 1:
      switch (XINT (x4, 1))
        {
        case 2:
          x5 = XVECEXP (x1, 0, 1);
          if (pattern297 (x5, 
E_CCmode, 
17) != 0)
            return -1;
          x6 = XVECEXP (x4, 0, 0);
          operands[1] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x4) != E_SImode
                  || !register_operand (operands[1], E_SImode)
                  || !(
#line 27075 "../../../gcc/config/i386/i386.md"
(ix86_target_stack_probe ()) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return -1;
              return 1501; /* allocate_stack_worker_probe_si */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x4) != E_DImode
                  || !register_operand (operands[1], E_DImode)
                  || !(
#line 27075 "../../../gcc/config/i386/i386.md"
(ix86_target_stack_probe ()) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return -1;
              return 1502; /* allocate_stack_worker_probe_di */

            default:
              return -1;
            }

        case 10:
          if (GET_MODE (x4) != E_DImode)
            return -1;
          x6 = XVECEXP (x4, 0, 0);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (pattern622 (x5, 
E_SImode, 
10, 
UNSPEC_VOLATILE) != 0
              || !register_operand (operands[0], E_DImode))
            return -1;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 1531; /* rdtscp */

        case 44:
          switch (pattern646 (x1, 
44))
            {
            case 0:
              if (!
#line 29362 "../../../gcc/config/i386/i386.md"
(TARGET_RDRND))
                return -1;
              return 1553; /* rdrandhi */

            case 1:
              if (!
#line 29362 "../../../gcc/config/i386/i386.md"
(TARGET_RDRND))
                return -1;
              return 1554; /* rdrandsi */

            default:
              return -1;
            }

        case 45:
          switch (pattern646 (x1, 
45))
            {
            case 0:
              if (!
#line 29372 "../../../gcc/config/i386/i386.md"
(TARGET_RDSEED))
                return -1;
              return 1555; /* rdseedhi */

            case 1:
              if (!
#line 29372 "../../../gcc/config/i386/i386.md"
(TARGET_RDSEED))
                return -1;
              return 1556; /* rdseedsi */

            default:
              return -1;
            }

        case 56:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != SET)
            return -1;
          x8 = XEXP (x5, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], E_SImode))
            return -1;
          x6 = XVECEXP (x4, 0, 0);
          operands[2] = x6;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 29615 "../../../gcc/config/i386/i386.md"
(TARGET_PKU))
            return -1;
          return 1578; /* *rdpkru */

        default:
          return -1;
        }

    case 2:
      switch (XINT (x4, 1))
        {
        case 3:
          x5 = XVECEXP (x1, 0, 1);
          if (pattern297 (x5, 
E_CCmode, 
17) != 0)
            return -1;
          x6 = XVECEXP (x4, 0, 0);
          operands[1] = x6;
          x9 = XVECEXP (x4, 0, 1);
          operands[2] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern1318 (x4, 
E_SImode) != 0
                  || !
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))
                return -1;
              return 1507; /* probe_stack_range_si */

            case E_DImode:
              if (pattern1318 (x4, 
E_DImode) != 0
                  || !
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))
                return -1;
              return 1508; /* probe_stack_range_di */

            default:
              return -1;
            }

        case 99:
          if (pattern647 (x1, 
99) != 0
              || !
#line 31348 "../../../gcc/config/i386/sse.md"
(TARGET_KL))
            return -1;
          return 9720; /* aesdec128klu8 */

        case 101:
          if (pattern647 (x1, 
101) != 0
              || !
#line 31348 "../../../gcc/config/i386/sse.md"
(TARGET_KL))
            return -1;
          return 9721; /* aesdec256klu8 */

        case 100:
          if (pattern647 (x1, 
100) != 0
              || !
#line 31348 "../../../gcc/config/i386/sse.md"
(TARGET_KL))
            return -1;
          return 9722; /* aesenc128klu8 */

        case 102:
          if (pattern647 (x1, 
102) != 0
              || !
#line 31348 "../../../gcc/config/i386/sse.md"
(TARGET_KL))
            return -1;
          return 9723; /* aesenc256klu8 */

        case 110:
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != SET)
            return -1;
          x6 = XVECEXP (x4, 0, 0);
          operands[1] = x6;
          x9 = XVECEXP (x4, 0, 1);
          operands[3] = x9;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          x7 = XEXP (x5, 0);
          if (!rtx_equal_p (x7, operands[1]))
            return -1;
          x8 = XEXP (x5, 1);
          switch (GET_CODE (x8))
            {
            case PLUS:
              if (pnum_clobbers == NULL)
                return -1;
              x10 = XEXP (x8, 1);
              operands[2] = x10;
              x11 = XEXP (x8, 0);
              if (!rtx_equal_p (x11, operands[1]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern1441 (x1, 
E_QImode) != 0
                      || !
#line 703 "../../../gcc/config/i386/sync.md"
(TARGET_XADD))
                    return -1;
                  *pnum_clobbers = 1;
                  return 10377; /* atomic_fetch_addqi */

                case E_HImode:
                  if (pattern1441 (x1, 
E_HImode) != 0
                      || !
#line 703 "../../../gcc/config/i386/sync.md"
(TARGET_XADD))
                    return -1;
                  *pnum_clobbers = 1;
                  return 10378; /* atomic_fetch_addhi */

                case E_SImode:
                  if (pattern1441 (x1, 
E_SImode) != 0
                      || !
#line 703 "../../../gcc/config/i386/sync.md"
(TARGET_XADD))
                    return -1;
                  *pnum_clobbers = 1;
                  return 10379; /* atomic_fetch_addsi */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[2] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern1373 (x4, 
E_QImode) != 0)
                    return -1;
                  return 10383; /* atomic_exchangeqi */

                case E_HImode:
                  if (pattern1373 (x4, 
E_HImode) != 0)
                    return -1;
                  return 10384; /* atomic_exchangehi */

                case E_SImode:
                  if (pattern1373 (x4, 
E_SImode) != 0)
                    return -1;
                  return 10385; /* atomic_exchangesi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 111:
          x5 = XVECEXP (x1, 0, 1);
          if (pattern297 (x5, 
E_CCmode, 
17) != 0)
            return -1;
          x9 = XVECEXP (x4, 0, 1);
          operands[2] = x9;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          x6 = XVECEXP (x4, 0, 0);
          switch (GET_CODE (x6))
            {
            case PLUS:
              switch (pattern1320 (x4))
                {
                case 0:
                  return 10390; /* atomic_addqi */

                case 1:
                  return 10391; /* atomic_addhi */

                case 2:
                  return 10392; /* atomic_addsi */

                default:
                  return -1;
                }

            case MINUS:
              switch (pattern1320 (x4))
                {
                case 0:
                  return 10393; /* atomic_subqi */

                case 1:
                  return 10394; /* atomic_subhi */

                case 2:
                  return 10395; /* atomic_subsi */

                default:
                  return -1;
                }

            case AND:
              switch (pattern1320 (x4))
                {
                case 0:
                  return 10396; /* atomic_andqi */

                case 1:
                  return 10399; /* atomic_andhi */

                case 2:
                  return 10402; /* atomic_andsi */

                default:
                  return -1;
                }

            case IOR:
              switch (pattern1320 (x4))
                {
                case 0:
                  return 10397; /* atomic_orqi */

                case 1:
                  return 10400; /* atomic_orhi */

                case 2:
                  return 10403; /* atomic_orsi */

                default:
                  return -1;
                }

            case XOR:
              switch (pattern1320 (x4))
                {
                case 0:
                  return 10398; /* atomic_xorqi */

                case 1:
                  return 10401; /* atomic_xorhi */

                case 2:
                  return 10404; /* atomic_xorsi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  switch (GET_CODE (operands[0]))
    {
    case MEM:
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (push_operand (operands[0], E_DImode))
            {
              if (general_gr_operand (operands[1], E_DImode)
                  && (
#line 2199 "../../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1195 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return gen_split_3 (insn, operands);
              if (sse_reg_operand (operands[1], E_DImode))
                {
                  if ((
#line 2269 "../../../gcc/config/i386/i386.md"
(TARGET_SSE && reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return gen_split_5 (insn, operands);
                  if ((
#line 2269 "../../../gcc/config/i386/i386.md"
(TARGET_SSE && reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return gen_split_7 (insn, operands);
                }
            }
          break;

        case E_SImode:
          if (push_operand (operands[0], E_SImode)
              && sse_reg_operand (operands[1], E_SImode))
            {
              if ((
#line 2269 "../../../gcc/config/i386/i386.md"
(TARGET_SSE && reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return gen_split_4 (insn, operands);
              if ((
#line 2269 "../../../gcc/config/i386/i386.md"
(TARGET_SSE && reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return gen_split_6 (insn, operands);
            }
          break;

        case E_TFmode:
          if (push_operand (operands[0], E_TFmode)
              && sse_reg_operand (operands[1], E_TFmode))
            {
              if ((
#line 3779 "../../../gcc/config/i386/i386.md"
(TARGET_SSE && reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return gen_split_15 (insn, operands);
              if ((
#line 3779 "../../../gcc/config/i386/i386.md"
(TARGET_SSE && reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return gen_split_16 (insn, operands);
            }
          break;

        case E_XFmode:
          if (push_operand (operands[0], E_XFmode)
              && fp_register_operand (operands[1], E_XFmode))
            {
              if ((
#line 3814 "../../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return gen_split_17 (insn, operands);
              if ((
#line 3814 "../../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return gen_split_18 (insn, operands);
            }
          break;

        case E_DFmode:
          if (push_operand (operands[0], E_DFmode)
              && any_fp_register_operand (operands[1], E_DFmode))
            {
              if ((
#line 3848 "../../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return gen_split_19 (insn, operands);
              if ((
#line 3848 "../../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return gen_split_20 (insn, operands);
            }
          break;

        case E_SFmode:
          if (push_operand (operands[0], E_SFmode))
            {
              if (any_fp_register_operand (operands[1], E_SFmode))
                {
                  if ((
#line 3979 "../../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return gen_split_21 (insn, operands);
                  if ((
#line 3979 "../../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return gen_split_24 (insn, operands);
                }
              if (memory_operand (operands[1], E_SFmode)
                  && 
#line 4002 "../../../gcc/config/i386/i386.md"
(reload_completed
   && find_constant_src (insn)))
                return gen_split_27 (insn, operands);
            }
          break;

        case E_HFmode:
          if (push_operand (operands[0], E_HFmode)
              && any_fp_register_operand (operands[1], E_HFmode))
            {
              if ((
#line 3979 "../../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return gen_split_22 (insn, operands);
              if ((
#line 3979 "../../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return gen_split_25 (insn, operands);
            }
          break;

        case E_BFmode:
          if (push_operand (operands[0], E_BFmode)
              && any_fp_register_operand (operands[1], E_BFmode))
            {
              if ((
#line 3979 "../../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return gen_split_23 (insn, operands);
              if ((
#line 3979 "../../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return gen_split_26 (insn, operands);
            }
          break;

        default:
          break;
        }
      break;

    case REG:
      if (general_reg_operand (operands[0], E_DImode)
          && sse_reg_operand (operands[1], E_DImode)
          && (
#line 2755 "../../../gcc/config/i386/i386.md"
(TARGET_SSE4_1
   && reload_completed) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return gen_split_8 (insn, operands);
      break;

    default:
      break;
    }
  if (nonimmediate_gr_operand (operands[0], E_DImode)
      && general_gr_operand (operands[1], E_DImode)
      && (
#line 2772 "../../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1195 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
    return gen_split_9 (insn, operands);
  if (sse_reg_operand (operands[0], E_DImode)
      && general_reg_operand (operands[1], E_DImode)
      && 
#line 2779 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_SSE4_1
   && reload_completed))
    return gen_split_10 (insn, operands);
  if (push_operand (operands[0], E_VOIDmode)
      && general_gr_operand (operands[1], E_VOIDmode)
      && 
#line 4010 "../../../gcc/config/i386/i386.md"
(reload_completed
   && (GET_MODE (operands[0]) == TFmode
       || GET_MODE (operands[0]) == XFmode
       || GET_MODE (operands[0]) == DFmode)))
    return gen_split_28 (insn, operands);
  switch (GET_MODE (operands[0]))
    {
    case E_TFmode:
      if (nonimmediate_gr_operand (operands[0], E_TFmode)
          && general_gr_operand (operands[1], E_TFmode)
          && 
#line 4083 "../../../gcc/config/i386/i386.md"
(reload_completed))
        return gen_split_29 (insn, operands);
      break;

    case E_XFmode:
      if (nonimmediate_gr_operand (operands[0], E_XFmode)
          && general_gr_operand (operands[1], E_XFmode)
          && 
#line 4156 "../../../gcc/config/i386/i386.md"
(reload_completed))
        return gen_split_30 (insn, operands);
      break;

    case E_DFmode:
      if (nonimmediate_gr_operand (operands[0], E_DFmode)
          && general_gr_operand (operands[1], E_DFmode)
          && 
#line 4334 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && reload_completed))
        return gen_split_31 (insn, operands);
      break;

    default:
      break;
    }
  if (any_fp_register_operand (operands[0], E_VOIDmode)
      && memory_operand (operands[1], E_VOIDmode)
      && 
#line 4602 "../../../gcc/config/i386/i386.md"
(reload_completed
   && (GET_MODE (operands[0]) == TFmode
       || GET_MODE (operands[0]) == XFmode
       || GET_MODE (operands[0]) == DFmode
       || GET_MODE (operands[0]) == SFmode)
   && ix86_standard_x87sse_constant_load_p (insn, operands[0])))
    return gen_split_32 (insn, operands);
  if (fp_register_operand (operands[0], E_SFmode)
      && immediate_operand (operands[1], E_SFmode)
      && 
#line 4626 "../../../gcc/config/i386/i386.md"
(reload_completed
   && (standard_80387_constant_p (operands[1]) == 8
       || standard_80387_constant_p (operands[1]) == 9)))
    return gen_split_34 (insn, operands);
  if (fp_register_operand (operands[0], E_DFmode)
      && immediate_operand (operands[1], E_DFmode)
      && 
#line 4626 "../../../gcc/config/i386/i386.md"
(reload_completed
   && (standard_80387_constant_p (operands[1]) == 8
       || standard_80387_constant_p (operands[1]) == 9)))
    return gen_split_35 (insn, operands);
  if (!fp_register_operand (operands[0], E_XFmode)
      || !immediate_operand (operands[1], E_XFmode)
      || !
#line 4626 "../../../gcc/config/i386/i386.md"
(reload_completed
   && (standard_80387_constant_p (operands[1]) == 8
       || standard_80387_constant_p (operands[1]) == 9)))
    return NULL;
  return gen_split_36 (insn, operands);
}

 rtx_insn *
split_9 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_CODE (operands[1]))
    {
    case CONST_INT:
      switch (pattern537 (x3))
        {
        case 0:
          if (!
#line 18186 "../../../gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (GET_MODE_BITSIZE (QImode) - 1))
   == GET_MODE_BITSIZE (QImode) - 1))
            return NULL;
          return gen_split_562 (insn, operands);

        case 1:
          if (!
#line 18186 "../../../gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (GET_MODE_BITSIZE (HImode) - 1))
   == GET_MODE_BITSIZE (HImode) - 1))
            return NULL;
          return gen_split_564 (insn, operands);

        case 2:
          if (!
#line 18186 "../../../gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode) - 1))
   == GET_MODE_BITSIZE (SImode) - 1))
            return NULL;
          return gen_split_566 (insn, operands);

        case 3:
          if (!(
#line 18186 "../../../gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode) - 1))
   == GET_MODE_BITSIZE (DImode) - 1) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_568 (insn, operands);

        case 4:
          if (!
#line 18259 "../../../gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_594 (insn, operands);

        case 5:
          if (!
#line 18259 "../../../gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_596 (insn, operands);

        case 6:
          if (!
#line 18259 "../../../gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_598 (insn, operands);

        case 7:
          if (!
#line 18328 "../../../gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_622 (insn, operands);

        case 8:
          if (!
#line 18328 "../../../gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_624 (insn, operands);

        case 9:
          if (!
#line 18328 "../../../gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_626 (insn, operands);

        case 10:
          if (!
#line 18221 "../../../gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (GET_MODE_BITSIZE (QImode) - 1))
  == GET_MODE_BITSIZE (QImode) - 1))
            return NULL;
          return gen_split_578 (insn, operands);

        case 11:
          if (!
#line 18221 "../../../gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (GET_MODE_BITSIZE (HImode) - 1))
  == GET_MODE_BITSIZE (HImode) - 1))
            return NULL;
          return gen_split_580 (insn, operands);

        case 12:
          if (!
#line 18221 "../../../gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode) - 1))
  == GET_MODE_BITSIZE (SImode) - 1))
            return NULL;
          return gen_split_582 (insn, operands);

        case 13:
          if (!(
#line 18221 "../../../gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode) - 1))
  == GET_MODE_BITSIZE (DImode) - 1) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_584 (insn, operands);

        case 14:
          if (!
#line 18291 "../../../gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_608 (insn, operands);

        case 15:
          if (!
#line 18291 "../../../gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_610 (insn, operands);

        case 16:
          if (!
#line 18291 "../../../gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_612 (insn, operands);

        case 17:
          if (!
#line 18360 "../../../gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_636 (insn, operands);

        case 18:
          if (!
#line 18360 "../../../gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_638 (insn, operands);

        case 19:
          if (!
#line 18360 "../../../gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_640 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
    case MEM:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != CONST_INT)
        return NULL;
      if (XWINT (x5, 0) == 32LL
          && register_operand (operands[0], E_DImode)
          && GET_MODE (x3) == E_DImode
          && register_operand (operands[1], E_DImode)
          && (
#line 18447 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT) && 
#line 18449 "../../../gcc/config/i386/i386.md"
( reload_completed)))
        return gen_split_644 (insn, operands);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_QImode))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !nonimmediate_operand (operands[1], E_SImode)
              || !
#line 18556 "../../../gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed && !optimize_function_for_size_p (cfun)
   && !TARGET_APX_NDD))
            return NULL;
          return gen_split_648 (insn, operands);

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !nonimmediate_operand (operands[1], E_DImode)
              || !(
#line 18556 "../../../gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed && !optimize_function_for_size_p (cfun)
   && !TARGET_APX_NDD) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_649 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_14 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return NULL;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return NULL;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  switch (GET_CODE (x5))
    {
    case SIGN_EXTRACT:
      if (GET_MODE (x5) != E_SImode)
        return NULL;
      x7 = XEXP (x5, 2);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x8 = XEXP (x4, 0);
      operands[0] = x8;
      if (!register_operand (operands[0], E_SImode)
          || !register_operand (operands[1], E_SImode))
        return NULL;
      return gen_split_11 (insn, operands);

    case ZERO_EXTRACT:
      x8 = XEXP (x4, 0);
      if (GET_CODE (x8) == SUBREG)
        {
          switch (pattern1218 (x4))
            {
            case 0:
              if ((
#line 19344 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 19346 "../../../gcc/config/i386/i386.md"
( 1)))
                return gen_split_698 (insn, operands);
              break;

            case 1:
              if (((
#line 19344 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 19346 "../../../gcc/config/i386/i386.md"
( 1)))
                return gen_split_699 (insn, operands);
              break;

            default:
              break;
            }
        }
      x7 = XEXP (x5, 2);
      if (GET_CODE (x7) != SUBREG)
        return NULL;
      switch (pattern1220 (x4))
        {
        case 0:
          if (!(
#line 19425 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()) && 
#line 19430 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_706 (insn, operands);

        case 1:
          if (!((
#line 19425 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 19430 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_707 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_15 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (pattern1072 (x2))
    {
    case 0:
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          x3 = XEXP (x2, 1);
          if (GET_MODE (x3) != E_DImode)
            return NULL;
          if (nonimmediate_operand (operands[0], E_DImode)
              && nonimmediate_operand (operands[1], E_DImode)
              && x86_64_hilo_general_operand (operands[2], E_DImode)
              && ((
#line 6465 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 6467 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return gen_split_77 (insn, operands);
          if (!register_operand (operands[0], E_DImode)
              || !register_operand (operands[1], E_DImode)
              || !x86_64_nonmemory_operand (operands[2], E_DImode))
            return NULL;
          if ((
#line 7053 "../../../gcc/config/i386/i386.md"
(reload_completed && ix86_avoid_lea_for_add (insn, operands)) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return gen_split_96 (insn, operands);
          if (!(
#line 7079 "../../../gcc/config/i386/i386.md"
(reload_completed && ix86_lea_for_add_ok (insn, operands)) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_100 (insn, operands);

        case E_TImode:
          x3 = XEXP (x2, 1);
          if (pattern513 (x3, 
E_TImode) != 0
              || !((
#line 6465 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 6467 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_78 (insn, operands);

        case E_SImode:
          x3 = XEXP (x2, 1);
          if (pattern1374 (x3, 
E_SImode) != 0)
            return NULL;
          if (
#line 7053 "../../../gcc/config/i386/i386.md"
(reload_completed && ix86_avoid_lea_for_add (insn, operands)))
            return gen_split_95 (insn, operands);
          if (!
#line 7079 "../../../gcc/config/i386/i386.md"
(reload_completed && ix86_lea_for_add_ok (insn, operands)))
            return NULL;
          return gen_split_99 (insn, operands);

        case E_QImode:
          x3 = XEXP (x2, 1);
          if (pattern1375 (x3, 
E_QImode) != 0
              || !
#line 7079 "../../../gcc/config/i386/i386.md"
(reload_completed && ix86_lea_for_add_ok (insn, operands)))
            return NULL;
          return gen_split_97 (insn, operands);

        case E_HImode:
          x3 = XEXP (x2, 1);
          if (pattern1375 (x3, 
E_HImode) != 0
              || !
#line 7079 "../../../gcc/config/i386/i386.md"
(reload_completed && ix86_lea_for_add_ok (insn, operands)))
            return NULL;
          return gen_split_98 (insn, operands);

        default:
          return NULL;
        }

    case 1:
      if (!(
#line 6946 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 6969 "../../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| rtx_equal_p (operands[0], operands[2])))))
        return NULL;
      return gen_split_87 (insn, operands);

    case 2:
      if (!(
#line 6946 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 6969 "../../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| rtx_equal_p (operands[0], operands[2])))))
        return NULL;
      return gen_split_88 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_21 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (pattern297 (x2, 
E_CCmode, 
17) != 0)
    return NULL;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      switch (pattern190 (x3))
        {
        case 0:
          x6 = XEXP (x3, 0);
          operands[0] = x6;
          x7 = XEXP (x4, 1);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              if (GET_CODE (x7) == SUBREG)
                {
                  switch (pattern1230 (x4))
                    {
                    case 0:
                      if (((
#line 15203 "../../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (4 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 4 * BITS_PER_UNIT - 1))
	 == (2 * 4 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 15208 "../../../gcc/config/i386/i386.md"
( 1)))
                        return gen_split_457 (insn, operands);
                      break;

                    case 1:
                      if (((
#line 15203 "../../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (8 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 8 * BITS_PER_UNIT - 1))
	 == (2 * 8 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 15208 "../../../gcc/config/i386/i386.md"
( 1)))
                        return gen_split_458 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              operands[2] = x7;
              if (register_operand (operands[2], E_QImode)
                  && register_operand (operands[0], E_SImode)
                  && GET_MODE (x4) == E_SImode
                  && nonimmediate_operand (operands[1], E_SImode)
                  && 
#line 15998 "../../../gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed))
                return gen_split_469 (insn, operands);
              if (GET_CODE (x7) == SUBREG
                  && known_eq (SUBREG_BYTE (x7), 0)
                  && GET_MODE (x7) == E_QImode)
                {
                  switch (pattern1148 (x4, 
E_SImode))
                    {
                    case 0:
                      if ((
#line 17860 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1))
      == 4 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 17865 "../../../gcc/config/i386/i386.md"
( 1)))
                        return gen_split_515 (insn, operands);
                      break;

                    case 1:
                      if ((
#line 17908 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 17912 "../../../gcc/config/i386/i386.md"
( 1)))
                        return gen_split_527 (insn, operands);
                      break;

                    case 2:
                      if ((
#line 17954 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 17958 "../../../gcc/config/i386/i386.md"
( 1)))
                        return gen_split_539 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              break;

            case CONST_INT:
              operands[2] = x7;
              if (const_0_to_3_operand (operands[2], E_VOIDmode))
                {
                  switch (GET_MODE (operands[0]))
                    {
                    case E_QImode:
                      if (general_reg_operand (operands[0], E_QImode)
                          && GET_MODE (x4) == E_QImode
                          && index_reg_operand (operands[1], E_QImode)
                          && 
#line 16293 "../../../gcc/config/i386/i386.md"
(reload_completed
   && REGNO (operands[0]) != REGNO (operands[1])))
                        return gen_split_472 (insn, operands);
                      break;

                    case E_HImode:
                      if (general_reg_operand (operands[0], E_HImode)
                          && GET_MODE (x4) == E_HImode
                          && index_reg_operand (operands[1], E_HImode)
                          && 
#line 16293 "../../../gcc/config/i386/i386.md"
(reload_completed
   && REGNO (operands[0]) != REGNO (operands[1])))
                        return gen_split_473 (insn, operands);
                      break;

                    case E_SImode:
                      if (general_reg_operand (operands[0], E_SImode)
                          && GET_MODE (x4) == E_SImode
                          && index_reg_operand (operands[1], E_SImode)
                          && 
#line 16293 "../../../gcc/config/i386/i386.md"
(reload_completed
   && REGNO (operands[0]) != REGNO (operands[1])))
                        return gen_split_474 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              break;

            default:
              break;
            }
          operands[2] = x7;
          switch (GET_CODE (x6))
            {
            case REG:
            case SUBREG:
              operands[0] = x6;
              if (GET_MODE (x4) == E_DImode)
                {
                  if (register_operand (operands[0], E_DImode)
                      && nonmemory_operand (operands[1], E_DImode)
                      && nonmemory_operand (operands[2], E_QImode)
                      && (
#line 15323 "../../../gcc/config/i386/i386.md"
(epilogue_completed) && 
#line 1195 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                    return gen_split_461 (insn, operands);
                  if (general_reg_operand (operands[0], E_DImode)
                      && index_reg_operand (operands[1], E_DImode)
                      && const_0_to_3_operand (operands[2], E_VOIDmode)
                      && (
#line 16293 "../../../gcc/config/i386/i386.md"
(reload_completed
   && REGNO (operands[0]) != REGNO (operands[1])) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return gen_split_475 (insn, operands);
                }
              break;

            case STRICT_LOW_PART:
              switch (pattern1231 (x3))
                {
                case 0:
                  if ((
#line 16243 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 16262 "../../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
                    return gen_split_470 (insn, operands);
                  break;

                case 1:
                  if ((
#line 16243 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 16262 "../../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
                    return gen_split_471 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
          if (GET_CODE (x7) != SUBREG)
            return NULL;
          switch (pattern1149 (x3))
            {
            case 0:
              if (!((
#line 17860 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1))
      == 8 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 17865 "../../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_518 (insn, operands);

            case 1:
              if (!((
#line 17908 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 17912 "../../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_530 (insn, operands);

            case 2:
              if (!((
#line 17954 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 17958 "../../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_542 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          if (register_operand (operands[0], E_DImode)
              && register_operand (operands[1], E_DImode)
              && ((
#line 15264 "../../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (4 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 4 * BITS_PER_UNIT - 1))
	 == (2 * 4 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 15269 "../../../gcc/config/i386/i386.md"
( 1)))
            return gen_split_459 (insn, operands);
          if (!nonimmediate_operand (operands[0], E_DImode)
              || !nonimmediate_operand (operands[1], E_DImode)
              || !((
#line 17885 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1))
      == 8 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 17890 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_524 (insn, operands);

        case 2:
          if (!((
#line 15264 "../../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (8 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 8 * BITS_PER_UNIT - 1))
	 == (2 * 8 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 15269 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_460 (insn, operands);

        case 3:
          if (!(
#line 17885 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1))
      == 4 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 17890 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_521 (insn, operands);

        case 4:
          if (!(
#line 17932 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 17936 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_533 (insn, operands);

        case 5:
          if (!((
#line 17932 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 17936 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_536 (insn, operands);

        case 6:
          if (!(
#line 17984 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 17988 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_545 (insn, operands);

        case 7:
          if (!((
#line 17984 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 17988 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_548 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x5) != E_DImode
          || pattern324 (x3) != 0
          || !((
#line 15365 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) >= 4 * BITS_PER_UNIT
   && INTVAL (operands[2]) < 4 * BITS_PER_UNIT * 2) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 15368 "../../../gcc/config/i386/i386.md"
( reload_completed)))
        return NULL;
      return gen_split_462 (insn, operands);

    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_DImode
          || pattern324 (x3) != 0
          || !((
#line 15365 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) >= 4 * BITS_PER_UNIT
   && INTVAL (operands[2]) < 4 * BITS_PER_UNIT * 2) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 15368 "../../../gcc/config/i386/i386.md"
( reload_completed)))
        return NULL;
      return gen_split_463 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_28 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern343 (x1))
    {
    case 0:
      if (!(
#line 18202 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, QImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (QImode)-1))
      == GET_MODE_BITSIZE (QImode)-1
   && ix86_pre_reload_split ()) && 
#line 18207 "../../../gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_570 (insn, operands);

    case 1:
      if (!(
#line 18202 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, HImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (HImode)-1))
      == GET_MODE_BITSIZE (HImode)-1
   && ix86_pre_reload_split ()) && 
#line 18207 "../../../gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_572 (insn, operands);

    case 2:
      if (!(
#line 18202 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()) && 
#line 18207 "../../../gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_574 (insn, operands);

    case 3:
      if (!((
#line 18202 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 18207 "../../../gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_576 (insn, operands);

    case 4:
      if (!(
#line 18273 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, QImode, operands)
   && (INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18277 "../../../gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_600 (insn, operands);

    case 5:
      if (!(
#line 18273 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, HImode, operands)
   && (INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18277 "../../../gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_602 (insn, operands);

    case 6:
      if (!(
#line 18273 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18277 "../../../gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_604 (insn, operands);

    case 7:
      if (!((
#line 18273 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 18277 "../../../gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_606 (insn, operands);

    case 8:
      if (!(
#line 18342 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, QImode, operands)
   && (INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18346 "../../../gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_628 (insn, operands);

    case 9:
      if (!(
#line 18342 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, HImode, operands)
   && (INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18346 "../../../gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_630 (insn, operands);

    case 10:
      if (!(
#line 18342 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18346 "../../../gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_632 (insn, operands);

    case 11:
      if (!((
#line 18342 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 18346 "../../../gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_634 (insn, operands);

    case 12:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 1);
      switch (pattern1075 (x4))
        {
        case 0:
          if ((
#line 18162 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, QImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (QImode)-1))
      == GET_MODE_BITSIZE (QImode)-1
   && ix86_pre_reload_split ()) && 
#line 18167 "../../../gcc/config/i386/i386.md"
( 1)))
            return gen_split_554 (insn, operands);
          break;

        case 1:
          if ((
#line 18162 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, HImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (HImode)-1))
      == GET_MODE_BITSIZE (HImode)-1
   && ix86_pre_reload_split ()) && 
#line 18167 "../../../gcc/config/i386/i386.md"
( 1)))
            return gen_split_556 (insn, operands);
          break;

        case 2:
          if ((
#line 18162 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()) && 
#line 18167 "../../../gcc/config/i386/i386.md"
( 1)))
            return gen_split_558 (insn, operands);
          break;

        case 3:
          if (((
#line 18162 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 18167 "../../../gcc/config/i386/i386.md"
( 1)))
            return gen_split_560 (insn, operands);
          break;

        case 4:
          if ((
#line 18237 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, QImode, operands)
   && (INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18241 "../../../gcc/config/i386/i386.md"
( 1)))
            return gen_split_586 (insn, operands);
          break;

        case 5:
          if ((
#line 18237 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, HImode, operands)
   && (INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18241 "../../../gcc/config/i386/i386.md"
( 1)))
            return gen_split_588 (insn, operands);
          break;

        case 6:
          if ((
#line 18237 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18241 "../../../gcc/config/i386/i386.md"
( 1)))
            return gen_split_590 (insn, operands);
          break;

        case 7:
          if (((
#line 18237 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 18241 "../../../gcc/config/i386/i386.md"
( 1)))
            return gen_split_592 (insn, operands);
          break;

        case 8:
          if ((
#line 18306 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, QImode, operands)
   && (INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18310 "../../../gcc/config/i386/i386.md"
( 1)))
            return gen_split_614 (insn, operands);
          break;

        case 9:
          if ((
#line 18306 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, HImode, operands)
   && (INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18310 "../../../gcc/config/i386/i386.md"
( 1)))
            return gen_split_616 (insn, operands);
          break;

        case 10:
          if ((
#line 18306 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18310 "../../../gcc/config/i386/i386.md"
( 1)))
            return gen_split_618 (insn, operands);
          break;

        case 11:
          if (((
#line 18306 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 18310 "../../../gcc/config/i386/i386.md"
( 1)))
            return gen_split_620 (insn, operands);
          break;

        case 12:
          x5 = XEXP (x4, 1);
          operands[2] = x5;
          if (const_int_operand (operands[2], E_QImode))
            {
              switch (pattern966 (x4))
                {
                case 0:
                  if (
#line 18543 "../../../gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed && !optimize_function_for_size_p (cfun)))
                    return gen_split_646 (insn, operands);
                  break;

                case 1:
                  if ((
#line 18543 "../../../gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed && !optimize_function_for_size_p (cfun)) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return gen_split_647 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          if (XWINT (x5, 0) == 8LL
              && QIreg_operand (operands[0], E_HImode)
              && GET_MODE (x4) == E_HImode)
            {
              x6 = XEXP (x4, 0);
              if (rtx_equal_p (x6, operands[0])
                  && 
#line 18743 "../../../gcc/config/i386/i386.md"
(reload_completed
  && (TARGET_USE_XCHGB || optimize_function_for_size_p (cfun))))
                return gen_split_656 (insn, operands);
            }
          break;

        default:
          break;
        }
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      switch (pattern1076 (x2))
        {
        case 0:
          if (!(
#line 18710 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 18721 "../../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_652 (insn, operands);

        case 1:
          if (!(
#line 18710 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 18721 "../../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_654 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_40 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (nonimmediate_gr_operand (operands[0], E_V8QImode)
          && nonimmediate_gr_operand (operands[1], E_V8QImode)
          && 
#line 310 "../../../gcc/config/i386/mmx.md"
(!TARGET_64BIT && reload_completed))
        return gen_split_813 (insn, operands);
      break;

    case E_V4HImode:
      if (nonimmediate_gr_operand (operands[0], E_V4HImode)
          && nonimmediate_gr_operand (operands[1], E_V4HImode)
          && 
#line 310 "../../../gcc/config/i386/mmx.md"
(!TARGET_64BIT && reload_completed))
        return gen_split_814 (insn, operands);
      break;

    case E_V2SImode:
      if (nonimmediate_gr_operand (operands[0], E_V2SImode)
          && nonimmediate_gr_operand (operands[1], E_V2SImode)
          && 
#line 310 "../../../gcc/config/i386/mmx.md"
(!TARGET_64BIT && reload_completed))
        return gen_split_815 (insn, operands);
      break;

    case E_V1DImode:
      if (nonimmediate_gr_operand (operands[0], E_V1DImode)
          && nonimmediate_gr_operand (operands[1], E_V1DImode)
          && 
#line 310 "../../../gcc/config/i386/mmx.md"
(!TARGET_64BIT && reload_completed))
        return gen_split_816 (insn, operands);
      break;

    case E_V2SFmode:
      if (nonimmediate_gr_operand (operands[0], E_V2SFmode)
          && nonimmediate_gr_operand (operands[1], E_V2SFmode)
          && 
#line 310 "../../../gcc/config/i386/mmx.md"
(!TARGET_64BIT && reload_completed))
        return gen_split_817 (insn, operands);
      break;

    case E_V4HFmode:
      if (nonimmediate_gr_operand (operands[0], E_V4HFmode)
          && nonimmediate_gr_operand (operands[1], E_V4HFmode)
          && 
#line 310 "../../../gcc/config/i386/mmx.md"
(!TARGET_64BIT && reload_completed))
        return gen_split_818 (insn, operands);
      break;

    case E_V4BFmode:
      if (nonimmediate_gr_operand (operands[0], E_V4BFmode)
          && nonimmediate_gr_operand (operands[1], E_V4BFmode)
          && 
#line 310 "../../../gcc/config/i386/mmx.md"
(!TARGET_64BIT && reload_completed))
        return gen_split_819 (insn, operands);
      break;

    case E_V2QImode:
      if (push_operand (operands[0], E_V2QImode)
          && sse_reg_operand (operands[1], E_V2QImode))
        {
          if ((
#line 614 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
            return gen_split_831 (insn, operands);
          if ((
#line 614 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
            return gen_split_832 (insn, operands);
        }
      break;

    case E_P2QImode:
      if (nonimmediate_operand (operands[0], E_P2QImode)
          && nonimmediate_operand (operands[1], E_P2QImode)
          && (
#line 30945 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VP2INTERSECT
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 30948 "../../../gcc/config/i386/sse.md"
( reload_completed)))
        return gen_split_3538 (insn, operands);
      break;

    case E_P2HImode:
      if (nonimmediate_operand (operands[0], E_P2HImode)
          && nonimmediate_operand (operands[1], E_P2HImode)
          && (
#line 30945 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VP2INTERSECT
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 30948 "../../../gcc/config/i386/sse.md"
( reload_completed)))
        return gen_split_3539 (insn, operands);
      break;

    default:
      break;
    }
  if (GET_CODE (x2) != SUBREG)
    return NULL;
  operands[0] = x3;
  switch (SUBREG_BYTE (x2))
    {
    case 8:
      if (GET_MODE (x2) != E_DFmode
          || !register_operand (operands[0], E_DFmode))
        return NULL;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2DFmode)
          || !
#line 14639 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
        return NULL;
      return gen_split_2944 (insn, operands);

    case 0:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || GET_MODE (x2) != E_DFmode
                  || !register_operand (operands[1], E_V2DFmode)
                  || !
#line 14692 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
                return NULL;
              return gen_split_2946 (insn, operands);

            case E_SImode:
              if (!nonimmediate_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !register_operand (operands[1], E_VOIDmode)
                  || !
#line 21449 "../../../gcc/config/i386/sse.md"
(can_create_pseudo_p ()
   && REG_P (operands[1])
   && VECTOR_MODE_P (GET_MODE (operands[1]))
   && ((TARGET_SSE && GET_MODE_SIZE (GET_MODE (operands[1])) == 16)
       || (TARGET_AVX && GET_MODE_SIZE (GET_MODE (operands[1])) == 32)
       || (TARGET_AVX512F && TARGET_EVEX512
	   && GET_MODE_SIZE (GET_MODE (operands[1])) == 64))
   && (SImode == SImode || TARGET_64BIT || MEM_P (operands[0]))))
                return NULL;
              return gen_split_3166 (insn, operands);

            case E_DImode:
              if (!nonimmediate_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !register_operand (operands[1], E_VOIDmode)
                  || !
#line 21449 "../../../gcc/config/i386/sse.md"
(can_create_pseudo_p ()
   && REG_P (operands[1])
   && VECTOR_MODE_P (GET_MODE (operands[1]))
   && ((TARGET_SSE && GET_MODE_SIZE (GET_MODE (operands[1])) == 16)
       || (TARGET_AVX && GET_MODE_SIZE (GET_MODE (operands[1])) == 32)
       || (TARGET_AVX512F && TARGET_EVEX512
	   && GET_MODE_SIZE (GET_MODE (operands[1])) == 64))
   && (DImode == SImode || TARGET_64BIT || MEM_P (operands[0]))))
                return NULL;
              return gen_split_3167 (insn, operands);

            default:
              return NULL;
            }

        case SS_TRUNCATE:
          switch (pattern667 (x2))
            {
            case 0:
              if (!(
#line 15412 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15414 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2958 (insn, operands);

            case 1:
              if (!(
#line 15507 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15509 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2961 (insn, operands);

            case 2:
              if (!(
#line 15507 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15509 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2964 (insn, operands);

            case 3:
              if (!(
#line 15858 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15860 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2980 (insn, operands);

            case 4:
              if (!((
#line 15605 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15587 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)) && 
#line 15607 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2967 (insn, operands);

            case 5:
              if (!(
#line 15605 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15607 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2970 (insn, operands);

            case 6:
              if (!(
#line 16121 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512 && ix86_pre_reload_split ()) && 
#line 16123 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2987 (insn, operands);

            case 7:
              if (!(
#line 15767 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15769 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2974 (insn, operands);

            case 8:
              if (!(
#line 15767 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15769 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2977 (insn, operands);

            case 9:
              if (!(
#line 16008 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 16010 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2984 (insn, operands);

            default:
              return NULL;
            }

        case TRUNCATE:
          switch (pattern667 (x2))
            {
            case 0:
              if (!(
#line 15412 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15414 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2959 (insn, operands);

            case 1:
              if (!(
#line 15507 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15509 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2962 (insn, operands);

            case 2:
              if (!(
#line 15507 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15509 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2965 (insn, operands);

            case 3:
              if (!(
#line 15858 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15860 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2981 (insn, operands);

            case 4:
              if (!((
#line 15605 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15587 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)) && 
#line 15607 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2968 (insn, operands);

            case 5:
              if (!(
#line 15605 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15607 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2971 (insn, operands);

            case 6:
              if (!(
#line 16121 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512 && ix86_pre_reload_split ()) && 
#line 16123 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2988 (insn, operands);

            case 7:
              if (!(
#line 15767 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15769 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2975 (insn, operands);

            case 8:
              if (!(
#line 15767 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15769 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2978 (insn, operands);

            case 9:
              if (!(
#line 16008 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 16010 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2985 (insn, operands);

            default:
              return NULL;
            }

        case US_TRUNCATE:
          switch (pattern667 (x2))
            {
            case 0:
              if (!(
#line 15412 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15414 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2960 (insn, operands);

            case 1:
              if (!(
#line 15507 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15509 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2963 (insn, operands);

            case 2:
              if (!(
#line 15507 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15509 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2966 (insn, operands);

            case 3:
              if (!(
#line 15858 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15860 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2982 (insn, operands);

            case 4:
              if (!((
#line 15605 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15587 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)) && 
#line 15607 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2969 (insn, operands);

            case 5:
              if (!(
#line 15605 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15607 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2972 (insn, operands);

            case 6:
              if (!(
#line 16121 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512 && ix86_pre_reload_split ()) && 
#line 16123 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2989 (insn, operands);

            case 7:
              if (!(
#line 15767 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15769 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2976 (insn, operands);

            case 8:
              if (!(
#line 15767 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15769 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2979 (insn, operands);

            case 9:
              if (!(
#line 16008 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 16010 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2986 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_52 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x5 = XVECEXP (x3, 0, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return NULL;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DFmode:
      if (!nonimmediate_operand (operands[0], E_V2DFmode)
          || GET_MODE (x2) != E_V2DFmode)
        return NULL;
      switch (GET_MODE (operands[1]))
        {
        case E_V8DFmode:
          if (!register_operand (operands[1], E_V8DFmode)
              || !(
#line 12471 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ
   && reload_completed
   && (TARGET_AVX512VL
       || REG_P (operands[0])
       || !EXT_REX_SSE_REG_P (operands[1]))) && 
#line 718 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return NULL;
          return gen_split_1331 (insn, operands);

        case E_V4DFmode:
          if (!nonimmediate_operand (operands[1], E_V4DFmode)
              || !
#line 12889 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))
   && reload_completed))
            return NULL;
          return gen_split_1340 (insn, operands);

        default:
          return NULL;
        }

    case E_V2DImode:
      if (!nonimmediate_operand (operands[0], E_V2DImode)
          || GET_MODE (x2) != E_V2DImode)
        return NULL;
      switch (GET_MODE (operands[1]))
        {
        case E_V8DImode:
          if (!register_operand (operands[1], E_V8DImode)
              || !(
#line 12471 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ
   && reload_completed
   && (TARGET_AVX512VL
       || REG_P (operands[0])
       || !EXT_REX_SSE_REG_P (operands[1]))) && 
#line 718 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return NULL;
          return gen_split_1332 (insn, operands);

        case E_V4DImode:
          if (!nonimmediate_operand (operands[1], E_V4DImode)
              || !
#line 12889 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))
   && reload_completed))
            return NULL;
          return gen_split_1339 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_54 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (pattern770 (x3) != 0)
    return NULL;
  x4 = XVECEXP (x3, 0, 4);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return NULL;
  x5 = XVECEXP (x3, 0, 5);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return NULL;
  x6 = XVECEXP (x3, 0, 6);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return NULL;
  x7 = XVECEXP (x3, 0, 7);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return NULL;
  switch (pattern1400 (x2))
    {
    case 0:
      if (!(
#line 12841 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))
   && reload_completed
   && (TARGET_AVX512VL
       || REG_P (operands[0])
       || !EXT_REX_SSE_REG_P (operands[1]))) && 
#line 722 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return NULL;
      return gen_split_1337 (insn, operands);

    case 1:
      if (!(
#line 12841 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))
   && reload_completed
   && (TARGET_AVX512VL
       || REG_P (operands[0])
       || !EXT_REX_SSE_REG_P (operands[1]))) && 
#line 722 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return NULL;
      return gen_split_1338 (insn, operands);

    case 2:
      if (!(
#line 13081 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 13083 "../../../gcc/config/i386/sse.md"
( reload_completed)))
        return NULL;
      return gen_split_1346 (insn, operands);

    case 3:
      if (!(
#line 13081 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 13083 "../../../gcc/config/i386/sse.md"
( reload_completed)))
        return NULL;
      return gen_split_1347 (insn, operands);

    case 4:
      if (!(
#line 13081 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 13083 "../../../gcc/config/i386/sse.md"
( reload_completed)))
        return NULL;
      return gen_split_1348 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_56 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case NOT:
      switch (pattern472 (x2))
        {
        case 0:
          if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1449 (insn, operands);

        case 1:
          if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1476 (insn, operands);

        case 2:
          if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1503 (insn, operands);

        case 3:
          if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1530 (insn, operands);

        case 4:
          if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1557 (insn, operands);

        case 5:
          if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1584 (insn, operands);

        case 6:
          if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1611 (insn, operands);

        case 7:
          if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1638 (insn, operands);

        case 8:
          if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1665 (insn, operands);

        case 9:
          if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1692 (insn, operands);

        case 10:
          if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1719 (insn, operands);

        case 11:
          if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1746 (insn, operands);

        case 12:
          if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1452 (insn, operands);

        case 13:
          if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1479 (insn, operands);

        case 14:
          if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1506 (insn, operands);

        case 15:
          if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1533 (insn, operands);

        case 16:
          if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1560 (insn, operands);

        case 17:
          if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1587 (insn, operands);

        case 18:
          if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1614 (insn, operands);

        case 19:
          if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1641 (insn, operands);

        case 20:
          if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1668 (insn, operands);

        case 21:
          if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1695 (insn, operands);

        case 22:
          if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1722 (insn, operands);

        case 23:
          if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1749 (insn, operands);

        case 24:
          if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1455 (insn, operands);

        case 25:
          if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1482 (insn, operands);

        case 26:
          if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1509 (insn, operands);

        case 27:
          if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1536 (insn, operands);

        case 28:
          if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1563 (insn, operands);

        case 29:
          if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1590 (insn, operands);

        case 30:
          if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1617 (insn, operands);

        case 31:
          if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1644 (insn, operands);

        case 32:
          if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1671 (insn, operands);

        case 33:
          if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1698 (insn, operands);

        case 34:
          if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1725 (insn, operands);

        case 35:
          if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1752 (insn, operands);

        case 36:
          if (!((
#line 13946 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13950 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2733 (insn, operands);

        case 37:
          if (!((
#line 13946 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13950 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2742 (insn, operands);

        case 38:
          if (!(
#line 13946 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13950 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2751 (insn, operands);

        case 39:
          if (!((
#line 13946 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13950 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2760 (insn, operands);

        case 40:
          if (!((
#line 13946 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13950 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2769 (insn, operands);

        case 41:
          if (!(
#line 13946 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13950 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2778 (insn, operands);

        case 42:
          if (!((
#line 13946 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13950 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2787 (insn, operands);

        case 43:
          if (!((
#line 13946 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13950 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2796 (insn, operands);

        case 44:
          if (!(
#line 13946 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13950 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2805 (insn, operands);

        case 45:
          if (!((
#line 13946 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13950 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2814 (insn, operands);

        case 46:
          if (!((
#line 13946 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13950 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2823 (insn, operands);

        case 47:
          if (!(
#line 13946 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13950 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2832 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      switch (pattern474 (x2))
        {
        case 0:
          if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2097 (insn, operands);

        case 1:
          if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2124 (insn, operands);

        case 2:
          if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2151 (insn, operands);

        case 3:
          if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2178 (insn, operands);

        case 4:
          if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2205 (insn, operands);

        case 5:
          if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2232 (insn, operands);

        case 6:
          if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2259 (insn, operands);

        case 7:
          if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2286 (insn, operands);

        case 8:
          if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2313 (insn, operands);

        case 9:
          if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2340 (insn, operands);

        case 10:
          if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2367 (insn, operands);

        case 11:
          if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2394 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      switch (pattern474 (x2))
        {
        case 0:
          if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2100 (insn, operands);

        case 1:
          if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2127 (insn, operands);

        case 2:
          if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2154 (insn, operands);

        case 3:
          if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2181 (insn, operands);

        case 4:
          if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2208 (insn, operands);

        case 5:
          if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2235 (insn, operands);

        case 6:
          if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2262 (insn, operands);

        case 7:
          if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2289 (insn, operands);

        case 8:
          if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2316 (insn, operands);

        case 9:
          if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2343 (insn, operands);

        case 10:
          if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2370 (insn, operands);

        case 11:
          if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2397 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      switch (pattern474 (x2))
        {
        case 0:
          if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2103 (insn, operands);

        case 1:
          if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2130 (insn, operands);

        case 2:
          if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2157 (insn, operands);

        case 3:
          if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2184 (insn, operands);

        case 4:
          if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2211 (insn, operands);

        case 5:
          if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2238 (insn, operands);

        case 6:
          if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2265 (insn, operands);

        case 7:
          if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2292 (insn, operands);

        case 8:
          if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2319 (insn, operands);

        case 9:
          if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2346 (insn, operands);

        case 10:
          if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2373 (insn, operands);

        case 11:
          if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2400 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_66 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case AND:
      return split_64 (x1, insn);

    case IOR:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
        case NOT:
          switch (pattern476 (x2))
            {
            case 0:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1766 (insn, operands);

            case 1:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1793 (insn, operands);

            case 2:
              if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1820 (insn, operands);

            case 3:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1847 (insn, operands);

            case 4:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1874 (insn, operands);

            case 5:
              if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1901 (insn, operands);

            case 6:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1928 (insn, operands);

            case 7:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1955 (insn, operands);

            case 8:
              if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1982 (insn, operands);

            case 9:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2009 (insn, operands);

            case 10:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2036 (insn, operands);

            case 11:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2063 (insn, operands);

            case 12:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1769 (insn, operands);

            case 13:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1796 (insn, operands);

            case 14:
              if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1823 (insn, operands);

            case 15:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1850 (insn, operands);

            case 16:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1877 (insn, operands);

            case 17:
              if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1904 (insn, operands);

            case 18:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1931 (insn, operands);

            case 19:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1958 (insn, operands);

            case 20:
              if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1985 (insn, operands);

            case 21:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2012 (insn, operands);

            case 22:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2039 (insn, operands);

            case 23:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2066 (insn, operands);

            case 24:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1772 (insn, operands);

            case 25:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1799 (insn, operands);

            case 26:
              if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1826 (insn, operands);

            case 27:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1853 (insn, operands);

            case 28:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1880 (insn, operands);

            case 29:
              if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1907 (insn, operands);

            case 30:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1934 (insn, operands);

            case 31:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1961 (insn, operands);

            case 32:
              if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1988 (insn, operands);

            case 33:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2015 (insn, operands);

            case 34:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2042 (insn, operands);

            case 35:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2069 (insn, operands);

            case 36:
              if (!((
#line 13946 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13950 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2840 (insn, operands);

            case 37:
              if (!((
#line 13946 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13950 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2849 (insn, operands);

            case 38:
              if (!(
#line 13946 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13950 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2858 (insn, operands);

            case 39:
              if (!((
#line 13946 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13950 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2867 (insn, operands);

            case 40:
              if (!((
#line 13946 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13950 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2876 (insn, operands);

            case 41:
              if (!(
#line 13946 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13950 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2885 (insn, operands);

            case 42:
              if (!((
#line 13946 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13950 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2894 (insn, operands);

            case 43:
              if (!((
#line 13946 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13950 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2903 (insn, operands);

            case 44:
              if (!(
#line 13946 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13950 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2912 (insn, operands);

            case 45:
              if (!((
#line 13946 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13950 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2921 (insn, operands);

            case 46:
              if (!((
#line 13946 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13950 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2930 (insn, operands);

            case 47:
              if (!((
#line 13946 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13950 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2939 (insn, operands);

            default:
              return NULL;
            }

        case AND:
          switch (pattern477 (x2))
            {
            case 0:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2414 (insn, operands);

            case 1:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2441 (insn, operands);

            case 2:
              if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2468 (insn, operands);

            case 3:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2495 (insn, operands);

            case 4:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2522 (insn, operands);

            case 5:
              if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2549 (insn, operands);

            case 6:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2576 (insn, operands);

            case 7:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2603 (insn, operands);

            case 8:
              if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2630 (insn, operands);

            case 9:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2657 (insn, operands);

            case 10:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2684 (insn, operands);

            case 11:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2711 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          switch (pattern477 (x2))
            {
            case 0:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2417 (insn, operands);

            case 1:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2444 (insn, operands);

            case 2:
              if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2471 (insn, operands);

            case 3:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2498 (insn, operands);

            case 4:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2525 (insn, operands);

            case 5:
              if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2552 (insn, operands);

            case 6:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2579 (insn, operands);

            case 7:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2606 (insn, operands);

            case 8:
              if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2633 (insn, operands);

            case 9:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2660 (insn, operands);

            case 10:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2687 (insn, operands);

            case 11:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2714 (insn, operands);

            default:
              return NULL;
            }

        case XOR:
          switch (pattern477 (x2))
            {
            case 0:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2420 (insn, operands);

            case 1:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2447 (insn, operands);

            case 2:
              if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2474 (insn, operands);

            case 3:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2501 (insn, operands);

            case 4:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2528 (insn, operands);

            case 5:
              if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2555 (insn, operands);

            case 6:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2582 (insn, operands);

            case 7:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2609 (insn, operands);

            case 8:
              if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2636 (insn, operands);

            case 9:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2663 (insn, operands);

            case 10:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2690 (insn, operands);

            case 11:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2717 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case XOR:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
        case NOT:
          switch (pattern476 (x2))
            {
            case 0:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1775 (insn, operands);

            case 1:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1802 (insn, operands);

            case 2:
              if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1829 (insn, operands);

            case 3:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1856 (insn, operands);

            case 4:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1883 (insn, operands);

            case 5:
              if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1910 (insn, operands);

            case 6:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1937 (insn, operands);

            case 7:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1964 (insn, operands);

            case 8:
              if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1991 (insn, operands);

            case 9:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2018 (insn, operands);

            case 10:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2045 (insn, operands);

            case 11:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2072 (insn, operands);

            case 12:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1778 (insn, operands);

            case 13:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1805 (insn, operands);

            case 14:
              if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1832 (insn, operands);

            case 15:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1859 (insn, operands);

            case 16:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1886 (insn, operands);

            case 17:
              if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1913 (insn, operands);

            case 18:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1940 (insn, operands);

            case 19:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1967 (insn, operands);

            case 20:
              if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1994 (insn, operands);

            case 21:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2021 (insn, operands);

            case 22:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2048 (insn, operands);

            case 23:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2075 (insn, operands);

            case 24:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1781 (insn, operands);

            case 25:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1808 (insn, operands);

            case 26:
              if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1835 (insn, operands);

            case 27:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1862 (insn, operands);

            case 28:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1889 (insn, operands);

            case 29:
              if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1916 (insn, operands);

            case 30:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1943 (insn, operands);

            case 31:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1970 (insn, operands);

            case 32:
              if (!(
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1997 (insn, operands);

            case 33:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2024 (insn, operands);

            case 34:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2051 (insn, operands);

            case 35:
              if (!((
#line 13777 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13789 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2078 (insn, operands);

            case 36:
              if (!((
#line 13946 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13950 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2843 (insn, operands);

            case 37:
              if (!((
#line 13946 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13950 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2852 (insn, operands);

            case 38:
              if (!(
#line 13946 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13950 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2861 (insn, operands);

            case 39:
              if (!((
#line 13946 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13950 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2870 (insn, operands);

            case 40:
              if (!((
#line 13946 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13950 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2879 (insn, operands);

            case 41:
              if (!(
#line 13946 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13950 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2888 (insn, operands);

            case 42:
              if (!((
#line 13946 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13950 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2897 (insn, operands);

            case 43:
              if (!((
#line 13946 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13950 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2906 (insn, operands);

            case 44:
              if (!(
#line 13946 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13950 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2915 (insn, operands);

            case 45:
              if (!((
#line 13946 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13950 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2924 (insn, operands);

            case 46:
              if (!((
#line 13946 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13950 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2933 (insn, operands);

            case 47:
              if (!((
#line 13946 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13950 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2942 (insn, operands);

            default:
              return NULL;
            }

        case AND:
          switch (pattern477 (x2))
            {
            case 0:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2423 (insn, operands);

            case 1:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2450 (insn, operands);

            case 2:
              if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2477 (insn, operands);

            case 3:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2504 (insn, operands);

            case 4:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2531 (insn, operands);

            case 5:
              if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2558 (insn, operands);

            case 6:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2585 (insn, operands);

            case 7:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2612 (insn, operands);

            case 8:
              if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2639 (insn, operands);

            case 9:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2666 (insn, operands);

            case 10:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2693 (insn, operands);

            case 11:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2720 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          switch (pattern477 (x2))
            {
            case 0:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2426 (insn, operands);

            case 1:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2453 (insn, operands);

            case 2:
              if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2480 (insn, operands);

            case 3:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2507 (insn, operands);

            case 4:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2534 (insn, operands);

            case 5:
              if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2561 (insn, operands);

            case 6:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2588 (insn, operands);

            case 7:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2615 (insn, operands);

            case 8:
              if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2642 (insn, operands);

            case 9:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2669 (insn, operands);

            case 10:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2696 (insn, operands);

            case 11:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2723 (insn, operands);

            default:
              return NULL;
            }

        case XOR:
          switch (pattern477 (x2))
            {
            case 0:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2429 (insn, operands);

            case 1:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2456 (insn, operands);

            case 2:
              if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2483 (insn, operands);

            case 3:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2510 (insn, operands);

            case 4:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2537 (insn, operands);

            case 5:
              if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2564 (insn, operands);

            case 6:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2591 (insn, operands);

            case 7:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2618 (insn, operands);

            case 8:
              if (!(
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2645 (insn, operands);

            case 9:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2672 (insn, operands);

            case 10:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2699 (insn, operands);

            case 11:
              if (!((
#line 13862 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 339 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13874 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2726 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
